#include "globals.h"
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>


/* CRACK STUFF */
int arg_index = 0;
char *arg_option;
char *pvcon = NULL;
char *index();



/************************************************************/

int main(argc,argv)
   int argc;
   char *argv[]; 
   {
   


    char	*filename, 
		ch, 
		crack()
    ;

    float norm=0.,  octpch,  Hz,  temp1,  temp2,  log_two, reference ; 
    int n = 0 ; 
    

#include "underflow.h"

 
/*GIVE USAGE AND EXIT IF NO ARGUMENTS */
   if(argc == 1) {
	fprintf( stderr,"%s",
	"USAGE:\n\n   Hztopitch frequency value(s)\n\n" 
	"   This routine prints out the octave.pitch class value(s)\n"
	"    for the specified frequencies.\n\n"
	 );
	exit(0);
    }

#ifdef __sgi
	log_two=flog10(2.) ;  
#else
	log_two = (float) log10(2.) ;  
#endif
	reference = 220. * (pow(2.,3./12.)) ;  

    arg_index++ ; 
    fprintf( stdout, "\n\n" ) ; 


    while(arg_index < argc){ 
  
      /* GET FREQUENCY VALUE */
       Hz = atof(argv[arg_index]) ;

	// TRANSFORM 
#ifdef __sgi
	temp2   = 8. + ( flog10( Hz / reference ) / log_two  ) ; 
#else
	temp2   = 8. + (float) ( log10( (double) (Hz / reference) ) / log_two  ) ; 
#endif
	temp1 = (float) ( (int) temp2 ) ; 
	octpch = temp1 + ( .12 * (temp2 - temp1) ) ; //OCT.PCLASS

       
       fprintf( stdout, "\nFREQUENCY:\t%-6.2f Hz\tOCT.PCH:\t%-f",  Hz,  octpch ) ; 

	arg_index++ ; 
    }

    fprintf( stdout, "\n\n" ) ; 
    exit( 1 ) ; 
}


char crack(argc, argv, flags, ign)
    int argc; char **argv; char *flags; int ign;
{
    char *pv, *flgp, *index();
    while ((arg_index) < argc)
	{
	if (pvcon != NULL)
	    pv = pvcon;
	else
	    {
	    if (++arg_index >= argc) return(0); 
	    pv = argv[arg_index];
	    if (*pv != '-') 
		return(0);
	    }
	pv++;		/* skip '-' or prev. flag */
	if (*pv != 0) 
	    {
	    if ((flgp=index(flags, *pv)) != NULL)
		{
		pvcon = pv;
		if (*(flgp+1) == '|') { arg_option = pv+1; pvcon = NULL; }
		return(*pv);
		}
	    else
		if (!ign)
		    {
		    fprintf(stderr, "\n\n%s: no such flag: %s\n", argv[0], pv);
		    return(EOF);
		    }
		else
		    pvcon = NULL;
	    }
	pvcon = NULL;
	}
    return(0);
    }

