#include "globals.h"

#define NUM_PARAMETERS 12

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k, l,  i1,  i2, ipartial,  bug=0, tone_now, *band_begin,  
     mm, numbands,  n,  NC, NCmult2, NCdiv2,   np,  nf=2,  first=1,  *binpt, *tone ;
float *binpt_iflag,  fc,  ac,  fcnow,  acnow,  dBc,  minusnullprop,  *tonesums, 
	    bandampsum, newbandampsum,   *oldbandampsum,  bandpeakamp,  *tune_factor, 
	    *null_phase_factor  ;
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag=0,   channelout=0,  part_count,  numpasspartials, 
    rejected_part_count,  current_rejected_part ;
float P = 1.0;
FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel, *previous_harmony, *F,   *harmony, *ampfreq, 
	*targetfreq, *sourcefreq, 
	*coswindow,    pmt,  pms  ; 
float threshfac = .001,  threshfacdB=-96 ;
float	gain=1.,  newfreq ;
float  temp,  temp2,  temp3,  temp4,  temp5,  temp6,  temp7,  temp8 ;  
float getthresh();
float   IR,  dur=0.;
float lowpartfreq,  shiftedpartfreq,  octroll ; 

float releasec,  minusreleasec,  attackc,  minusattackc ; 
float asum,  fsum ;
int bcount,  b1 ; 

float tgateamp ; 

float dBrolloff ;
int beginchan,  endchan ; 
int sourceflag=1 ; 
int method_flag=0 ; 

float coscurve( float v ) ; 
float coscurve_dB( float v ) ; 

FILE *data ; 
char datafile[ 128 ] = "EMPTY\0",  new_datafile[ 128 ] ; 
float *PP, *domainamp, *partialamp,    fundamental,  target_gain,  SOURCE_gain,  midC,  part ; 
int shift_method=0, source_method=0,   nd=0 ; 
float bw ; 
char tempstring[ 128 ] ; 

// GAIN
struct  func  dBgain ; 

// SOURCE  FREQUENCY SHIFT ADDER
struct  func  SOURCE_harmadd ; 

// SOURCE  PITCH TRANSPOSITION IN SEMITONES
struct  func  SOURCE_ptrans ; 

// SOURCE DECIBELS
struct  func  SOURCE_dB ; 

// SPECTRUM WARPSHAPE INDEX
struct  func  warpshape ; 


// TARGET DECIBELS
struct  func  target_dB ; 

// TARGET  FREQUENCY SHIFT ADDER
struct  func  target_harmadd ; 

// TARGET  PITCH TRANSPOSITION IN SEMITONES
struct  func  target_ptrans ; 


// AMP INTERPOLATION CONTROL
struct  func  amp_control ; 

// FREQ INTERPOLATION CONTROL
struct  func  freq_control ; 


// NULL PHASE PROPORTION CONTROL
struct  func  nullprop ; 

// PARTIAL TUNING CONTROL
struct  func  tuneprop ; 

// PARTIAL TUNING CONTROL BASE
struct  func  tunebase ; 

// TONE AMP EXPANSION THRESHOLD
struct  func  tgatethresh ; 

// TONE  EXPANSION INDEX
struct  func  expandex ; 

//  RELEASE
struct  func  release ; 

//  ATTACK
struct  func  attack ; 

//SHELF EQ
struct  func  dBlow;
struct  func  dBhi;
struct  func  freqlow;
struct  func  freqhi ;

#include "underflow.h"

//*****************INITIALIZE
// SOURCE  FREQUENCY SHIFT ADDER
SOURCE_harmadd.L = 1. ; SOURCE_harmadd.n = 1. ; SOURCE_harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// SOURCE  PITCH TRANSPOSITION IN SEMITONES
SOURCE_ptrans.L = 1. ; SOURCE_ptrans.n = 1. ; SOURCE_ptrans.A[ 0 ] = 1. ; 

// TARGET DECIBELS
target_dB.L = 1. ; target_dB.n = 1. ; target_dB.A[ 0 ] = 0. ; 

// SOURCE DECIBELS
SOURCE_dB.L = 1. ; SOURCE_dB.n = 1. ; SOURCE_dB.A[ 0 ] = 0. ; 

// TARGET  PITCH TRANSPOSITION IN SEMITONES
target_ptrans.L = 1. ; target_ptrans.n = 1. ; target_ptrans.A[ 0 ] = 1. ; 

// TARGET  FREQUENCY SHIFT ADDER
target_harmadd.L = 1. ; target_harmadd.n = 1. ; target_harmadd.A[ 0 ] = 0. ; 

// AMP INTERPOLATION CONTROL
amp_control.L = 1. ; amp_control.n = 1. ; amp_control.A[ 0 ] = 1. ; 

// FREQ INTERPOLATION CONTROL
freq_control.L = 1. ; freq_control.n = 1. ; freq_control.A[ 0 ] = 1. ; 

// SPECTRUM WARPSHAPE INDEX
warpshape.L = 1. ; warpshape.n = 1. ; warpshape.A[ 0 ] = 0. ; 

// NULL PHASE PROPORTION CONTROL
nullprop.L = 1. ; nullprop.n = 1. ; nullprop.A[ 0 ] = 0. ; 

// PARTIAL TUNING CONTROL
tuneprop.L = 1. ; tuneprop.n = 1. ; tuneprop.A[ 0 ] = 0. ; 

// PARTIAL TUNING CONTROL BASE
tunebase.L = 1. ; tunebase.n = 1. ; tunebase.A[ 0 ] = 0. ; 


// TONE AMP EXPANSION THRESHOLD
tgatethresh.L = 1. ; tgatethresh.n = 1. ; tgatethresh.A[ 0 ] = 0. ; 

// TONE  EXPANSION INDEX
expandex.L = 1. ; expandex.n = 1. ; expandex.A[ 0 ] = 3. ; 



//  RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 

//  ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 

// SHELF EQ
dBlow.L = 1. ; dBlow.n = 1. ; dBlow.A[ 0 ] = 0. ; 
dBhi.L = 1. ; dBhi.n = 1. ; dBhi.A[ 0 ] = 0. ; 
freqlow.L = 1. ; freqlow.n = 1. ; freqlow.A[ 0 ] = 200. ; 
freqhi.L = 1. ; freqhi.n = 1. ; freqhi.A[ 0 ] = 2000. ; 




if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|l|L|W|E|M|K|H|J|P|w|S|T|U|V|D|t|B|I|c|d|b|e|_|Q|=|C|p|i|B|F|f|T|u|b|v|G|V|K|k|l|L|Z|V|S|H|m|q|X|W|c|d|s|a|A|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'w':   window_type = atoi(arg_option) ;
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

            case 'p':	quiet = atoi(arg_option) ; 
			break;
            case 'i':	ampstatinc = atof(arg_option) ; 
			break;

           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;



// SOURCE
	    case 'a':   strcpy(tempstring, arg_option);
			SOURCE_harmadd.fp = crackstring( tempstring, 
			    &SOURCE_harmadd );
			break;
	    case 'P':   strcpy(tempstring, arg_option);
			SOURCE_ptrans.fp = crackstring( tempstring, &SOURCE_ptrans ); 
			break;
	    case 'G':   strcpy(tempstring, arg_option);
			SOURCE_dB.fp = crackstring( tempstring, 
			    &SOURCE_dB );
			break;

// TARGETS

	    case 'q':   strcpy(tempstring, arg_option);
			target_harmadd.fp = crackstring( tempstring, 
			    &target_harmadd );
			break;
	    case 'X':   strcpy(tempstring, arg_option);
			target_ptrans.fp = crackstring( tempstring, 
			    &target_ptrans );
			break;
	    case 'm':   strcpy(tempstring, arg_option);
			target_dB.fp = crackstring( tempstring, 
			    &target_dB );
			break;


	    case 'c':   strcpy(tempstring, arg_option);
			amp_control.fp = crackstring( tempstring, 
			    &amp_control );
			break;

	    case 'd':   strcpy(tempstring, arg_option);
			freq_control.fp = crackstring( tempstring, 
			    &freq_control );
			break;


	    case 'W':   strcpy(tempstring, arg_option);
			warpshape.fp = crackstring( tempstring, 
			    &warpshape );
			break;

	    case 'K':   strcpy(tempstring, arg_option);
			tuneprop.fp = crackstring( tempstring, 
			    &tuneprop );
			break;

	    case 'J':   strcpy(tempstring, arg_option);
			tunebase.fp = crackstring( tempstring, 
			    &tunebase );
			break;

	    case 'B':   strcpy(tempstring, arg_option);
			nullprop.fp = crackstring( tempstring, 
			    &nullprop );
			break;



	    case 'E':   strcpy(tempstring, arg_option);
			tgatethresh.fp = crackstring( tempstring, 
			    &tgatethresh );
			break;


	    case 'H':   strcpy(tempstring, arg_option);
			expandex.fp = crackstring( tempstring, 
			    &expandex );
			break;



	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;
	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;

// EQ

	    case 'S':   strcpy(tempstring, arg_option);
			dBlow.fp = crackstring( tempstring, &dBlow );
			break;
	    case 'T':   strcpy(tempstring, arg_option);
			dBhi.fp = crackstring( tempstring, &dBhi );
			break;
	    case 'U':   strcpy(tempstring, arg_option);
			freqlow.fp = crackstring( tempstring, &freqlow );
			break;
	    case 'V':   strcpy(tempstring, arg_option);
			freqhi.fp = crackstring( tempstring, &freqhi );
			break;





	    case 'Z':   shift_method = atoi(arg_option) ;
			break;
	    case 'Q':   source_method = atoi(arg_option) ;
			break;

	    case 'F':   strcpy(datafile, arg_option);
			break;

	    case 't':   threshfacdB = atof(arg_option);
			break;
	    case 's':	sflag = 1;
			break;
	    case 'h':	usage(1);
	}
    }


prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "CHORDMAPPER", 69 ) ; 
prline( 69,  "-" ) ; 

    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
 
// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 
    
// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 

    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
//*********************************
    
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    obank = P != 0. ;
    if( P == 0.0 ) {P = 1.0;}
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    midC = (220.*pow(2., (3./12.))) ; 
    fundamental = (float) R / (float) N ; 
    IR = (float) I / (float) R ; 

    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 

//***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 

prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
pri( tfactor,  "TIME EXPANSION/CONTRACTION FACTOR" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( I,  "      INTERPOLATION SAMPLES (samples between resynthesis frames)" ) ; 
prline( 1,  "*" ) ; 
prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (in dB)" ) ; 
prline( 1,  "*" ) ; 
prp( &dBgain,  "MASTER GAIN (in dB)"  ) ; 
prline( 1,  "*" ) ; 
prp( &target_dB,	"TARGETS: GAIN (in dB)"  ) ; 
prp( &target_ptrans,  "TARGETS: PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &target_harmadd,  "TARGETS: FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &SOURCE_dB,	"SOURCE: GAIN (in dB)"  ) ; 
prp( &SOURCE_ptrans,  "SOURCE: PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &SOURCE_harmadd,  "SOURCE: FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &attack,  "ENVELOPE ATTACK TIME (in seconds)"  ) ; 
prp( &release,  "ENVELOPE RELEASE TIME (in seconds)"  ) ; 
prline( 1,  "*" ) ; 
prp( &warpshape, "SPECTRUM WARPSHAPE INDEX" ) ; 
prline( 1,  "*" ) ; 
prp( &amp_control, "0-1 AMPLITUDE INTERPOLATION CONTROL" ) ; 
prp( &freq_control, "0-1 FREQUENCY INTERPOLATION CONTROL" ) ; 
prp( &nullprop, "0-1 NULL PHASE INTERPOLATION CONTROL" ) ; 
prline( 1,  "*" ) ; 
prp( &tuneprop, "0-1 PARTIAL TUNING CONTROL" ) ; 
prp( &tunebase, "PARTIAL TUNING BASE VALUE" ) ; 
prline( 1,  "*" ) ; 
//prp( &tgatethresh, "TONE  AMP EXPANSION THRESHOLD (in dB)" ) ; 
//prp( &expandex, "TONE  AMP EXPANSION CURVE INDEX " ) ; 




prline( 1,  "*" ) ; 
prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prp( &freqlow, "LOW SHELF FREQUENCY" ) ; 
prp( &dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prp( &freqhi, "HIGH SHELF FREQUENCY" ) ; 
prp( &dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
prt( "*...........................................*" ) ;  
prline( 1,  "*" ) ; 

//***************** 
 
if( datafile ==  "EMPTY\0" ){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A DATA FILE. BYE.\n" ) ;
    exit(0);
}
//****** TURN SOURCE ON OR OFF
if( (SOURCE_dB.A[0] > threshfacdB) || (SOURCE_dB.n != 1.)){
    // INCLUDE SOURCE
    sourceflag = 1 ;
    fprintf( stderr, "\n SOURCE SOUND INCLUDED......." ) ; 
    fprintf( stderr, "\n\t(SOURCE DECIBEL LEVEL BASED ON FUNCTION, \n\tOR IS > RESYNTHESIS THRESHOLD OF %f dB)", 
	threshfacdB ) ; 
}else{
    // EXCLUDE SOURCE
    sourceflag = 0 ; 
    fprintf( stderr, "\n ====> * SOURCE SOUND EXCLUDED * <=======" ) ; 
    fprintf( stderr, "\n\t(SOURCE DECIBEL LEVEL  < RESYNTHESIS THRESHOLD OF %f dB)", 
	threshfacdB ) ; 
}
//***************** 
    
//****** MAKE ARRAYS
    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, (N+2) ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
//***************** 

// MAKE THRESH AMP
    threshfac = dB_to_amp( threshfacdB );	

// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 




//**************************GET DATA	
// READ IN CHORD TONES, SHIFTPOINT, NUMBER_OF_PARTIALS, BW, AND DB

//**********

// MAKE NEW DATA FILE WITH COMMENTED LINES REMOVED

    cut_data_lines( datafile,  new_datafile,  NUM_PARAMETERS ) ; 

// OPEN FILE
  	if( (data = fopen( new_datafile, "r")) == NULL ){
	    fprintf( stderr, "\n%s <-- NO SUCH FILE. BYE.\n",  datafile ) ; 
	    exit(0); 
	}


// COUNT VALUES IN FILE
	k = 0 ; 
	while( fscanf( data,  " %f ",  &temp ) != EOF ) k++ ; 			
	rewind( data ) ;    

// ABORT IF NOT ENOUGH DATA
if( k < (NUM_PARAMETERS - 1) ){
    prt( "\n\n==========> INSUFFICIENT DATA FILE <==========\n\n" ) ; 
    exit( 0 ) ; 
}





// ALLOCATE SPACE FOR CHORD TONES
    fvec( PP, k ) ;	/* PARTIALS */
// COMPUTE NUMBER OF TONES
    np = k / NUM_PARAMETERS ;


// MAKE THE SUM BINS
    fvec( tonesums, np ) ;

prline( 69,  "-" ) ;
prbanner( "CHORDMAPPER: DATAFILE VALUES", 69 ) ; 
prline( 69,  "-" ) ;

if(source_method == 0){
    // FREQUENCY

    if( shift_method == 0 ){
	// MULTIPLIER

    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Frequency |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Frequency |Partial   |Multiplier|of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |          |Number    |          |Partials  |          |          |" ) ;
	
    }else if( shift_method == 1 ){
	// FREQ
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Partial   |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Frequency |Partial   |Shift     |of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |          |Number    |Adder     |Partials  |          |          |" ) ;
	
    }else if( shift_method == 2 ){
	// FREQ
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Frequency |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Frequency |Partial   |Map       |of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |          |Number    |Point     |Partials  |          |          |" ) ;
	
    }else if( shift_method == 3 ){
	// OCTAVE.PITCHCLASS
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Oct.Pitch |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Frequency |Partial   |Class Map |of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |          |Number    |Point     |Partials  |          |          |" ) ;





	
    }else{
	// EXIT
	prt("ILLEGAL SHIFT DATA FORMAT" ) ; 
	exit(0) ; 
    }

}else if(source_method == 1){
    // OCTAVE.PITCHCLASS
    
    if( shift_method == 0 ){
	// MULTIPLIER
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Frequency |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Oct.Pitch |Partial   |Multiplier|of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |Class     |Number    |          |Partials  |          |          |" ) ;
	
    }else if( shift_method == 1 ){
	// FREQ
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Partial   |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Oct.Pitch |Partial   |Shift     |of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |Class     |Number    |Adder     |Partials  |          |          |" ) ;
	
    }else if( shift_method == 2 ){
	// FREQ
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Frequency |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Oct.Pitch |Partial   |Map       |of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |Class     |Number    |Point     |Partials  |          |          |" ) ;
	
    }else if( shift_method == 3 ){
	// OCTAVE.PITCHCLASS
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Source    |Source Low|Oct.Pitch |Number    |BW        |          |" ) ; 
    fprintf( stderr,  "\n|    |Oct.Pitch |Partial   |Class Map |of        |Proportion|Decibels  |" ) ; 
    fprintf( stderr,  "\n|    |Class     |Number    |Point     |Partials  |          |          |" ) ;
	
    }else{
	// EXIT
	prt("ILLEGAL SHIFT DATA FORMAT" ) ; 
	exit(0) ; 
    }
    


}else{
    // EXIT
    prt("ILLEGAL SOURCE POINT DATA FORMAT" ) ; 
    exit(0) ; 
}


    fprintf( stderr,  "\n.......................................................................|" ) ; 


// READ IN AND PRINT OUT VALUES
k = 0 ; 
rewind( data ) ;    
for( i = 0; i < np ; i++ ){
    fprintf( stderr,  "\n" ) ;
    fprintf( stderr,  "|%-4d|",  i + 1 ) ; 

    for( j = 0; j < 6 ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	    fprintf( stderr,  "%-10.3f|", PP[ k ]  ) ;
	     k++ ; 			
    }
    for( j = 6; j < NUM_PARAMETERS ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	     k++ ; 			
    }
} 
    fprintf( stderr,  "\n************************************************************************" ) ; 
        fprintf( stderr,  "\n\n" ) ; 
    



    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n|Tone|Partials  |Db Rolloff|Amp Interp|FreqInterp|Tuning    |Null      |" ) ; 
    fprintf( stderr,  "\n|    |Spacing   |(or up)per| Control  | Control  |Factor    |Phase     | " ) ; 
    fprintf( stderr,  "\n|    |Proportion|Octave    | Switch   | Switch   |          |          |" ) ;
	

    fprintf( stderr,  "\n.......................................................................|" ) ; 


// READ IN AND PRINT OUT VALUES
k = 0 ; 
rewind( data ) ;    
for( i = 0; i < np ; i++ ){
    fprintf( stderr,  "\n" ) ;
    fprintf( stderr,  "|%-4d|",  i + 1 ) ; 

    for( j = 0; j < 6 ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	     k++ ; 			
    }
    for( j = 6; j < NUM_PARAMETERS ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	    fprintf( stderr,  "%-10.3f|", PP[ k ]  ) ;
	     k++ ; 			
    }
} 
    fprintf( stderr,  "\n************************************************************************" ) ; 
    fprintf( stderr,  "\n\n" ) ; 
    



//************************************
// SET UP THE ARRAY POINTING AT THE BINS AND THEIR AMPLITUDES
    // FIRST TIME LOOP TO ACCESS ARRAY SIZE NEEDED
  for(l = 0 ; l < 2 ; l++ ){
    mm = 0 ; numbands = 0 ; 
    // LOOP FOR  TONES

    for( j = 0, tone_now = 0 ; j < (np*NUM_PARAMETERS) ; j += NUM_PARAMETERS,  tone_now++ ){
//***
	//*** --> 0 <--- FIND THE SOURCE TONE FREQUENCY AND MAKE THE BW MULTIPLIER
	if( source_method == 1 ){
 
	// TRANSLATE OCTAVE.PT.PITCHCLASS INTO FREQUENCY AND REPLACE IN ARRAY
	    temp = (float) ((int) PP[j] ) ; // INTEGER PART
	    temp =  (( 12. * (temp - 8.)) + 
		    (100. * (PP[j] - temp)) ) / 12. ;

	    temp = midC * pow( 2., (double) temp ) ; 

		    // FREQUENCY METHOD
	} else if(source_method == 0) {
 
	    // MOVE FREQUENCY INTO TEMP
	    temp = PP[j] ;
	}
	    // MAKE BW ADDER
	    if( PP[j + 4] > 0. ){
		bw = temp * PP[j + 4] * .5 ;
	    }else{
		prf( PP[j + 4],  "BANDWIDTH" ) ; 
		prt( "BANDWIDTH MUST BE > 0.,  BYE\n\n" ) ; 
		exit( 0 ) ; 
	    }


	    // TEST ON LOWEST PARTIAL
	    if( PP[j + 1] < 1.  ){
		prf( PP[j + 1],  "LOWEST PARTIAL" ) ; 
		prt( "LOWEST PARTIAL MUST BE >= 1,  BYE\n\n" ) ; 
		exit( 0 ) ; 
	    }	    

	 // FIND THE ALLOWED NUMBER OF PASSMODE PARTIALS
	    // FACTOR IN SPACING AND POSITION OF LOWEST PARTIAL

	 numpasspartials = (int)((nyquist - (temp * PP[j + 1])) / (temp * fabs( PP[j + 6] ))) ; 
	//pri( numpasspartials,  "(A)NUMBER OF PASS PARTIALS FOR THIS TONE numpasspartials" ) ; 

	//prf( PP[j + 3],  "(A) CODE: NUMBER OF PARTIALS FOR THIS TONE PP[j + 3]" ) ; 

	    // IF NUMBER OF PARTIALS IS 1 OR GREATER,USE THE NUMBER SPECIFIED
	    if( ((int) PP[j + 3] >= 1.)  ){

		numpasspartials = PP[j + 3] ; 
	    }

	//pri( numpasspartials,  "(B) NUMBER OF PARTIALS FOR THIS TONE numpasspartials" ) ; 

	// BRANCH ON SPACING
	if( PP[j + 6] >= 1. ){
	    
	    // ************  PASSMODE SPACING == 1 or more
	    // ALREADY DONE


	}else if( PP[j + 6] <= -2. ){

	    // ************ REJECTMODE: SPACING -2 OR LESS
	    // FIND THE TOTAL NUMBER OF PARTIALS FOR THE FUNDAMENTAL,
	    //  THEN SUBTRACT THE  NUMBER IN THE PASSMODE
	    // TOTAL PARTIALS
	    temp7 = (float) ((int)( nyquist / temp )) ; 
	//pri( temp7,  "(C) TOTAL NUMBER OF PARTIALS FOR THIS TONE" ) ; 
	    numpasspartials = temp7 - numpasspartials ; 
	    	    
	//pri( numpasspartials,  "(C) NUMBER OF PARTIALS FOR THIS TONE numpasspartials" ) ; 

	}else{
	    // ILLEGAL BETWEEN -2 and 1
		prf( PP[j + 6],  "PARTIAL SPACING" ) ; 
		prt( "PARTIAL SPACING MUST BE >= 1.,  OR <= -2,  BYE\n\n" ) ; 
		exit( 0 ) ; 
	}



	    // SAVE PARTIAL DB ROLLOFF 
		dBrolloff = PP[j + 7]  ; 


//***
	// FIND THE MAP POINT FREQUENCY
 	    if( shift_method == 3 ){
	// TRANSLATE OCTAVE.PT.PITCHCLASS INTO FREQUENCY
	    temp2 = (float) ((int) PP[j + 2] ) ; // INTEGER PART
	    temp2 =  (( 12. * (temp2 - 8.)) + 
		    (100. * (PP[j + 2] - temp2)) ) / 12. ;

	    temp2 = midC * pow( 2., (double) temp2 ) ; 
		    // FREQUENCY SHIFT POINT
	} else if(shift_method == 2) {
	    // MOVE FREQUENCY INTO TEMP
	    temp2 = PP[j + 2] ;

	} else if(shift_method == 1) {
	    //* PARTIAL SHIFT ADDER
	    temp2 = ( temp * PP[j + 2] ) ;

	} else if(shift_method == 0) {
	    //* FREQUENCY MULTIPLIER
	    temp2 = temp * PP[j + 2] ;
	}

 	// MAKE SHIFT FACTOR
	// temp IS THE FUNDAMENTAL, temp2 IS THE FREQUENCY TO SHIFT THE FUNDAMENTAL
	// AND SELCTED PARTIALS TO,  EXCEPT IN METHOD 1 WHERE IT IS THE AMOUNT TO ADD
	// THAT IS THE NUMBER OF PARTIALS TO SHIFT * THE FUNDAMENTAL FREQ

	if(shift_method == 1){
	    // temp4 IS THE FREQUENCY ADDER
	    temp4 = temp2 ;  
	}else {
	    // temp4 IS THE FREQUENCY SHIFT MULTIPLER
	    temp4 = temp2 / temp ;  
	}


	// temp3 BELOW IS THE FREQUENCY OF THE UNSHIFTED PARTIAL FREQUENCY


	// LOOP FOR PARTIALS
	part_count = 1 ;
	rejected_part_count = 0 ; 
	current_rejected_part = (int) PP[j + 1] ; // FIRST PARTIAL 

	for( k = 1; k <= numpasspartials; k++ ){

	// SAVE THE ADDRESS OF THE BOTTOM OF THIS BAND
	if( l == 1 )band_begin[ numbands ] = mm ; 

	// MAKE (UNSHIFTED) PARTIAL FREQUENCY


	    if( PP[j + 6] >= 1. ){
		// SELECTED PARTIALS "PASSMODE": MAKE (UNSHIFTED) PARTIAL FREQUENCY
		temp3 = (temp * PP[j + 1]) + (temp * PP[j + 6] * (float) (k - 1)) ; 



	    }else{
	    

		if( part_count == current_rejected_part ){
		    part_count++ ; // SKIP THIS PARTIAL
		    rejected_part_count++ ; // COUNT THE REJECTED PARTIAL

		    //INCREMENT TO NEXT REJECT PARTIAL IF THERE ARE MORE TO REJECT
		    if( ( PP[j + 3] == 0. ) || (rejected_part_count < PP[j + 3] ) )
			current_rejected_part += (int) fabs( PP[j + 6] ) ; // INCREMENT
		}

		temp3 = temp * (float) part_count ; 
		
		
		// INCREMENT TO NEXT PARTIAL
		 part_count++ ; 

	    }	    


	// INDEX OF THE FREQ BIN BELOW THE PARTIAL
	    i1 = 1 + (2 * ( rint((double)(temp3 - bw) / fundamental)) ) ; 
	// INDEX OF THE FREQ BIN ABOVE THE PARTIAL
	    i2 = 1 + (2 * ( rint((double)(temp3 + bw) / fundamental)) )  ;  
	// INDEX OF THE FREQ BIN AT THE PARTIAL
	    ipartial = 1 + (2 * ( rint((double)(temp3) / fundamental)) )  ;  

    
//******** NEW STUFF BEGIN

	// LOOP FOR THE ipartial-i1 BINS (BELOW THE PARTIAL) >>>>>>>> BELOW <<<<<<<<<<<<<<<
	for(i = i1; i < ipartial; i += 2){

	    // IN THE NEXT (ipartial-i1)*2 SPACES IN THE FILTER ARRAY 
	    // PLACE THE APPROPRIATE AMP VALUE FOR THIS TONE
	    
	    // IF IN RANGE.....
	    if((i > 0) && (i < N) ){
		// AMP
		temp6 = (float) (ipartial - i) / (float) (ipartial - i1) ; // 0-1 function index
		temp6 = coscurve( temp6 ) ; // COSINE CURVE AMP 


	    // THE BIN INDEX
	    if( l == 1) binpt[ mm ] = i ; 
	    if( l == 1) tone[ mm ] = tone_now ;  // THE TONE

	    // THE INTERPOLATION CONTROL SWITCH
	    if( l == 1) binpt_iflag[ mm * 2 ] = PP[j + 8] ; // : AMP
	    if( l == 1) binpt_iflag[ (mm * 2) + 1 ] = PP[j + 9] ; // : FREQ

	    // SAVE THE UNSHIFTED PARTIAL FREQUENCY FOR TUNING OF THE PARTIAL BINS
	    if( l == 1) sourcefreq[mm] = temp3 ; 




	    // THE AMPFREQ MULTIPLIERS

	    if( l == 1) 
		if( shift_method == 1 ){
		    // FREQUENCY SHIFT ADDER

		    ampfreq[ (mm * 2) + 1 ] = 1. - ((temp3 + temp4) / temp3) ; 

		  //*******

		    // MAKE THE FREQUENCY OF THE SHIFTED PARTIAL 
		    shiftedpartfreq = temp3 + temp4 ;

		    // SAVE FREQ IF IT IS THE LOWEST SHIFTED PARTIAL
		    if( k == 1 ) lowpartfreq = shiftedpartfreq ;
		    
		    // PROPORTION OF SHIFTED TO LOWEST
		    octroll = log10( (double) ( shiftedpartfreq / lowpartfreq ) ) / log10( 2. )  ; 
		    
		    // MAKE FINAL AMP
		    ampfreq[ (mm * 2) ] = PP[j + 5] + (octroll * dBrolloff)  ; 
		    coswindow[ mm ] = temp6 ; 
		    targetfreq[ mm ] = shiftedpartfreq ; 
		  //*******






		}else{
		    // FREQ SHIFT FACTOR
		    ampfreq[ (mm * 2) + 1 ] = 1. - temp4 ; 

		  //*******
		    // MAKE THE FREQUENCY OF THE SHIFTED PARTIAL 
		    shiftedpartfreq = temp3 * temp4 ;

		    // SAVE FREQ IF IT IS THE LOWEST SHIFTED PARTIAL
		    if( k == 1 ) lowpartfreq = shiftedpartfreq ;
		    
		    // PROPORTION OF SHIFTED TO LOWEST
		    octroll = log10( (double) ( shiftedpartfreq / lowpartfreq ) ) / log10( 2. )  ; 
		    
		    // MAKE FINAL AMP
		    ampfreq[ (mm * 2) ] = PP[j + 5] + (octroll * dBrolloff)  ; 
		    coswindow[ mm ] = temp6 ; 
		    targetfreq[ mm ] = shiftedpartfreq ; 

		  //*******



		}

		mm++ ; 


	    }
	}

	// SETUP PARTIAL	>>>>>>>>>>>>> AT PARTIAL <<<<<<<<<<<<<<<<<<<<<<
	    // IF IN RANGE.....
	    if((ipartial > 0) && (ipartial < N) ){


	    // THE BIN INDEX
	    if( l == 1) binpt[ mm ] = ipartial ; 
	    if( l == 1) tone[ mm ] = tone_now ;  // THE TONE

	    // THE INTERPOLATION CONTROL SWITCH
	    if( l == 1) binpt_iflag[ mm * 2 ] = PP[j + 8] ; // : AMP
	    if( l == 1) binpt_iflag[ (mm * 2) + 1 ] = PP[j + 9] ; // : FREQ

	    // SAVE THE UNSHIFTED PARTIAL FREQUENCY FOR TUNING OF THE PARTIAL BINS
	    if( l == 1) sourcefreq[mm] = temp3 ; 

	    // THE AMPFREQ MULTIPLIERS
	    if( l == 1) 
		if( shift_method == 1 ){

		    // FREQUENCY SHIFT ADDER

		    ampfreq[ (mm * 2) + 1 ] = 1. - ((temp3 + temp4) / temp3) ; 

		  //*******

		    // MAKE THE FREQUENCY OF THE SHIFTED PARTIAL 
		    shiftedpartfreq = temp3 + temp4 ;

		    // SAVE FREQ IF IT IS THE LOWEST SHIFTED PARTIAL
		    if( k == 1 ) lowpartfreq = shiftedpartfreq ;
		    
		    // PROPORTION OF SHIFTED TO LOWEST
		    octroll = log10( (double) ( shiftedpartfreq / lowpartfreq ) ) / log10( 2. )  ; 
		    
		    // MAKE FINAL AMP
		    ampfreq[ (mm * 2) ] = PP[j + 5] + (octroll * dBrolloff)  ; 
		    coswindow[ mm ] = 1. ; 
		    targetfreq[ mm ] = shiftedpartfreq ; 

		  //*******





		}else{
		    // FREQ SHIFT FACTOR
		    ampfreq[ (mm * 2) + 1 ] = 1. - temp4 ; 

		  //*******
		    // MAKE THE FREQUENCY OF THE SHIFTED PARTIAL 
		    shiftedpartfreq = temp3 * temp4 ;

		    // SAVE FREQ IF IT IS THE LOWEST SHIFTED PARTIAL
		    if( k == 1 ) lowpartfreq = shiftedpartfreq ;
		    
		    // PROPORTION OF SHIFTED TO LOWEST
		    octroll = log10( (double) ( shiftedpartfreq / lowpartfreq ) ) / log10( 2. )  ; 
		    
		    // MAKE FINAL AMP
		    ampfreq[ (mm * 2) ] = PP[j + 5] + (octroll * dBrolloff)  ; 
		    coswindow[ mm ] = 1. ; 
		    targetfreq[ mm ] = shiftedpartfreq ; 

		  //*******
		}




		mm++ ; 

	    }




	// LOOP FOR THE ipartial-i2 BINS   >>>>>>>>>>>>>>>>>> ABOVE <<<<<<<<<<<<<<<<
	for(i = i2; i > ipartial; i -= 2){
	    // IN THE NEXT (ipartial-i2)*2 SPACES IN THE FILTER ARRAY 
	    // PLACE THE APPROPRIATE AMP VALUE FOR THIS TONE
	    
	    // IF IN RANGE.....
	    if((i > 0) && (i < N) ){
		// AMP
		temp6 = (float) (i - ipartial) / (float) (i2 - ipartial) ; // 0-1 function index
		temp6 = coscurve( temp6 ) ; // COSINE CURVE AMP 


	    // THE BIN INDEX
	    if( l == 1) binpt[ mm ] = i ; 
	    if( l == 1) tone[ mm ] = tone_now ;  // THE TONE

	    // THE INTERPOLATION CONTROL SWITCH
	    if( l == 1) binpt_iflag[ mm * 2 ] = PP[j + 8] ; // : AMP
	    if( l == 1) binpt_iflag[ (mm * 2) + 1 ] = PP[j + 9] ; // : FREQ

	    // SAVE THE UNSHIFTED PARTIAL FREQUENCY FOR TUNING OF THE PARTIAL BINS
	    if( l == 1) sourcefreq[mm] = temp3 ; 

	    // THE AMPFREQ MULTIPLIERS
	    if( l == 1) 
		if( shift_method == 1 ){


		    // FREQUENCY SHIFT ADDER

		    ampfreq[ (mm * 2) + 1 ] = 1. - ((temp3 + temp4) / temp3) ; 

		  //*******

		    // MAKE THE FREQUENCY OF THE SHIFTED PARTIAL 
		    shiftedpartfreq = temp3 + temp4 ;

		    // SAVE FREQ IF IT IS THE LOWEST SHIFTED PARTIAL
		    if( k == 1 ) lowpartfreq = shiftedpartfreq ;
		    
		    // PROPORTION OF SHIFTED TO LOWEST
		    octroll = log10( (double) ( shiftedpartfreq / lowpartfreq ) ) / log10( 2. )  ; 
		    
		    // MAKE FINAL AMP
		    ampfreq[ (mm * 2) ] = PP[j + 5] + (octroll * dBrolloff)  ; 
		    coswindow[ mm ] = temp6 ; 
		    targetfreq[ mm ] = shiftedpartfreq ; 
	
		  //*******





		}else{
		    // FREQ SHIFT FACTOR
		    ampfreq[ (mm * 2) + 1 ] = 1. - temp4 ; 

		  //*******
		    // MAKE THE FREQUENCY OF THE SHIFTED PARTIAL 
		    shiftedpartfreq = temp3 * temp4 ;

		    // SAVE FREQ IF IT IS THE LOWEST SHIFTED PARTIAL
		    if( k == 1 ) lowpartfreq = shiftedpartfreq ;
		    
		    // PROPORTION OF SHIFTED TO LOWEST
		    octroll = log10( (double) ( shiftedpartfreq / lowpartfreq ) ) / log10( 2. )  ; 
		    
		    // MAKE FINAL AMP
		    ampfreq[ (mm * 2) ] = PP[j + 5] + (octroll * dBrolloff)  ; 
		    coswindow[ mm ] = temp6 ; 
		    targetfreq[ mm ] = shiftedpartfreq ; 

		  //*******
		}

		mm++ ; 

	    }
	}

    // INCREMENT THE NUMBER OF BANDS
    numbands++ ; 


// END PARTIALS LOOP
      }

	// SAVE TUNE FACTOR FOR THIS PARTIAL
    if( l == 1 )tune_factor[ tone_now ] = PP[j + 10] ; 


	// SAVE NULL PHASE FACTOR FOR THIS PARTIAL
    if( l == 1 )null_phase_factor[ tone_now ] = PP[j + 11] ; 

// END TONES LOOP
    }

    
	// MAKE  ARRAYS

	if(l == 0)ivec( band_begin, numbands + 1 ) ;
	if(l == 0)fvec( oldbandampsum, numbands ) ;

	if(l == 0)fvec( ampfreq, (mm*2) ) ;
	if(l == 0)fvec( targetfreq, mm ) ;
	if(l == 0)fvec( sourcefreq, mm ) ;
	if(l == 0)fvec( coswindow, mm ) ;
	if(l == 0)ivec( tone, mm ) ;
	if(l == 0)ivec( binpt, mm ) ;
	if(l == 0)fvec( binpt_iflag, (mm*2) ) ;

	if(l == 0)fvec( tune_factor, np ) ;
	if(l == 0)fvec( null_phase_factor, np ) ;
    

    }
    
    NC = mm ; NCmult2 = NC * 2 ;   

    band_begin[ numbands ] = NC ;



    
    
	// MAKE  ARRAY
	fvec( harmony, (NCmult2+2) ) ;
	fvec( previous_harmony, (NCmult2+2) ) ;


//************************************

	
//************************************
//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 


   makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;


    // ZERO OLD BAND AMPS
    for( i = 0; i < numbands; i++) oldbandampsum[i] = 0. ; 

//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
	in += D ;
	on += I ;
	timenow( dur ) ;

	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
	  	  convert( buffer, channel, N2, D, R ) ;




//*************************
// GET THE VALUES
//*************************


//  SHIFT, GAIN, AND MULTIPLIER

		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp( dBgain.A[ 0 ] ) ; 
// TARGETS
		target_harmadd.A[ 0 ] =  fval( &target_harmadd, dur, t );
		target_ptrans.A[ 0 ] = fval( &target_ptrans, dur, t );
		    pmt = semitones_to_mult( target_ptrans.A[ 0 ] ) ;
		target_dB.A[ 0 ] =  fval( &target_dB, dur, t );
		    target_gain = dB_to_amp( target_dB.A[ 0 ] ) ; 

		amp_control.A[ 0 ] =  fval( &amp_control, dur, t );
		    ac = 1 - amp_control.A[ 0 ] ;
		freq_control.A[ 0 ] =  fval( &freq_control, dur, t );
		    fc = 1 - freq_control.A[ 0 ] ; 
		
		warpshape.A[ 0 ] =  fval( &warpshape, dur, t );
		nullprop.A[ 0 ] =  fval( &nullprop, dur, t );
		    minusnullprop = 1. - nullprop.A[ 0 ] ; 
		tuneprop.A[ 0 ] =  fval( &tuneprop, dur, t );
		tunebase.A[ 0 ] =  fval( &tunebase, dur, t );

		//tgatethresh.A[ 0 ] =  fval( &tgatethresh, dur, t );
		//    tgateamp = dB_to_amp( tgatethresh.A[ 0 ] ) ; 
		//expandex.A[ 0 ] =  fval( &expandex, dur, t );




		attack.A[ 0 ] = fval( &attack, dur, t );
		    smooth_setup( attack.A[ 0 ], &attackc, &minusattackc, IR ) ; 
		release.A[ 0 ] = fval( &release, dur, t );
		    smooth_setup( release.A[ 0 ], &releasec, &minusreleasec, IR ) ; 


		dBlow.A[ 0 ] =  fval( &dBlow, dur, t );
		dBhi.A[ 0 ] =  fval( &dBhi, dur, t );
		freqlow.A[ 0 ] =  fval( &freqlow, dur, t );
		freqhi.A[ 0 ] =  fval( &freqhi, dur, t );
 

// SOURCE
		if(sourceflag){
		    SOURCE_harmadd.A[ 0 ] =  fval( &SOURCE_harmadd, dur, t );
		    SOURCE_ptrans.A[ 0 ] = fval( &SOURCE_ptrans, dur, t );
			pms = semitones_to_mult( SOURCE_ptrans.A[ 0 ] ) ;
		    SOURCE_dB.A[ 0 ] =  fval( &SOURCE_dB, dur, t );
			SOURCE_gain = dB_to_amp( SOURCE_dB.A[ 0 ] ) ; 
		}


//**********************************

	    // TUNE THE PARTIAL BANDS
	mm = 0 ; 
	b1 = 0 ; bcount = 0 ; asum = 0. ; fsum = 0. ;  
	if( (tunebase.A[ 0 ] != 0.) || (tuneprop.A[ 0 ] != 0.)  ) while( mm < NC ){
	    
 
	    // SUM FREQS WEIGHTED BY FREQS
	    temp = channel[ binpt[ mm ] - 1] * channel[ binpt[ mm ] - 1] ; 
	    fsum += (channel[ binpt[ mm ] ] * temp) ; 
		 
	     // SUM AMPS
	    asum += temp ; 

	    bcount++ ; // INCREMENT COUNT ON BINS FOR THIS PARTIAL

	    if( mm == (NC - 1) ) temp = 0. ; else temp = sourcefreq[mm + 1] ; 

	    if( temp != sourcefreq[mm] ){

 	    
		// THIS IS THE TOP, FIND STATS AND TUNE BINS

		// IF NON ZERO AMPLITUDE THEN
		if( asum > 0. ){

 		    // FIND AVERAGE FREQ
		    temp = fsum / asum ; 

		    // CREATE PROPORTION FROM AVERAGE AND SOURCE
		    temp = sourcefreq[b1] / temp ; 

		    temp2 = tunebase.A[0] + 
			((tune_factor[ tone[mm] ]  - tunebase.A[0]) * tuneprop.A[ 0 ]) ; 
		    temp = (temp2 * (temp - 1.)) + 1. ; 


		    // GO THROUGH ALL THE BINS AND TUNE
		    for( i = b1 ; i < (b1 + bcount); i++ ) channel[ binpt[ i ]] *= temp ;  

		}
		
		b1 = b1 + bcount ; // SET LOW BIN PAIR TO THE NEXT BOTTOM
		bcount = 0 ; asum = 0. ; fsum = 0. ;  
	    }

	    mm++ ; // INCREMENT MASTER BIN COUNT
	}	    



//**********************************

//**********************************

	    // NULL THE PHASE OF THE PARTIAL BANDS
	mm = 0 ; 
	b1 = 0 ; bcount = 0 ; 
	if( nullprop.A[ 0 ] != 0. ) while( mm < NC ){
	    
 	    bcount++ ; // INCREMENT COUNT ON BINS FOR THIS PARTIAL

	    if( mm == (NC - 1) ) temp = 0. ; else temp = sourcefreq[mm + 1] ; 

	    if( temp != sourcefreq[mm] ){
		// THIS IS THE TOP, NULL PHASE OF ALL BINS IN BAND

		    // GO THROUGH ALL THE BINS AND NULL THE PHASE
		    for( i = b1 ; i < (b1 + bcount); i++ ){
			    channel[ binpt[ i ]] = 
				((nullprop.A[ 0 ] * null_phase_factor[ tone[mm] ]) * 
				(sourcefreq[mm] - channel[ binpt[ i ]])) +
				channel[ binpt[ i ]] ; 
		    }
		
		b1 = b1 + bcount ; // SET LOW BIN PAIR TO THE NEXT BOTTOM
		bcount = 0 ; 
	    }

	    mm++ ; // INCREMENT MASTER BIN COUNT
	}	    



//**********************************


//***********************************

//**********************************


	// ATTACK AND RELEASE, AND WARP

	// STEP THROUGH BANDS


	for( i = 0; i < numbands; i++ ){
	    bandampsum = 0. ; bandpeakamp = 0. ; 		    
	    

	    
	    for( mm = band_begin[ i ]; mm <  band_begin[ i + 1 ] ; mm++ ){

		// FIND PEAK AMP FOR BAND
		if( channel[ binpt[ mm ] - 1 ] > bandpeakamp ) 
			bandpeakamp = channel[ binpt[ mm ] - 1 ] ; 

		// FIND SUM OF AMPS IN BAND
		bandampsum += channel[ binpt[ mm ] - 1 ] ;  

	    }  


		//WARP AMPS USING PEAK AMP FOUND IN BAND
		if( bandpeakamp > 0. )
		    for( mm = band_begin[ i ] ; mm <  band_begin[ i + 1 ] ; mm++ ){
			channel[ binpt[ mm ] - 1 ] =
			    curve( 0., bandpeakamp,  
				(channel[ binpt[ mm ] - 1 ] / bandpeakamp), warpshape.A[ 0 ] ) ;  
		    }


	    if( bandampsum > 0. ){
	    // MAKE THE NEW BAND AMP SUM USING THE ATTACK AND RELEASE
	    
		if(( bandampsum < oldbandampsum[ i ] ) ){
		// RELEASE
		    newbandampsum =  
			(releasec * oldbandampsum[ i ] ) + ( minusreleasec * bandampsum ); 
		} else {
		// ATTACK
		    newbandampsum =  
			(attackc * oldbandampsum[ i ] ) + ( minusattackc * bandampsum ); 

		}

		



		
		// MAKE NORMALIZED AMP MULTIPLIER

		temp = newbandampsum / bandampsum ; 


		// MODIFY AMPS
		for( mm = band_begin[ i ] ; mm <  band_begin[ i + 1 ] ; mm++ ){
		    channel[ binpt[ mm ] - 1 ] *= temp ; 
		}





	    }else{
		// ZERO BAND AMP SUM
		newbandampsum = 0. ; 
	    }

	    // SAVE OLD BAND AMP
	    oldbandampsum[ i ] = newbandampsum ; 


	}



//**********************************

// MAKE TRANSFER TO HARMONY ARRAY
	for( mm = 0 ; mm < NC ; mm++ ){


		// AMP
	    if( binpt_iflag[ mm * 2 ] >= 0. ){
		// REGULAR
		acnow = 1. - ( ac * binpt_iflag[ mm * 2 ] ) ;  

	    }else{
		// REVERSE
		acnow = 1. + ( amp_control.A[ 0 ] *  binpt_iflag[ mm * 2 ] ) ;  

	    }

		// FREQ
	    if( binpt_iflag[ (mm * 2) + 1 ] >= 0. ){
		// REGULAR
		fcnow = 1. - ( fc * binpt_iflag[ (mm * 2) + 1 ] ) ;  

	    }else{
		// REVERSE
		fcnow = 1. + ( freq_control.A[ 0 ] * binpt_iflag[ (mm * 2) + 1 ] ) ;  

	    }


		// AMP
		    
		harmony[ (mm * 2) ] = 
		    channel[ binpt[ mm ] - 1 ]  * 
			dB_to_amp( acnow * ampfreq[ mm * 2 ] ) *
			    coswindow[ mm ] * gain * target_gain ;  
		    
		// FREQ
		if( shift_method == 1 ){
		    // PARTIAL SHIFT ADDER


		    newfreq = channel[ binpt[ mm ] ]  * 
				(1. - ( fcnow * ampfreq[ (mm * 2) + 1 ] ) ) ;    

		    harmony[ (mm * 2) + 1 ] = 
			(newfreq +  target_harmadd.A[ 0 ] ) * pmt ;

		}else{
		    // OTHERS


		    newfreq = channel[ binpt[ mm ] ]  * 
			(1. - ( fcnow * ampfreq[ (mm * 2) + 1 ] ) )  ;    



		    harmony[ (mm * 2) + 1 ] = 
			(newfreq +  target_harmadd.A[ 0 ] ) * pmt ;



		}
	}

//**** THRESHOLD STUFF

/********************** BEGIN NOT IN SERVICE

    // SKIP IF ONLY ONE TONE
    if( np > 1 ){

	// ZERO SUMS
	for( i = 0; i < np; i++)tonesums[i] = 0. ; 

	// FIND SUM OF AMPLITUDES FOR ALL THE BINS OF A TONE
	for( mm = 0 ; mm < NC ; mm++ )tonesums[tone[mm]] += harmony[ (mm * 2) ] ; 
    
	// WHICH TONE IS THE STRONGEST
	k = 0 ; 
	for( i = 1; i < np; i++) if( tonesums[i] > tonesums[k] ) k = i ; 

	// ABORT IF NO AMP
	if( tonesums[k] > 0. ){
	    // NORMALIZE THE SUMS
	    for( i = 0; i < np; i++)tonesums[i] = tonesums[i] / tonesums[k] ;  

	    // GATE AMPS
	    for( mm = 0 ; mm < NC ; mm++ )
		if( tonesums[tone[mm]] < tgateamp ) {
		    temp = harmony[ (mm * 2) ] / tgateamp ; 
		    harmony[ (mm * 2) ] =  
			    curve(0., tgateamp, temp,  expandex.A[ 0 ]  );

	    }  
		

	}	    
	    	    


    }
**** END NOT IN SERVICE  */


    //************* SMOOTH THE CHANGES TO THE SPECTRUM
    //  --> THIS HAS BEEN REPLACED BY SMOOTHING A GAIN FUNCTION (SEE ABOVE)
    //smooth( harmony, previous_harmony, NCmult2, attackc, minusattackc, releasec, minusreleasec ) ; 



    //*************WARP THE AMPLITUDE SPECTRUM --> THIS HAS BEEN REPLACED BY WARPING
    // THE AMPLITUDES IN INDIVIDUAL BANDS (SEE ABOVE)
    //spectmagwarp( harmony,  NCmult2, warpshape.A[ 0 ], 0 ) ;		

    //*************EQUALIZE THE OUTPUT SPECTRUM
    eq3( harmony,  NCmult2,  dBlow.A[0],  dBhi.A[0], freqlow.A[0],  freqhi.A[0] ) ; 
		


//if(bug)fprintf( stderr,  "\n************************" ) ; 
//if(bug)for( j = 1; j < NCmult2; j += 2){
//    fprintf( stderr,  "\n%d)harmony array--> NCmult2: %d,  freq: %f,  amp: %f",
//	  j, NCmult2,  harmony[j],  harmony[j - 1] ) ; 
//}



//*****************
// MODIFICATIONS 
//*****************


//*********************************************************

		    
// **************** SOURCE
		 if(sourceflag){
		    for( i = 1; i < N; i = i + 2){
			// MODIFY SOURCE

			// **FREQ
			temp = pms * (channel[i] + SOURCE_harmadd.A[ 0 ]) ;
			// **AMP
			channel[i - 1] = channel[i - 1] * SOURCE_gain * gain ; 
			// ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
			if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
			else channel[i] = temp ; 
		    }
		 }

// *************   
// *************   
		    // harmony OUT OF BOUNDS?
		 for( i = 1; i < NCmult2; i += 2 ){
 		    if((harmony[ i ] <= 0.) || (harmony[ i ] >= nyquist)) harmony[i - 1] = 0. ; 
		}




	    if(sourceflag){
		synt = getthresh( channel, N, threshfac );
		temp = getthresh( harmony, NCmult2, threshfac );
		if(temp > synt) synt = temp ; 
	    }else{
		synt = getthresh( harmony, NCmult2, threshfac );
	    }

	    if(sourceflag){
		// DO BOTH
		noscbank2( channel, N2, R, Nw, I, P, output, harmony,  NC );
	    }else{
		// ONLY DO HARMONIZER
		noscbank(harmony, NC, R, Nw, I, P, output);
	    }
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;


	    frame_count++ ; 
// FRAMES LOOP END


    }


    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  


    fprintf(stderr,"\n\nCHORDMAPPER : RESYNTHESIS COMPLETED\n");




    if( SOURCE_harmadd.n != 1. ) fclose(SOURCE_harmadd.fp ) ;
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;
    if( SOURCE_ptrans.n != 1. ) fclose(SOURCE_ptrans.fp ) ;
    if( target_dB.n != 1. ) fclose(target_dB.fp ) ;
    if( SOURCE_dB.n != 1. ) fclose(SOURCE_dB.fp ) ;
    if( target_ptrans.n != 1. ) fclose(target_ptrans.fp ) ;
    if( target_harmadd.n != 1. ) fclose(target_harmadd.fp ) ;
     if( amp_control.n != 1. ) fclose(amp_control.fp ) ;
   if( freq_control.n != 1. ) fclose(freq_control.fp ) ;
     if( warpshape.n != 1. ) fclose(warpshape.fp ) ;
    if( nullprop.n != 1. ) fclose(nullprop.fp ) ;
    if( tuneprop.n != 1. ) fclose(tuneprop.fp ) ;
    if( tunebase.n != 1. ) fclose(tunebase.fp ) ;
         if( tgatethresh.n != 1. ) fclose(tgatethresh.fp ) ;
     if( expandex.n != 1. ) fclose(expandex.fp ) ;
     if( release.n != 1. ) fclose(release.fp ) ;
     if( attack.n != 1. ) fclose(attack.fp ) ;
    if( dBlow.n != 1. ) fclose(dBlow.fp ) ;
    if( dBhi.n != 1. ) fclose(dBhi.fp ) ;
     if( freqlow.n != 1. ) fclose(freqlow.fp ) ;
    if( freqhi.n != 1. ) fclose(freqhi.fp ) ;

  
    fclose( data ) ; 
    
    sprintf( tempstring,  "rm %s\0", new_datafile ) ; 
    system( tempstring ) ; 


    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"chordmapper:  mutiple harmonic tone mapper \n"
	"chordmapper   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  \n"
	"		    2 = Blackman [0.],  3 = Bartlett triangular \n"
	"	D:	analysis frames per second [200]\n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"
	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (0. = end of file) [0.] \n"
	"	C:	resynthesis channel(s) (1 -> ?) (0 = all) [0] \n"

	"	A:	overall gain in decibels (func) [0.] \n"
	"	a:	SOURCE: frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func)[0.] \n"
	"	P:	SOURCE: pitch transposition in semitones (func) [0]\n"
	"	G:	SOURCE: gain control in decibels (func) [0.] \n"
	"	q:	TARGETS: frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func)[0.] \n"
	"	X:	TARGETS: pitch transposition in semitones (func) [0]\n"
	"	m:	TARGETS: gain control in decibels (func) [0.] \n"
	"	F:	(ascii) FILE of tone data (unordered groups of 12 parameters):\n"
	"		     Each consisting of: \n"
	"			(1) source point (see -Q source point data format below)\n"
	"			(2) lowest partial number\n"
	"			(3) shift factor or point (see -Z shift data format below)\n"
	"			(4) number of partials (0 = all partials below Nyquist)\n"
	"			(5) bandwidth as proportion of fundamental frequency\n"
	"			(6) decibels \n"
	"			(7) partial spacing as proportion of fundamental frequency\n"
	"				positive values: pass mode\n"
	"				    (include the selected partials)\n"
	"				negative values: reject mode\n"
	"				    (include all partials except the selected ones) \n"
	"			(8) dB rolloff (or rollup) per octave \n"
	"				measured from lowest (shifted) partial\n"
	"				(In reject mode this becomes the first non-rejected partial.)\n"
	"			(9) amplitude interpolation switch/degree\n"
	"			(10) frequency interpolation switch/degree\n"
	"			    (0 = no interpolation, 1 = full interpolation, .5 = half) \n"
	"			    (-1 = full reverse interpolation ) \n"
	"			(11) tuning factor\n"
	"			    (0 = no tuning, 1 = tuned to target partial) \n"
	"			    (values < 0 produce exagerated deviation, > 1 produces inverse\n"
	"				exagerated deviation)\n"
	"			(12) null phase factor\n"
	"			    0 = no change,  1 = all bins tuned(null phase) to freq \n"
	"			    of source partial,   .5 = halfway to null\n"
	"	Q:	SOURCE POINT DATA FORMAT: PITCH or FREQUENCY  [0]\n"
	"		     0 = frequency\n"
	"		     1 = octave.pitch_class\n"
	"	Z:	SHIFT DATA  FORMAT:[0]\n"
	"		     0 = frequency multiplier \n"
	"		     1 = partial shift adder \n"
	"		     2 = frequency shift point\n"
	"		     3 = octave.pitch_class shift point\n"
	"	c:	TARGETS: amplitude interpolation control,  0-1 (func) [1]\n"
	"	d:	TARGETS: frequency interpolation control,  0-1 (func) [1]\n"
	"		    ( amp and freq interpolation controls control the\n"
	"		      amount of shift from the original to the target.\n"
	"		      0 = no shift,  1 = full shift )\n"
	"	K:	TARGETS: partials master tuning control (pre-null phase )  0-1 (func) [0]\n"
	"		    (0 = tuning set to base (-J), 1 = full tuning deviation (P-field 11) )\n"
	"	J:	TARGETS: tuning control base setting 0-1 [0]\n"
	"		    (all tones equal this tune factor when control (-K) is 0.)\n"
	"		    (0 = original source tuning, 1 = tuned to target partial) \n"
	"		    (values < 0 source deviation exagerated > 1 produces inverse\n"
	"				exagerated source deviation)\n"
	"	B:	TARGETS: null phase interpolation control,  0-1 (func) [0]\n"
	"	W:	TARGETS: warp index for reshaping magnitude response of individual\n"
	"		    partials (func) [0.] \n"
	"		    Values > 0 expand the dynamic range, < 0 compress it. \n"
	"		TARGETS SHELF EQ:(post transpose/shift)\n"
	"	S:	    SHELF EQ: Low shelf gain in dB (func) [0.] \n"
	"	T:	    SHELF EQ: High shelf gain in dB (func) [0.] \n"
	"	U:	    SHELF EQ: Low shelf frequency in Hz (func) [200.] \n"
	"	V:	    SHELF EQ: High shelf frequency in Hz (func) [2000.] \n"


	"	l:      TARGETS: envelope attack time  (func) [0.]\n"
	"	L:      TARGETS: envelope release time   (func) [0.]\n"
	"	t:	oscillator resynthesis threshold in decibels [ -60 ]\n"

	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 
	"	_:	 OUTPUT FORMAT: 0 = taken from input file\n"
	"		    1 = 16-bit integer, 2 = 32-bit floats [0]\n" 

	"	=:	 PEAK RESCALE LEVEL (float output only) 0 to -96 dB \n"
	"		    set to 1 to rescale to level of input file [ 1 ]\n" 

	);
    exit(woof);
}


/*
 * 
	"	E:	TARGETS: tone amplitude expansion threshold,  0 to -96 (func) [0]\n"
	"		    (The amplitude of tones is expanded relative \n"
	"			    to the peak dB of all the tones.)\n"
	"	H:	TARGETS:  amplitude expansion curve 0 (linear) - +? (func) [3.] \n"
	"		    This value controls the shape of the expansion curve.\n"
	"		    The expansion is increased with greater values.\n"
 * 
 */



int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

float coscurve( float v ){
    
    
    static float table[ 1024 ] ; 
    static int first=1 ; 
    int i ; 
    float x ; 
    
    // SETUP TABLE FIRST TIME
    
    if( first ){
	
	for( i = 0 ; i < 1024; i++ ) {
	    x = ((float) i / 1024.) * (TWOPI * .5) ; 
	    table[ i ] = .5 * ((float) cos( (double) x ) + 1.) ; 
	}
	first = 0 ; 
    }
    
    i = (int) ((v * 1023.) + .5) ; 
    return( table[ i ] ) ; 
    
    
}


float coscurve_dB( float v ){
    
    
    static float table[ 1024 ] ; 
    static int first=1 ; 
    int i ; 
    float x ; 
    
    // SETUP TABLE FIRST TIME
    
    if( first ){
	
	for( i = 0 ; i < 1024; i++ ) {
	    x = ((float) i / 1024.) * (TWOPI * .5) ; 
	    table[ i ] = .5 * ((float) cos( (double) x ) + 1.) ; 
	    if( table[ i ] > 0. )
		table[ i ] = 20. * log10( table[ i ] ) ;
	    else
		table[ i ] = -200. ;  
	}
	first = 0 ; 
    }
    
    i = (int) ((v * 1023.) + .5) ; 
    return( table[ i ] ) ; 
    
    
}


     
     
     
     
     
      

