#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k,  itemp ;
float nyquist;
double atof();
  int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag = 0,  channelout=0,  achannelout ;
int analysis_N,  analysis_D, analysis_R, analysis_chan,   niframes ;  
float analysis_dur,  iframes_per_sec ; 
float P = 1.0;
FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel, 
    *C_buffer, *C_channel, *output ;
float *previous_channel,  *F,  *Fbuffer,  *F_lower,  *F_higher ; 
float threshfac = .001,  threshfacdB=-96 ;
float	pm, fm, panc,  pans, panpot, 
    A_dB,  B_dB,  C_dB,    gain=1. ;
float  temp,  temp2,  temp3 ;  
float getthresh();
float peakbinamp = 0.,  avgbinamp=0.,  peakamp ;
float   IR,  dur=0.;
float fundamental ;
float warpshape=0. ; 
float envattack,  envrelease,  minusattack,  minusrelease  ;  
double ar_dB ; 

float A_peak, B_peak,  AB_peak,  normamp,  normamps[16] ; 

float panwarp_A=0.,  panwarp_B=0. ; 
int ainchan,  exflag ; 

// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 

int autostop=0,  autostopflag=0 ; 

// ** FILTER VARIABLES
float filttnow=0.,   filttinc,  filtf, filtfprop  ; 
int filtflow,  filtflowold=0,  filtfhigh,  imode=1. ; 


char tempstring[ 128 ] ; 

// COMB FREQUENCY SHIFT ADDER
struct  func  harmadd ; 

// GAIN
struct  func  dBgain ; 

// PITCH MULTIPLIER
struct  func  ptrans ; 

// FILTER
struct  func  filter ; 
 


//  FILTER  RATE
struct  func  filtrate ; 

// FILTER TIME POINT ORIGIN
struct  func  filttorigin ; 

// FILTER TIME WINDOW LOWER BOUNDARY
struct  func  filtwinlow ; 

// FILTER TIME WINDOW UPPER BOUNDARY
struct  func  filtwinhi ; 







//  SOUND A dB
struct  func  Sound_A_dB ; 

//  SOUND B dB
struct  func  Sound_B_dB ; 

//  CONVOLUTION dB
struct  func  convolve_dB ; 

//  RELEASE
struct  func  release ; 

//  ATTACK
struct  func  attack ; 

//  CONVOLUTION PANPOT
struct  func  pan ; 

#include "underflow.h"

// *****************INITIALIZE
// COMB FREQUENCY SHIFT ADDER
harmadd.L = 1. ; harmadd.n = 1. ; harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// PITCH MULTIPLIER
ptrans.L = 1. ; ptrans.n = 1. ; ptrans.A[ 0 ] = 0. ; 

// FILTER
filter.L = 1. ; filter.n = 0. ; filter.A[ 0 ] = 0. ; 

//  SOUND A dB
Sound_A_dB.L = 1. ; Sound_A_dB.n = 1. ; Sound_A_dB.A[ 0 ] = -0. ; 

//  SOUND B dB
Sound_B_dB.L = 1. ; Sound_B_dB.n = 1. ; Sound_B_dB.A[ 0 ] = -0. ; 

//  CONVOLUTION dB
convolve_dB.L = 1. ; convolve_dB.n = 1. ; convolve_dB.A[ 0 ] = -0. ; 

//  RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 

//  ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 

//  CONVOLUTION PANPOT
pan.L = 1. ; pan.n = 1. ; pan.A[ 0 ] = 0  ; 

//  FILTER  RATE
filtrate.L = 1. ; filtrate.n = 1. ; filtrate.A[ 0 ] = 1. ; 

// FILTER
filttorigin.L = 1. ; filttorigin.n = 1. ; filttorigin.A[ 0 ] = 0. ; 

// FILTER TIME WINDOW LOWER BOUNDARY
filtwinlow.L = 1. ; filtwinlow.n = 1. ; filtwinlow.A[ 0 ] = 0. ; 

// FILTER TIME WINDOW UPPER BOUNDARY
filtwinhi.L = 1. ; filtwinhi.n = 1. ; filtwinhi.A[ 0 ] = -1. ; 




if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|M|P|D|w|y|K|_|=|t|I|Z|F|f|j|J|u|Q|g|G|T|l|L|V|S|b|e|p|i|H|m|x|y|z|X|Y|Z|B|q|C|W|c|d|s|a|A|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;

	    case 'w':   window_type = atoi(arg_option) ;
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

	    case 'K':   achannelout = atoi(arg_option) ;
			break;

	    case 'H':   dBlow = atof(arg_option) ;
			break;
	    case 'X':   dBhi = atof(arg_option) ;
			break;
	    case 'm':   freqlow = atof(arg_option) ;
			break;
	    case 'R':   freqhi = atof(arg_option) ;
			break;

	    case 'y':   autostop = atoi(arg_option) ;
			break;

            case 'p':	quiet = atoi(arg_option) ; 
			break;
            case 'i':	ampstatinc = atof(arg_option) ; 
			break;

	    case 'P':   strcpy(tempstring, arg_option);
			ptrans.fp = crackstring( tempstring, &ptrans ); 
			break;
	    case 'a':   strcpy(tempstring, arg_option);
			harmadd.fp = crackstring( tempstring, 
			    &harmadd );
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;
	    case 'F':   strcpy(tempstring, arg_option);
			filter.fp = crackstring_bin_only( tempstring, 
			    &filter );
			break;

// ****
	    case 'u':	imode = atoi(arg_option);
			break;
	    case 'Q':   strcpy(tempstring, arg_option);
			filttorigin.fp = crackstring( tempstring, 
			    &filttorigin );
			break;
	    case 'Y':   strcpy(tempstring, arg_option);
			filtrate.fp = crackstring( tempstring, 
			    &filtrate );
			break;

	    case 'g':   strcpy(tempstring, arg_option);
			filtwinlow.fp = crackstring( tempstring, 
			    &filtwinlow );
			break;
	    case 'G':   strcpy(tempstring, arg_option);
			filtwinhi.fp = crackstring( tempstring, 
			    &filtwinhi );
			break;

// ****
           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;



	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;
	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;

	    case 'B':   strcpy(tempstring, arg_option);
			Sound_B_dB.fp = crackstring( tempstring, 
			    &Sound_B_dB );
			break;
	    case 'q':   strcpy(tempstring, arg_option);
			Sound_A_dB.fp = crackstring( tempstring, 
			    &Sound_A_dB );
			break;
	    case 'Z':   strcpy(tempstring, arg_option);
			convolve_dB.fp = crackstring( tempstring, 
			    &convolve_dB );
			break;

	    case 'S':   strcpy(tempstring, arg_option);
			pan.fp = crackstring( tempstring, 
			    &pan );
			break;

	    case 'j':	panwarp_A = atof(arg_option);
			break;
	    case 'J':	panwarp_B = atof(arg_option);
			break;

	    case 't':	threshfacdB = atof(arg_option);
			break;
	    case 'h':   usage(1); } }


prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "CONVOLVE: SPECTRAL MULTIPLICATION", 69 ) ; 
prline( 69,  "-" ) ; 


// ** SOUND B
if( filter.n == 0. ){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A SOUND B - INPUT FILE. BYE.\n" ) ;
    exit(0); 
} 

    // READ IN FFT HEADER VALUES
    //readffthead(  &analysis_N,  &analysis_D,  &analysis_R,  &analysis_chan,  normamps, &filter ) ; 
    readffthead(  &analysis_N,  &analysis_D,  &analysis_R,  &analysis_chan, &itemp,  normamps, &filter ) ; 



// ************ TEST SIZE TO SEE IF DATA FILE IS POSSIBLY WRONG
    temp = ( ((filter.n  - (float) FFT_HEADER_SIZE ) / (float) (analysis_N + 2) ) != 0 ) ; 
    temp2 = temp - (float) ( (int) temp ) ; 
    if( (analysis_N <= 0) || (analysis_D <= 0) || (analysis_R <= 0) || 
	    (analysis_chan <= 0) || ( temp2 != 0. ) ){
	prt( "YOUR SOUND B ANALYSIS FILE HAS QUESTIONABLE DATA. BYE." ) ; 
	    pri( analysis_N,  "INPUT ANALYSIS: FFT SIZE" ) ; 
	    pri( analysis_R,  "INPUT ANALYSIS: SAMPLE RATE" ) ; 
	    pri( analysis_D,  "INPUT ANALYSIS: DECIMATION" ) ; 
	    pri( analysis_chan,  "INPUT ANALYSIS: NUMBER OF CHANNELS" ) ; 
	    pri( filter.n,  "INPUT ANALYSIS: FILE SIZE" ) ; 
	exit(0) ; 
    }

 		
fprintf( stderr,"\n*******************************************\n\n" ) ; 
    niframes = (((filter.n - (float) FFT_HEADER_SIZE) / (float) (analysis_N + 2))) / analysis_chan ; 
    analysis_dur = (float) (niframes) / ((float) analysis_R / (float) analysis_D ) ; 
    iframes_per_sec = (float) analysis_R /  (float) analysis_D ; 
    pri( niframes,  "NUMBER OF FRAMES IN ANALYSIS" ) ; 

// FILTER WINDOW BOUNDARIES
    if( filtwinhi.A[ 0 ] < 0.) filtwinhi.A[ 0 ] = analysis_dur ;

// **************************************************************
// GET PRELIMINARY SOUNDFILE NAME AND HEADER INFO

   ifile = argv[arg_index] ;

        exflag = getsfstats(ifile, &isr, &ichan, &idur, \
                &idata_offset, &iformat);

	if ( exflag == -2 ) {
	    banneri() ;
	    fprintf( stderr, "\n\n\t....FIX THE FORMAT OF YOUR INPUT FILE. BYE.\n\n" ) ;
	    exit(0) ; 
	}
	if( exflag == -1 ) {
	    banneri() ;
	    fprintf( stderr, "\n\n\t....FIX YOUR INPUT FILE (PATH)NAME. BYE.\n\n" ) ;
	    exit(0) ; 
	}
// **************************************************************

	
// **************************************************************

prbanner( "SOUND B:  ANALYSIS FILE",  69 ) ; 
prf( analysis_dur,	  "INPUT ANALYSIS: DURATION" ) ; 
pri( analysis_N,  "SOUND B ANALYSIS: FFT SIZE" ) ; 
pri( analysis_R,  "SOUND B ANALYSIS: SAMPLE RATE" ) ; 
prf( iframes_per_sec,  "SOUND B ANALYSIS: FRAMES PER SECOND" ) ; 
pri( analysis_D,  "SOUND B ANALYSIS:      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( analysis_chan,  "SOUND B ANALYSIS: NUMBER OF CHANNELS" ) ;
    
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............REDO ANALYSIS.  BYE.\n\n" ) ; exit(0) ; 
    }

// **************************************************************
// **** OUTPUT CHANNEL SETUP
// **************************************************************
    // SET channelflag TO  SPECIAL CASE -1 (PRESELECTED ochan)
    channelflag = -1 ;   
prbanner( "CHANNELS CONFIGURATION",  69 ) ; 

    if(channelout == 0){
	// ALL SOUND A CHANNELS
	if( achannelout == 0 ){
	    // *********ALL SOUND B CHANNELS: (ALL SOUND A)
	    // SET ochan TO SMALLER OF TWO

	    if(ichan != analysis_chan){
		// DIFFERENT NUMBER CHANNELS
		prt( "THE NUMBER OF CHANNELS IN YOUR SOUND B ANALYSIS FILE" );
		prt( "  AND YOUR SOUND A SOUND FILE DO NOT MATCH. WILL USE SMALLER OF TWO.");
		ochan = (ichan > analysis_chan) ? analysis_chan : ichan ; 
		pri( ochan, "AUTO-SELECTED NUMBER OF OUTPUT CHANNELS" ) ; 
	    }else{
		// MATCHING NUMBER OF CHANNELS
		ochan = ichan ; 
		prt( "\n ........NUMBER OF CHANNELS MATCH" ) ; 
		pri( ochan, "NUMBER OF OUTPUT CHANNELS" ) ; 
	    }

	}else{

	    // *********ONE SOUND B CHANNEL: (ALL SOUND A)
	    // SET ochan to SOUND A NUMBER OF CHANNELS
	    ochan = ichan ;


	}

    }else{
	// ONE SOUND A CHANNEL

	if( achannelout == 0 ){
	    // ********* ALL SOUND B CHANNELS: (ONE SOUND A)
	    ochan = analysis_chan ; 
	    prt( "USING SOUND B NUMBER OF OUTPUT CHANNELS FOR OUTPUT" ) ; 
	    pri( ochan, "NUMBER OF OUTPUT CHANNELS" ) ; 
	}else{
	    // ********* ONE SOUND B CHANNEL: (ONE SOUND A)
	    ochan = 1 ; 
	    prt( "ONE CHANNEL OUTPUT FILE" ) ; 
	}
	
    }
    prline( 10,  "." ) ; 

// **************************************************************
// ***** VERIFY ANALYSIS CHANNEL
// **************************************************************
    // SOUND A
    if( channelout != 0 ){
	// PARTICULAR SOUND A CHANNEL  SELECTED
	if( (channelout - 1) >= ichan ){
	    // NOT A SOUND A CHANNEL -- RESET TO 1 AND ANNOUNCE
	    prline( 1,  "*" ) ;
	    pri( channelout,  "\nSELECTED SOUND A CHANNEL" ) ;
	    prt( "DOES NOT EXIST. WILL RESET TO  1" ) ;
	    prline( 1,  "*" ) ;
	    channelout = 1 ;  
	}else{
	    // GOOD CHANNEL
	    if( achannelout == 0)
		prt( "\nTHE SELECTED SOUND A CHANNEL WILL BE APPLIED TO ALL SOUND B CHANNELS." ) ; 
	    pri( channelout,  "SELECTED SOUND A CHANNEL" ) ; 
	    prline( 1,  "*" ) ;
	}
    }

    // SOUND B
    if( achannelout != 0 ){
	// PARTICULAR SOUND B CHANNEL  SELECTED
	if( (achannelout - 1) >= analysis_chan ){
	    // NOT A SOUND B CHANNEL -- RESET TO 1 AND ANNOUNCE
	    prline( 1,  "*" ) ;
	    pri( achannelout,  "\nSELECTED SOUND B CHANNEL" ) ;
	    prt( "DOES NOT EXIST. WILL RESET TO  1" ) ;
	    prline( 1,  "*" ) ;
	    achannelout = 1 ;  
	}else{
	    // GOOD CHANNEL
	    if( channelout == 0)
		prt( "\nTHE SELECTED SOUND B CHANNEL WILL BE APPLIED TO ALL SOUND A CHANNELS." ) ; 
	    pri( achannelout,  "SELECTED SOUND B CHANNEL" ) ; 
	    prline( 1,  "*" ) ;
	}
    }
    prline( 69,  "-" ) ; 



// **************************************************************
// **************************************************************
 
// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    prbanner( "(SOUND A)",  69 ) ; 
    setupfiles(argc, argv) ; 

// **************************************************************
    N = analysis_N;
    D = analysis_D;
    frames_per_sec =  iframes_per_sec ; 

// **** SET UPS *****
    if(isr == analysis_R){
	// SAMPLE RATES MATCH
	R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    }else{
	// NO MATCH
	prf( isr, "\nSOUND A SAMPLE RATE" ) ; 
	prf( analysis_R, "SOUND B SAMPLE RATE" ) ; 
	prt( "\nYOUR SAMPLE RATES DO NOT MATCH,. ....BYE.\n\n" ) ;  exit(0) ; 
    }


    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

// ******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
// *********************************
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    fundamental = (float) R / (float) N ; 
// DECAY TIME STUFF
    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	
    IR = (float) I / (float) R ;

    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 

// SET UP FLAG FOR OSCIL BANK OR OVERLAP/ADD
    if( (ptrans.n  != 1.) || (harmadd.n  != 1.) || 
	    (ptrans.A[0] != 0.) || (harmadd.A[0] != 0.)  ) {
	// OSC BANK
	P = 1. ; obank = 1 ;  
    }else{
	// OVERLAPP-ADD
	P = 0. ; obank = 0 ;  
    }
    
// ***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 

prbanner( "SOUND A: ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
pri( tfactor,  "TIME EXPANSION/CONTRACTION FACTOR" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( I,  "      INTERPOLATION SAMPLES (samples between resynthesis frames)" ) ; 
prline( 1,  "*" ) ; 
prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (in dB)" ) ; 
prline( 1,  "*" ) ; 

prp( &dBgain,  "MASTER GAIN (in dB)"  ) ; 
prp( &ptrans,  "PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &harmadd,  "FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &attack,  "ENVELOPE ATTACK TIME (in seconds)"  ) ; 
prp( &release,  "ENVELOPE RELEASE TIME (in seconds)"  ) ; 
prline( 1,  "*" ) ; 


pri( imode,  "SOUND B: DATA MODE" ) ; 
prp( &filtrate,  "SOUND B: RATE MULTIPLIER"  ) ; 
prp( &filttorigin,  "SOUND B: TIME POINT-ORIGIN"  ) ; 
prp( &filtwinlow,  "SOUND B: TIME WINDOW LOWER BOUNDARY"  ) ; 
prp( &filtwinhi,  "SOUND B: TIME WINDOW UPPER BOUNDARY"  ) ; 


prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prf( freqlow, "LOW SHELF FREQUENCY" ) ; 
prf( dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prf( freqhi, "HIGH SHELF FREQUENCY" ) ; 
prf( dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
prt( "*...........................................*" ) ;  
prline( 1,  "*" ) ; 
// *******
prp( &Sound_A_dB,  "CONVOLUTION PANPOT: SOUND A DB"  ) ; 
prp( &Sound_B_dB,  "CONVOLUTION PANPOT: SOUND B DB"  ) ; 
prp( &convolve_dB,  "CONVOLUTION PANPOT: CONVOLUTION DB"  ) ; 
prline( 1,  "*" ) ; 

prp( &pan,  "CONVOLUTION PANPOT (-1 to +1)"  ) ; 
prf( panwarp_A,  "CONVOLUTION PANPOT: SOUND A DOMAIN WARP"  ) ; 
prf( panwarp_B,  "CONVOLUTION PANPOT: SOUND A DOMAIN WARP"  ) ; 
prline( 1,  "*" ) ; 


// ***************** SET UP ARRAYS


    pri( niframes,  "NUMBER OF FRAMES IN ANALYSIS" ) ; 
    fprintf( stderr,  "\nINPUT FILE WILL BE USED %f TIMES", 
	    (dur * ((float) R / (float) D) ) / (float) niframes )  ;

fprintf( stderr,"\n*******************************************\n\n" ) ; 

 
    temp2 = (float) R  / (float) I  ; 
fprintf( stderr,"\n******** CONVOLVE  OUPUT *******************" ) ; 
fprintf( stderr,"\nOUTPUT DURATION: %f seconds",  dur ) ; 
fprintf( stderr,"\nOUTPUT: %d frames/sec ", (int) temp2 ) ;  ; 
fprintf( stderr,"\nOUTPUT: %d total frames", (int) (temp2 * dur) ) ;

// **************

    

    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */

    fvec( C_buffer, N ) ;		/* CONVOLUTION FFT buffer */
    fvec( C_channel, N+2 ) ;	/* CONVOLUTION analysis channels */

    fvec( output, Nw ) ;	/* output buffer */
    fvec( previous_channel, N+2 ) ;	/* previous analysis channels */

// ***********
// SETUP FILTER CONTROL VALUES
	         // FILTER INCREMENT IN SECONDS
    filttinc =  (float) D / (float) R ; 
// ***********

// MAKE THRESH AMP
    threshfac = dB_to_amp(threshfacdB );	
    

// ALLOCATE INPUT FILE SPACE
    fvec( F,  N+2  ) ;	/* input array */
    fvec( Fbuffer,  N  ) ;	/* input Cartesian buffer */

    fvec( F_lower,  analysis_N+2  ) ;	/* lower filter array */
    fvec( F_higher,  analysis_N+2  ) ;	/* higher filter array */

// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 

// *********************************************
// LOOP FOR CHANNELS
// *********************************************

for(channow = 0; channow < ochan;channow++ ){

    // **** SET UP CHANNELS
    outchan = (channelout == 0) ? channow : (channelout - 1) ; 
    ainchan = (achannelout == 0) ? channow : (achannelout - 1) ; 

// SETUP FILTER CONTROL VALUES
    filttorigin.A[ 0 ] = fval( &filttorigin, dur, 0. );
    filttnow = filttorigin.A[ 0 ] ; // ACCUMULATED FILTER TIME POINT IN SECONDS

    prline( 69,   "=" ) ; 
    pri( (outchan+1), "SOUND A CHANNEL" ) ; 
    pri( (ainchan+1), "SOUND B CHANNEL" ) ; 

    
    
    // *****   REINITS
    frame_count = 0 ;    eof = 0 ; 
    autostopflag = 0 ; 


    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
	
//*************
    // SET AT DATA BEGIN
    fseek( filter.fp,  sizeof(float) * FFT_HEADER_SIZE,  SEEK_SET ) ; 
//*************

// *********************************************
// LOOP FOR FRAMES
// *********************************************

    while ( (!eof) && (autostopflag == 0) ) {
	in += D ;
	on += I ;
	timenow( dur ) ;


	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;



	// SETUP PREVIOUS CHANNEL
	    if( !frame_count )for(i = 0; i < N; i++ )
		    previous_channel[ i ] = channel[ i ] ; 


// *************
// FILTER TIME ISSUES

	// LOW WINDOW TIME POINT
		filtwinlow.A[ 0 ] = fval( &filtwinlow, dur, t );
		if(filtwinlow.A[ 0 ] < 0.)filtwinlow.A[ 0 ] = 0. ; 
		if(filtwinlow.A[ 0 ] > analysis_dur)filtwinlow.A[ 0 ] = analysis_dur ;  

	// HIGH WINDOW TIME POINT
		filtwinhi.A[ 0 ] = fval( &filtwinhi, dur, t );
		if(filtwinhi.A[ 0 ] > analysis_dur)filtwinhi.A[ 0 ] = analysis_dur ; 
		if(filtwinhi.A[ 0 ] < 0.)filtwinhi.A[ 0 ] = 0. ;

	// WINDOW SIZE
		temp = filtwinhi.A[ 0 ] - filtwinlow.A[ 0 ] ;  
		if( temp == 0. ){
		    // ZERO WINDOW SIZE
		    filttnow = filtwinlow.A[ 0 ] ; 
		}else if(temp < 0.){
		    // UPPER BENEATH LOWER
		    while(filttnow >= filtwinlow.A[ 0 ]){
			filttnow += temp ;
			prf( t, "CROSSED LOWER BOUNDARY (NOW ABOVE LOWER) AT TIME" ) ;
			if( autostop != 0 ) autostopflag = 1 ;  
		    } 
		    while(filttnow < filtwinhi.A[ 0 ]){
			filttnow -= temp ; 
			prf( t, "CROSSED UPPER BOUNDARY (NOW BENEATH LOWER) AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    }
		}else{
		    // REGULAR
		    while(filttnow >= filtwinhi.A[ 0 ]){
			filttnow -= temp ; 
			prf( t, "CROSSED UPPER BOUNDARY AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    }
		    while(filttnow < filtwinlow.A[ 0 ]){
			filttnow += temp ;
			prf( t, "CROSSED LOWER BOUNDARY AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    } 
		    
		}

//*************


// ******************************************************************************
// MAKE THE FILTER FRAME
// ******************************************************


		filtf = iframes_per_sec * filttnow ; // VIRTUAL FRAME 
		filtflow = (int) filtf ; // LOWER FRAME
		filtfhigh = filtflow + 1 ; // HIGHER FRAME
		filtfprop =  filtf - (float) filtflow ; // PROPORTIONAL POSITION BETWEEN FRAMES

// READ IN THE LOWER AND HIGHER FRAMES
	    
    if((t == 0.) || (filtflowold != filtflow)){
	// POSITION TO LOWER FRAME
		k = ((FFT_HEADER_SIZE + 
		    ((ainchan + (analysis_chan * filtflow) ) 
			    * (analysis_N + 2) ) ) * sizeof(float)) ; 
		fseek( filter.fp,  k,  SEEK_SET ) ; 
	// READ IN LOWER FRAME		
		fread( F_lower, sizeof(float), analysis_N+2, filter.fp ) ;
    
	// POSITION TO HIGHER FRAME
		k = ((FFT_HEADER_SIZE + 
		    ((ainchan + (analysis_chan * filtfhigh) ) 
			    * (analysis_N + 2) ) ) * sizeof(float)) ; 
		fseek( filter.fp,  k,  SEEK_SET ) ; 
	// READ IN HIGHER FRAME		
		fread( F_higher, sizeof(float) , analysis_N+2, filter.fp ) ;
    }

// MAKE INTERPOLATED FRAME
	for( i = 1; i < analysis_N; i +=2){
	    F[i - 1] = F_lower[i - 1] + (filtfprop * (F_higher[i - 1] - F_lower[i - 1])) ; 
	}

// USE FREQS FROM CLOSER ONE
	if( filtfprop < .5 ){
	    // LOWER
	    for( i = 1; i < N; i +=2) F[i] = F_lower[i]  ; 
	}else{
	    // UPPER
	    for( i = 1; i < N; i +=2) F[i] = F_higher[i]  ; 
	}

	
// SAVE OLD FRAME NUMBERS
		filtflowold = filtflow ; 
// INCREMENT FILTER TIME POINT
    // BRANCH FOR EXPLICIT OR RATE MODE
	if( imode == 0 ){
	    // EXPLCIT MODE
	// FIND THE TIME POINT ORIGIN
		filttorigin.A[ 0 ] = fval( &filttorigin, dur, t );
		filttnow = filttorigin.A[ 0 ] ; 
	} else{
	    // RATE MODE
   // FIRST GET THE FRAME RATE MULTIPLIER
		filtrate.A[ 0 ] = fval( &filtrate, dur, t );
		filttnow += (filttinc * filtrate.A[ 0 ]) ;
	}

		
// *****************************************************

// *************MAKE CARTESIAN ARRAY FROM  FREQ/MAGNITUDES FOR BOTH 
    	unconvert1( F, Fbuffer, N2, I, R ) ;
	

// ************MULTIPLY BUFFERS TOGETHER
    // FIND GREATEST PEAK BETWEEN THE TWO
    A_peak = RIfindpeak( buffer, N ) ; 
    B_peak = RIfindpeak( Fbuffer, N ) ; 
    AB_peak = A_peak > B_peak ? A_peak : B_peak ; 
    normamp = AB_peak == 0 ? 1. : 1. / AB_peak ; 

    // GET LEVELS
    Sound_A_dB.A[ 0 ] = fval( &Sound_A_dB, dur, t );
    Sound_B_dB.A[ 0 ] = fval( &Sound_B_dB, dur, t );
    convolve_dB.A[ 0 ] = fval( &convolve_dB, dur, t );


    // GET PAN POINT
    pan.A[ 0 ] = fval( &pan, dur, t ) ;
    pans = (float) fabs((double) pan.A[ 0 ] ) ; 
    temp = pan.A[ 0 ] < 0. ? (panwarp_A) :  (panwarp_B) ; 
    pans = curve( 0.,  1.,  pans, temp ) ;  
        
    // MAKE AMP LEVELS FROM DECIBELS
    A_dB = dB_to_amp( Sound_A_dB.A[ 0 ]/20.) * pans ;	
    B_dB = dB_to_amp( Sound_B_dB.A[ 0 ]/20.) * pans ;	
    C_dB = dB_to_amp(convolve_dB.A[ 0 ]/20.) * (1. - pans) ;	

    // MULTIPLY BUFFERS
        for(i = 0; i < N; i++){
	    C_buffer[i] = normamp * C_dB *  buffer[i] * Fbuffer[i] ; 
	}
// ************ NOW LEANCONVERT TO FREQ/MAGNITUDES
	leanconvert( C_buffer, C_channel, N2, D, R ) ;
    
// *************EQUALIZE THE  SPECTRUM
    eq( C_channel,  N,  dBlow,  dBhi, freqlow,  freqhi,  fundamental, 1,  0, 0 ) ; 


// ************ NOW LEANUNCONVERT 
	leanunconvert( C_channel, C_buffer, N2, D, R ) ;


// *********** NOW MIX PROPORTIONS IN CARTESIAN FORM
    if( pan.A[ 0 ] < 0. ){
        for(i = 0; i < N; i++){
	    buffer[i] = 
		C_buffer[i]  + (A_dB * buffer[i] ) ; 
	}
    }else{
        for(i = 0; i < N; i++){
	    buffer[i] = 
		C_buffer[i]  + (B_dB * Fbuffer[i]) ; 
	}
    }


// ************* NOW CONVERT


	  	  convert( buffer, channel, N2, D, R ) ;

// *************************
// GET THE VALUES
// *************************


//  SHIFT, GAIN, AND TRANSPOSITION

		harmadd.A[ 0 ] =  fval( &harmadd, dur, t );
		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp( dBgain.A[ 0 ] ) ; 
		ptrans.A[ 0 ] = fval( &ptrans, dur, t );
		    pm = semitones_to_mult( ptrans.A[ 0 ] ) ;

		release.A[ 0 ] = fval( &release, dur, t );
		smooth_setup( release.A[ 0 ], &envrelease, &minusrelease, IR ) ; 

		attack.A[ 0 ] = fval( &attack, dur, t );
		smooth_setup( attack.A[ 0 ], &envattack, &minusattack, IR ) ; 




// *************************

    // SMOOTH THE CHANGES TO THE SPECTRUM
    smooth( channel, previous_channel, N, envattack, minusattack, envrelease, minusrelease ) ; 


// *****************
// MODIFICATIONS LOOP
// *****************





		 for( i = 1, j = 0; i < N; i+= 2, j++ ){

		    // SHIFT BY -a AND TRANSPOSE BY -P

		    temp = pm * (channel[i] + harmadd.A[ 0 ]) ;
		    
		    // ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
		    if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
		   else channel[i] = temp ; 

		  channel[i - 1] = channel[i - 1] * gain ;  

		}
		

        synt = getthresh( channel, N, threshfac );
// ** OSCIL BANK OR OVERLAP/ADD OUT
	if ( obank ) {
	    noscbank(channel, N2, R, Nw, I, P, output);
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;
	} else {
	    unconvert( channel, buffer, N2, I, R ) ;

	    rfft( buffer, N2, INVERSE ) ;
	    overlapadd( buffer, N, Wsyn, output, Nw, on ) ;


	     shiftout( output, Nw, I, on, 0 ) ;
	
	}

	frame_count++ ; 

    // FRAMES LOOP END

    }
    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  
    fprintf(stderr,"\nCONVOLVE : RESYNTHESIS COMPLETED\n");
 



    if( harmadd.n != 1. ) fclose(harmadd.fp ) ;
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;
    if( ptrans.n != 1. ) fclose(ptrans.fp ) ;
    if( filter.n != 1. ) fclose(filter.fp ) ;
    if( Sound_A_dB.n != 1. ) fclose(Sound_A_dB.fp ) ;
    if( Sound_B_dB.n != 1. ) fclose(Sound_B_dB.fp ) ;
    if( convolve_dB.n != 1. ) fclose(convolve_dB.fp ) ;
    if( release.n != 1. ) fclose(release.fp ) ;
    if( attack.n != 1. ) fclose(attack.fp ) ;
    if( pan.n != 1. ) fclose(pan.fp ) ;
    if( filtrate.n != 1. ) fclose(filtrate.fp ) ;
    if( filttorigin.n != 1. ) fclose(filttorigin.fp ) ;
    if( filtwinlow.n != 1. ) fclose(filtwinlow.fp ) ;
    if( filtwinhi.n != 1. ) fclose(filtwinhi.fp ) ;

    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"convolve:  phase vocoder spectral multiplier\n"
	"convolve   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	    (values in brackets denote defaults)\n"
	"	      (FFT and framerate/decimation are taken from Sound B analysis file)\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  [0.] \n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"

	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (0. = end of file) [0.] \n"
	"	C:	resynthesis channel (1 -> ?) (0 = all) [0] \n"

	"	P:	pitch transposition of output spectrum in semitones (func) [0]\n"
	"	a:	frequency shift  of output spectrum \n"
	"		    (bin frequency adder, before -P )(func)[0.] \n"
	"	A:	gain in decibels of output (func) [0.] \n"

	"	F:	input analysis file - (sound B) \n"
	"	B:	Sound B gain in decibels (func) [0.] \n"
	"	q:	Sound A gain in decibels (func) [0.] \n"
	"	Z:	Convolution gain in decibels (func) [0.] \n"

	"	S:	CONVOLUTION PAN POT position between \n"
	"		    convolved sounds (-1 to 1) (func) [0] \n"
	"		    (-1 = A,  1 = B,  0 = convolution of A and B)\n"
	"	j:	CONVOLUTION PAN POT: Sound A domain warp [0.] \n"
	"	J:	CONVOLUTION PAN POT: Sound B domain warp [0.] \n"

	"	L:	envelope release time  (func) [0.]\n"
	"	l:	envelope attack time  (func) [0.]\n"

	"	u:	SOUND B data access mode [1]\n"
	"	K:	SOUND B channel (1 -> ?) (0 = all) [0] \n"
	"		   (0 = explicit time: Use -Q)\n"
	"		   (1 = rate mode: Use -Q as begin point, -Y as rate control) \n"
	"	Q:	SOUND B time point (func) [0.] \n"
	"	g:	SOUND B time window: lower boundary (func) [0.] \n"
	"	G:	SOUND B time window: upper boundary (func) [end of file] \n"
	"	Y:	SOUND B rate multiplier (func) [1.]\n"
	"		    (1. = rate of original, 2. = twice as fast, etc.)\n"
	"		    (negative = reverse,  0 = stationary) \n"
	"	y:	DATA auto stop: 0 = off,  1 = on [0]\n"
	"		    (When on,  auto stop will terminate synthesis when a\n"
	"		     time boundary in the SOUND B analysis is crossed.)\n"


	"	     CONVOLUTION OUTPUT LOW/HIGH SHELF EQ:(pre transpose/shift)\n"
	"	H:	FILTER SHELF EQ: Low shelf gain in dB [0.] \n"
	"	X:	FILTER SHELF EQ: High shelf gain in dB [0.] \n"
	"	m:	FILTER SHELF EQ: Low shelf frequency in Hz [200.] \n"
	"	R:	FILTER SHELF EQ: High shelf frequency in Hz [2000.] \n"


	"	t:	oscillator resynthesis threshold in decibels [-96.]\n"
	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 
	"	_:	 OUTPUT FORMAT: 0 = taken from input file\n"
	"		    1 = 16-bit integer, 2 = 32-bit floats [0]\n" 

	"	=:	 PEAK RESCALE LEVEL (float output only) 0 to -96 dB \n"
	"		    set to 1 to rescale to level of input file [ 1 ]\n" 


	);
    exit(woof);
}


int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

