#include "globals.h"
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>


/* CRACK STUFF */
int arg_index = 0;
char *arg_option;
char *pvcon = NULL;
char *index();



/************************************************************/

int main(argc,argv)
   int argc;
   char *argv[]; 
   {
   


    char	*filename, 
		ch, 
		crack()
    ;

    float norm=0.,  amplitude,  dB ; 
    int n = 0 ; 
    

#include "underflow.h"

 
/*GIVE USAGE AND EXIT IF NO ARGUMENTS */
   if(argc == 1) {
	fprintf( stderr,"%s",
	"USAGE:\n\n   dBtoamp decibel value(s)\n\n" 
	"   This routine prints out the amplitude for the decibel level(s).\n"
	"   ( amplitude = 10^( decibel / 20.) )\n\n"
	 );
	exit(0);
    }

    arg_index++ ; 
   if(arg_index >= argc) {
       // ABORT
       fprintf( stderr, "\n\nWHERE IS THE DECIBEL VALUE??\n\n" ) ;
       exit( 0 ) ; 
   }
    fprintf( stdout, "\n\n" ) ; 


    while(arg_index < argc){ 
  
      /* GET DECIBEL VALUE */
       dB = atof(argv[arg_index]) ;
       //dB = dB + norm ; 
       amplitude = pow( 10., (double) (dB / 20.) ) ; 
       
       fprintf( stdout, "\nDECIBEL LEVEL:\t%-6.2f dB\tAMPLITUDE:\t%-f",  dB,  amplitude ) ; 

	arg_index++ ; 
    }

    fprintf( stdout, "\n\n" ) ; 
    exit( 1 ) ; 
}


char crack(argc, argv, flags, ign)
    int argc; char **argv; char *flags; int ign;
{
    char *pv, *flgp, *index();
    while ((arg_index) < argc)
	{
	if (pvcon != NULL)
	    pv = pvcon;
	else
	    {
	    if (++arg_index >= argc) return(0); 
	    pv = argv[arg_index];
	    if (*pv != '-') 
		return(0);
	    }
	pv++;		/* skip '-' or prev. flag */
	if (*pv != 0) 
	    {
	    if ((flgp=index(flags, *pv)) != NULL)
		{
		pvcon = pv;
		if (*(flgp+1) == '|') { arg_option = pv+1; pvcon = NULL; }
		return(*pv);
		}
	    else
		if (!ign)
		    {
		    fprintf(stderr, "\n\n%s: no such flag: %s\n", argv[0], pv);
		    return(EOF);
		    }
		else
		    pvcon = NULL;
	    }
	pvcon = NULL;
	}
    return(0);
    }

