#include "globals.h"
#define NUM_PARAMETERS 4

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k, l,  i1,  i2, ipartial,  bug=0, exflag=0, 
     mm,  n,  NC, NCmult2, NCdiv2,   np,   *binpt  ;
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag=0,   channelout=0;
float P = 1.0;
FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, 
    *buffer, *channel,  *output ;
float *previous_channel,  *F,  *FT,  *SUM,  *harmony, *ampfreq,   pmt,  pms  ; 
float threshfac = .001,  threshfacdB=-96. ;
float	random_seed, gain=1. ;
float lowfreq,  hifreq,  dur ; 
float  temp,  temp2,  temp3,  temp4,  temp5,  temp6 ;  
float getthresh();
float   IR ;

float dBedge=0 ;
int beginchan,  endchan ; 
int sourceflag=1 ; 

FILE *data ; 
char datafile[ 128 ] = "EMPTY\0",  new_datafile[ 128 ] ; 
float *PP,  fundamental,  target_gain,  SOURCE_gain,  midC ; 
int window_format=0, shift_format=0,   nd=0 ; 
char tempstring[ 128 ] ; 

// GAIN
struct  func  dBgain ; 

// SOURCE  FREQUENCY SHIFT ADDER
struct  func  SOURCE_harmadd ; 

// SOURCE  PITCH TRANSPOSITION IN SEMITONES
struct  func  SOURCE_ptrans ; 

// SOURCE DECIBELS
struct  func  SOURCE_dB ; 



// TARGET DECIBELS
struct  func  target_dB ; 

// TARGET  FREQUENCY SHIFT ADDER
struct  func  target_harmadd ; 

// TARGET  PITCH TRANSPOSITION IN SEMITONES
struct  func  target_ptrans ; 



// SPECTRUM WARPSHAPE INDEX
struct  func  warpshape ; 


#include "underflow.h"


//*****************INITIALIZE
// SOURCE  FREQUENCY SHIFT ADDER
SOURCE_harmadd.L = 1. ; SOURCE_harmadd.n = 1. ; SOURCE_harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// SOURCE  PITCH TRANSPOSITION IN SEMITONES
SOURCE_ptrans.L = 1. ; SOURCE_ptrans.n = 1. ; SOURCE_ptrans.A[ 0 ] = 1. ; 

// TARGET DECIBELS
target_dB.L = 1. ; target_dB.n = 1. ; target_dB.A[ 0 ] = 0. ; 

// SOURCE DECIBELS
SOURCE_dB.L = 1. ; SOURCE_dB.n = 1. ; SOURCE_dB.A[ 0 ] = 0. ; 

// TARGET  PITCH TRANSPOSITION IN SEMITONES
target_ptrans.L = 1. ; target_ptrans.n = 1. ; target_ptrans.A[ 0 ] = 1. ; 

// TARGET  FREQUENCY SHIFT ADDER
target_harmadd.L = 1. ; target_harmadd.n = 1. ; target_harmadd.A[ 0 ] = 0. ; 

// SPECTRUM WARPSHAPE INDEX
warpshape.L = 1. ; warpshape.n = 1. ; warpshape.A[ 0 ] = 0. ; 



if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|M|W|w|P|D|t|I|B|_|=|F|f|T|C|p|i|u|b|e|v|G|V|K|k|l|L|Z|z|V|S|H|m|q|X|W|c|d|s|a|A|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'w':   window_type = atoi(arg_option) ;
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

            case 'p':	quiet = atoi(arg_option) ; break;
            case 'i':	ampstatinc = atof(arg_option) ; break;

	    case 'W':   strcpy(tempstring, arg_option);
			warpshape.fp = crackstring( tempstring, 
			    &warpshape );
			break;




// SOURCE
	    case 'a':   strcpy(tempstring, arg_option);
			SOURCE_harmadd.fp = crackstring( tempstring, 
			    &SOURCE_harmadd );
			break;
	    case 'P':   strcpy(tempstring, arg_option);
			SOURCE_ptrans.fp = crackstring( tempstring, &SOURCE_ptrans ); 
			break;
	    case 'G':   strcpy(tempstring, arg_option);
			SOURCE_dB.fp = crackstring( tempstring, 
			    &SOURCE_dB );
			break;

// TARGETS

	    case 'q':   strcpy(tempstring, arg_option);
			target_harmadd.fp = crackstring( tempstring, 
			    &target_harmadd );
			break;
	    case 'X':   strcpy(tempstring, arg_option);
			target_ptrans.fp = crackstring( tempstring, 
			    &target_ptrans );
			break;
	    case 'm':   strcpy(tempstring, arg_option);
			target_dB.fp = crackstring( tempstring, 
			    &target_dB );
			break;

           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;



	    case 'Z':   window_format = atoi(arg_option) ;
			break;
	    case 'z':   shift_format = atoi(arg_option) ;
			break;

	    case 'F':   strcpy(datafile, arg_option);
			break;

	    case 'B':   dBedge = atoi(arg_option) ;
			break;
	    case 't':   threshfacdB = atof(arg_option);
			break;
	    case 'h':	usage(1);
	}
    }
 

prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "HARMONIZER", 69 ) ; 
prline( 69,  "-" ) ; 

    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
 
// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 
    
// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 

    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
//*********************************


    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    IR = (float) I / (float) R ; 

    obank = P != 0. ;
    if( P == 0.0 ) {P = 1.0;}

    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    midC = (220.*pow(2., (3./12.))) ; 
    fundamental = (float) R / (float) N ; 

    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 

//***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 

prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
pri( tfactor,  "TIME EXPANSION/CONTRACTION FACTOR" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( I,  "      INTERPOLATION SAMPLES (samples between resynthesis frames)" ) ; 
prline( 1,  "*" ) ; 
prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (in dB)" ) ; 
prline( 1,  "*" ) ; 
prp( &dBgain,  "MASTER GAIN (in dB)"  ) ; 
prline( 1,  "*" ) ; 
prp( &target_dB,	"TARGETS: GAIN (in dB)"  ) ; 
prp( &target_ptrans,  "TARGETS: PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &target_harmadd,  "TARGETS: FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &SOURCE_dB,	"SOURCE: GAIN (in dB)"  ) ; 
prp( &SOURCE_ptrans,  "SOURCE: PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &SOURCE_harmadd,  "SOURCE: FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &warpshape, "SPECTRUM WARPSHAPE INDEX" ) ; 
prline( 1,  "*" ) ; 

//***************** 

if( datafile ==  "EMPTY\0" ){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A DATA FILE. BYE.\n" ) ;
    exit(0);
}

//****** TURN SOURCE ON OR OFF
if( (SOURCE_dB.A[0] > threshfacdB) || (SOURCE_dB.n != 1.)){
    // INCLUDE SOURCE
    sourceflag = 1 ;
    fprintf( stderr, "\n SOURCE SOUND INCLUDED......." ) ; 
    fprintf( stderr, "\n\t(SOURCE DECIBEL LEVEL BASED ON FUNCTION, \n\tOR IS > RESYNTHESIS THRESHOLD OF %f dB)", 
	threshfacdB ) ; 

}else{
    // EXCLUDE SOURCE
    sourceflag = 0 ; 
    fprintf( stderr, "\n ====> * SOURCE SOUND EXCLUDED * <=======" ) ; 
    fprintf( stderr, "\n\t(SOURCE DECIBEL LEVEL  < RESYNTHESIS THRESHOLD OF %f dB)", 
	threshfacdB ) ; 
}
//***************** 
    

//****** MAKE ARRAYS
    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, (N+2) ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
//***************** 


// MAKE THRESH AMP
    threshfac = pow( (double) 10.0, (double) (threshfacdB / 20.) );	


// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 



//**************************GET DATA	
// READ IN LEVELS


// MAKE NEW DATA FILE WITH COMMENTED LINES REMOVED

    cut_data_lines( datafile,  new_datafile,  NUM_PARAMETERS ) ; 


// OPEN FILE
  	if( (data = fopen( new_datafile, "r")) == NULL ){
	    fprintf( stderr, "\n%s <-- NO SUCH FILE. BYE.\n",  datafile ) ; 
	    exit(0); 
	}





// COUNT VALUES IN FILE
	k = 0 ; 
	while( fscanf( data,  " %f ",  &temp ) != EOF ) k++ ; 			
	rewind( data ) ;    
// ALLOCATE SPACE FOR LEVELS
    fvec( PP, k ) ;	/* LEVELS */
// COMPUTE NUMBER OF LEVELS
    np = k / NUM_PARAMETERS ;


prline( 69,  "-" ) ;
prbanner( "HARMONIZER: DATAFILE VALUES", 69 ) ; 
prline( 69,  "-" ) ;
	fprintf( stderr,  "\n****************************************************" ) ; 
if(window_format == 0){


    if( shift_format == 0 ){
	fprintf( stderr,  "\nFrequency   |Low Boundary|Hi  Boundary|Decibels    |" ) ; 
	fprintf( stderr,  "\nMultiplier  |Frequency   |Frequency   |            |" ) ; 
	fprintf( stderr,  "\n            |(-1 = 0 Hz) |(-1=Nyquist)|            |" ) ; 
    }else if( shift_format == 1 ){
	fprintf( stderr,  "\nFrequency   |Low Boundary|Hi  Boundary|Decibels    |" ) ; 
	fprintf( stderr,  "\nAdder       |Frequency   |Frequency   |            |" ) ; 
	fprintf( stderr,  "\n            |(-1 = 0 Hz) |(-1=Nyquist)|            |" ) ; 
    }else if( shift_format == 2 ){
	fprintf( stderr,  "\nSemitones   |Low Boundary|Hi  Boundary|Decibels    |" ) ; 
	fprintf( stderr,  "\nof Trans-   |Frequency   |Frequency   |            |" ) ; 
	fprintf( stderr,  "\nposition    |(-1 = 0 Hz) |(-1=Nyquist)|            |" ) ; 
    }else{
	fprintf( stderr,  "\nILLEGAL SHIFT METHOD FORMAT. BYE.\n\n" ) ; 
	exit( 0 ) ; 
    }
    
}else if(window_format == 1){


    if( shift_format == 0 ){
	fprintf( stderr,  "\nFrequency   |Low Boundary|Hi  Boundary|Decibels    |" ) ; 
	fprintf( stderr,  "\nMultiplier  |Oct.Pclass  |Oct.Pclass  |            |" ) ; 
	fprintf( stderr,  "\n            |(-1 = 0 Hz) |(-1=Nyquist)|            |" ) ; 
    }else if( shift_format == 1 ){
	fprintf( stderr,  "\nFrequency   |Low Boundary|Hi  Boundary|Decibels    |" ) ; 
	fprintf( stderr,  "\nAdder       |Oct.Pclass  |Oct.Pclass  |            |" ) ; 
	fprintf( stderr,  "\n            |(-1 = 0 Hz) |(-1=Nyquist)|            |" ) ; 
    }else if( shift_format == 2 ){
	fprintf( stderr,  "\nSemitones   |Low Boundary|Hi  Boundary|Decibels    |" ) ; 
	fprintf( stderr,  "\nof Trans-   |Oct.Pclass  |Oct.Pclass  |            |" ) ; 
	fprintf( stderr,  "\nposition    |(-1 = 0 Hz) |(-1=Nyquist)|            |" ) ; 
    }else{
	fprintf( stderr,  "\nILLEGAL SHIFT METHOD FORMAT. (0,  1,  or 2)  BYE.\n\n" ) ; 
	exit( 0 ) ; 
    }

}else{
	    fprintf( stderr, "\n\nILLEGAL WINDOW DATA FORMAT. (0 or 1 please.) BYE....!\n\n" ) ; 
	    exit(0) ; 
}
    fprintf( stderr,  "\n...................................................|" ) ; 
















// READ IN VALUES
k = 0 ; 
for( i = 0; i < np ; i++ ){
    fprintf( stderr,  "\n" ) ;
    for( j = 0; j < NUM_PARAMETERS ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	    fprintf( stderr,  "%-12.3f|", PP[ k ]  ) ;
	     k++ ; 			
    }
} 
    fprintf( stderr,  "\n****************************************************" ) ; 
    fprintf( stderr,  "\n\n" ) ; 
    

//************************************
// SET UP THE ARRAY POINTING AT THE BINS AND THEIR AMPLITUDES
    // FIRST TIME LOOP TO ACCESS ARRAY SIZE NEEDED
  for(l = 0 ; l < 2 ; l++ ){
    mm = 0 ; 
    // LOOP FOR  LEVELS

    for( j = 0; j < (np*NUM_PARAMETERS) ; j += NUM_PARAMETERS ){

	    // SHIFT VALUE
	    if( shift_format == 0){
 		// MOVE FREQUENCY MULTIPLIER INTO TEMP
		temp = PP[j] ;
	    }else if( shift_format == 1){
		// MOVE FREQ ADDER INTO TEMP
		temp = PP[j] ;
	    
	    }else{
		// MAKE FREQ MULTIPLIER FROM SEMITONES OF TRANSPOSITION
		// AND PUT IN TEMP
		temp = semitones_to_mult( PP[j] ) ;		
	    }
	    
	// FIND THE LOW AND HIGH FREQUENCY BOUNDARIES
	if( window_format == 0 ){

		    // FREQUENCY BOUNDARY FORMAT
	    if( PP[j + 1] < 0.) lowfreq = 0; else lowfreq = PP[j + 1] ; 
	    if( PP[j + 2] < 0.) hifreq = nyquist;  else hifreq = PP[j + 2] ; 

	} else if(window_format == 1) {

	// TRANSLATE OCTAVE.PT.PITCHCLASS INTO LOW AND HIGH FREQUENCY BOUNDARIES

		if( PP[j + 1] > 15. ){
		    // QUESTIONABLE
		    prf( PP[j + 1],  "\n\n ====> WARNING: HARMONIZER LOW BAND PASS BOUNDARY (IN OCTAVE.PCLASS)" ) ; 
		    prt( "QUESTIONABLE DATA.............................." ) ;  
		    exflag = 1 ;  ;  
		} 
		if( PP[j + 2] > 15. ){
		    // QUESTIONABLE
		    prf( PP[j + 2],  "\n\n ====> WARNING: HARMONIZER HIGH BAND PASS BOUNDARY (IN OCTAVE.PCLASS)" ) ; 
		    prt( "QUESTIONABLE DATA.............................." ) ;  
		    exflag = 1 ;  ;  
		} 

	    if( exflag ){
		prt( "\n\nIS YOUR DATA TYPE FLAG CORRECT?\n\n.......................CHECK YOU DATA.\n\n" ) ; 
		exit(0) ; 
	    }
	    
	    if( PP[j + 1] < 3.){
		 lowfreq = 0;
	    }else{
		lowfreq = (float) ((int) PP[j + 1] ) ; // INTEGER PART
		lowfreq =  (( 12. * (lowfreq - 8.)) + 
		    (100. * (PP[j + 1] - lowfreq)) ) / 12. ;
		lowfreq = midC * pow( 2., (double) lowfreq ) ; 
	    }

	    if( PP[j + 2] < 3.){
		 hifreq = nyquist;
	    }else{
		hifreq = (float) ((int) PP[j + 2] ) ; // INTEGER PART
		hifreq =  (( 12. * (hifreq - 8.)) + 
		    (100. * (PP[j + 2] - hifreq)) ) / 12. ;
		hifreq = midC * pow( 2., (double) hifreq ) ; 
	    }
 
	}else{
	    fprintf( stderr, "\n\nBAD DATA FORMAT. (0 or 1 please.) BYE....!\n\n" ) ; 
	    exit(0) ; 
	}

	if( lowfreq < 0. ) lowfreq = 0. ; 
	if( hifreq > nyquist) hifreq = nyquist ; 
//***

	// LOOP FOR WINDOW BAND
	i1 = (2 * ((int)(.5 + (lowfreq / fundamental)))) + 1 ; 
	i2 = (2 * ((int)(.5 + (hifreq / fundamental)))) + 1 ;
	if( i2 < i1 )
	    { j = i1 ; i1 = i2 ; i2 = j ; }

	
	// LOOP FOR THE BINS
	for(i = i1; i <= i2; i += 2){

	    // IN THE NEXT (ipartial-i1)*2 SPACES IN THE FILTER ARRAY 
	    // PLACE THE APPROPRIATE AMP VALUE FOR THIS LEVEL
	    
	    // IF IN RANGE.....
	    if((i > 0) && (i < N) ){

	    // THE BIN INDEX
	    if( l == 1) binpt[ mm ] = i ; 
	    // THE AMPFREQ TRANSFORMATION VALUES
	    // AMP
	    if( l == 1) ampfreq[ (mm * 2) ] = (float)  pow( (double) 10.0, (double) (PP[j + 3]/20.) ) ; ; 
	    // FREQ
	    if( l == 1) ampfreq[ (mm * 2) + 1 ] = temp ; 

		mm++ ; 


	    }
	}







      
// END LEVELS LOOP
     }

// fprintf( stderr,  "\nmm = %d",  mm ) ; 

    
	// MAKE  ARRAYS
	if(l == 0)fvec( ampfreq, (mm*2) ) ;
	if(l == 0)ivec( binpt, mm ) ;
    
}
   
    
    NC = mm ; NCmult2 = NC * 2 ;   
//    fprintf( stderr, "\nNC: %d,  NCmult2: %d", NC,   NCmult2 ) ;    
	// MAKE  ARRAY
	fvec( harmony, (NCmult2+2) ) ;

    for( mm = 0 ; mm < NC ; mm++ ){
	    if(bug)fprintf( stderr,  "\nbinpt: %d,  amp: %f,  freq: %f ",  
		binpt[ mm ],  ampfreq[ mm * 2], ampfreq[ (mm * 2) + 1]  ) ;  
   }



//************************************
//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 



   makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;

 	
//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
	in += D ;
	on += I ;
	timenow( dur ) ;

	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
	  	  convert( buffer, channel, N2, D, R ) ;



//*************************
// GET THE VALUES
//*************************

//  SHIFT, GAIN, AND MULTIPLIER

		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp( dBgain.A[ 0 ] ) ; 
// TARGETS
		target_harmadd.A[ 0 ] =  fval( &target_harmadd, dur, t );
		target_ptrans.A[ 0 ] = fval( &target_ptrans, dur, t );
		    pmt = semitones_to_mult( target_ptrans.A[ 0 ] ) ;
		target_dB.A[ 0 ] =  fval( &target_dB, dur, t );
		    target_gain = dB_to_amp( target_dB.A[ 0 ] ) ; 

		warpshape.A[ 0 ] =  fval( &warpshape, dur, t );


// SOURCE
		if(sourceflag){
		    SOURCE_harmadd.A[ 0 ] =  fval( &SOURCE_harmadd, dur, t );
		    SOURCE_ptrans.A[ 0 ] = fval( &SOURCE_ptrans, dur, t );
			pms = semitones_to_mult( SOURCE_ptrans.A[ 0 ] ) ;
		    SOURCE_dB.A[ 0 ] =  fval( &SOURCE_dB, dur, t );
			SOURCE_gain = dB_to_amp( SOURCE_dB.A[ 0 ] ) ; 

		}




//***********************************


// MAKE TRANSFER TO HARMONY ARRAY
	for( mm = 0 ; mm < NC ; mm++ ){
	    // AMP

		harmony[ (mm * 2) ] = 
		    channel[ binpt[ mm ] - 1 ]  * ampfreq[ mm * 2 ] 
			* gain * target_gain ;  

	    // FREQ
		if( shift_format == 1 ){
		    // FREQ ADDER
		    harmony[ (mm * 2) + 1 ] = 
			((channel[ binpt[ mm ] ]  + ampfreq[ (mm * 2) + 1 ])
			+  target_harmadd.A[ 0 ] ) * pmt ;

		}else{
		    // FREQ MULTIPLIER
		    harmony[ (mm * 2) + 1 ] = 
			((channel[ binpt[ mm ] ]  * ampfreq[ (mm * 2) + 1 ])
			+  target_harmadd.A[ 0 ] ) * pmt ;
		}
	}



if(bug)fprintf( stderr,  "\n************************" ) ; 
if(bug)for( j = 1; j < NCmult2; j += 2){
    fprintf( stderr,  "\n%d)harmony array--> NCmult2: %d,  freq: %f,  amp: %f",
	  j, NCmult2,  harmony[j],  harmony[j - 1] ) ; 
}



//*****************
// MODIFICATIONS 
//*****************


//*********************************************************

		    

// **************** SOURCE
		 if(sourceflag){
		    for( i = 1; i < N; i = i + 2){
			// MODIFY SOURCE

			// **FREQ
			temp = pms * (channel[i] + SOURCE_harmadd.A[ 0 ]) ;
			// **AMP
			channel[i - 1] = channel[i - 1] * SOURCE_gain * gain ; 

			// ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
			if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
			else channel[i] = temp ; 
		    }
		 }

// *************   
		    // harmony OUT OF BOUNDS?
		 for( i = 1; i < NCmult2; i += 2 ){
 		    if((harmony[ i ] <= 0.) || (harmony[ i ] >= nyquist)) harmony[i - 1] = 0. ; 
		}


// ******
    //*************WARP THE INPUT SPECTRUM
    spectmagwarp( harmony,  NCmult2, warpshape.A[ 0 ], 0 ) ;		



	    if(sourceflag){
		synt = getthresh( channel, N, threshfac );
		temp = getthresh( harmony, NCmult2, threshfac );
		if(temp > synt) synt = temp ; 
	    }else{
		synt = getthresh( harmony, NCmult2, threshfac );
	    }


	    if(sourceflag){
		// DO BOTH
		if( !frame_count )prt( "RESYNTHESIZING BOTH SOURCE AND HARMONIZED PORTIONS....." ) ; 
		noscbank2( channel, N2, R, Nw, I, P, output, harmony,  NC );
	    }else{
	    // ONLY HARMONIZER
		if( !frame_count )prt( "RESYNTHESIZING  HARMONIZED PORTIONS ONLY....." ) ; 
		noscbank(harmony, NC, R, Nw, I, P, output);
	    }
	    
	    // NOW OUTPUT
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;

	    frame_count++ ; 
// FRAMES LOOP END

    }

    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  






    fprintf(stderr,"\n\nHARMONIZER : RESYNTHESIS COMPLETED\n");







 
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;

    if( SOURCE_harmadd.n != 1. ) fclose(SOURCE_harmadd.fp ) ;
    if( SOURCE_ptrans.n != 1. ) fclose(SOURCE_ptrans.fp ) ;
    if( SOURCE_dB.n != 1. ) fclose(SOURCE_dB.fp ) ;

    if( target_harmadd.n != 1. ) fclose(target_harmadd.fp ) ;
    if( target_ptrans.n != 1. ) fclose(target_ptrans.fp ) ;
    if( target_dB.n != 1. ) fclose(target_dB.fp ) ;
    if( warpshape.n != 1. ) fclose(warpshape.fp ) ;

  
    fclose( data ) ; 
 


    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"harmonizer:  multiple level, phase vocoder harmonizer \n"
	"		    with selectable frequency-band window \n"
	"harmonizer   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  \n"
	"		    2 = Blackman,  3 = Bartlett triangular [0.]\n"
	"	D:	analysis frames per second [200]\n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"
	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (-1. = end of file) [0.] \n"
	"	C:	resynthesis channel(s) (1 -> ?) (0 = all) [0] \n"

	"	A:	MASTER: gain in decibels (func) [0.] \n"
	"	a:	SOURCE: frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func)[0.] \n"
	"	P:	SOURCE: pitch transposition in semitones (func) [0]\n"
	"	G:	SOURCE: gain control in decibels (func) [0.] \n"
	"	q:	HARMONIZER: frequency shift factor \n"
	"		    (bin frequency adder, before -X )(func)[0.] \n"
	"	X:	HARMONIZER: pitch transposition in semitones (func) [0]\n"
	"	m:	HARMONIZER: gain control in decibels (func) [0.] \n"
	"	F:	(ascii) DATA FILE of unordered quartets:\n"
	"		  Each consisting of: \n"
	"		    (1) shift factor (see -z for format) \n"
	"		    (2) window: low boundary  (see -Z for format)  \n"
	"		    (3) window: high boundary (see -Z for format)  \n"
	"		    (4) decibels \n"
	"	Z:	DATA FILE window boundary format [0]\n"
	"		     0 = frequency\n"
	"		     1 = octave.pitchclass\n"
	"	z:	DATA FILE shift method format [0]\n"
	"		     0 = frequency multipler\n"
	"		     1 = frequency adder\n"
	"		     2 = semitones of transposition\n"
	"	W:	HARMONIZER: warp index for reshaping magnitude response (func) [0.] \n"
	"		    Values > 0 expand the dynamic range, \n"
	"		    values < 0 compress the dynamic range. \n"
	"	t:	oscillator resynthesis threshold in decibels [ -60 ]\n"
	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 

	"	_:	 OUTPUT FORMAT: 0 = taken from input file\n"
	"		    1 = 16-bit integer, 2 = 32-bit floats [0]\n" 

	"	=:	 PEAK RESCALE LEVEL (float output only) 0 to -96 dB \n"
	"		    set to 1 to rescale to level of input file [ 1 ]\n" 

	);
    exit(woof);
}


int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

