#include "globals.h"
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>


/* CRACK STUFF */
int arg_index = 0;
char *arg_option;
char *pvcon = NULL;
char *index();



/************************************************************/

int main(argc,argv)
   int argc;
   char *argv[]; 
   {
   


    char	*filename, 
		ch, 
		crack()
    ;

    float norm=0.,midC,   octpch,  Hz,  temp1,  temp2,  log_two, reference ; 
    int n = 0 ; 
    

#include "underflow.h"

 
/*GIVE USAGE AND EXIT IF NO ARGUMENTS */
   if(argc == 1) {
	fprintf( stderr,"%s",
	"USAGE:\n\n   pitchtoHz octave.pitch class value(s)\n\n" 
	"   This routine prints out the frequency\n"
	"    for the specified octave.pitch class value(s).\n\n"
	 );
	exit(0);
    }

#ifdef __sgi
	log_two=flog10(2.) ;  
#else
	log_two = (float) log10(2.) ;  
#endif
	reference = 220. * (pow(2.,3./12.)) ;  
    midC = (220.*pow(2., (3./12.))) ; 

    arg_index++ ; 
    fprintf( stdout, "\n\n" ) ; 


    while(arg_index < argc){ 
  
      /* GET OCTAVE.PITCH CLASS VALUE */
       octpch = atof(argv[arg_index]) ;

	// TRANSFORM 
	temp1 = (float) ((int) octpch ) ; // INTEGER PART
	temp1 =  (( 12. * (temp1 - 8.)) + 
	    (100. * (octpch - temp1)) ) / 12. ;
	Hz = midC * pow( 2., (double) temp1 ) ; 

       
       fprintf( stdout, "\nOCT.PCH:\t%-6.2f\tFREQUENCY:\t%-f Hz", octpch,  Hz ) ; 

	arg_index++ ; 
    }

    fprintf( stdout, "\n\n" ) ; 
    exit( 1 ) ; 
}


char crack(argc, argv, flags, ign)
    int argc; char **argv; char *flags; int ign;
{
    char *pv, *flgp, *index();
    while ((arg_index) < argc)
	{
	if (pvcon != NULL)
	    pv = pvcon;
	else
	    {
	    if (++arg_index >= argc) return(0); 
	    pv = argv[arg_index];
	    if (*pv != '-') 
		return(0);
	    }
	pv++;		/* skip '-' or prev. flag */
	if (*pv != 0) 
	    {
	    if ((flgp=index(flags, *pv)) != NULL)
		{
		pvcon = pv;
		if (*(flgp+1) == '|') { arg_option = pv+1; pvcon = NULL; }
		return(*pv);
		}
	    else
		if (!ign)
		    {
		    fprintf(stderr, "\n\n%s: no such flag: %s\n", argv[0], pv);
		    return(EOF);
		    }
		else
		    pvcon = NULL;
	    }
	pvcon = NULL;
	}
    return(0);
    }

