#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k,  i1,  i2;
float i1p,  i2p ; 
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int analysis_N, analysis_N2,   analysis_D, analysis_R, analysis_chan,  niframes ;  
float analysis_dur,  iframes_per_sec ; 
int   eof = 0, obank = 0,  sflag = 0,  channelout=0,  achannelout=0 ;
int pitchflag=0; 
 float P = 1.0;
  FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel,  *F, *Ffreq,  *previous_F,  *F_lower,  *F_higher ; 
float threshfac = .001,  threshfacdB=-60 ;
float	pm, fm, fs,  gain=1.;
double ar_dB ; 
float  temp,  temp2,  temp3 ;  
float getthresh();
float normamp[4] ;
float diff ; 
float   IR,  dur=0.;
float fundamental ;
float filtframenow=0. ; 
float analysis_fundamental, N_ratio,  sourceamp,  filtamp ;  
int limitcount=0,  bandrejecton=0 ; 
int ainchan ; 
// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 

float fdmdiff,  fdpm, fdbm,   fsdiff,  fdevminus ; 

int autostop=0,  autostopflag=0 ; 

float releasec,  minusreleasec,  attackc,  minusattackc ; 
float freleasec,  minusfreleasec,  fattackc,  minusfattackc ; 

//** FILTER VARIABLES
float filttnow=0.,   filttinc,  filtf, filtfprop  ; 
int filtflow,  filtflowold=0,  filtfhigh,  imode=1. ; 

int beginchan,  endchan ; 

char tempstring[ 128 ] ; 

// FREQUENCY SHIFT ADDER
struct  func  harmadd ; 

// GAIN
struct  func  dBgain ; 

// PITCH MULTIPLIER
struct  func  ptrans ; 

//  BIN AMP SOURCE dB
struct  func  sourcedB ; 

//  RELEASE
struct  func  release ; 

//  ATTACK
struct  func  attack ; 

// FILTER
struct  func  filter ; 

// ****
//  FILTER  RATE
struct  func  filtrate ; 

// FILTER TIME POINT ORIGIN
struct  func  filttorigin ; 

// FILTER TIME WINDOW LOWER BOUNDARY
struct  func  filtwinlow ; 

// FILTER TIME WINDOW UPPER BOUNDARY
struct  func  filtwinhi ; 

//  FILTER COMPRESSION THRESHOLD
struct  func  filtcompthresh ;
float    filtcompthreshamp; 
int compflag=0 ; 

//  FILTER DECIBELS OF COMPRESSION 
struct  func  filtcompdecibels ;
float  filtcompamp,  filtcompnormamp ; 
// ****

//  FILTER EXPANSION THRESHOLD IN DB
struct  func  expthreshdB ;

//  FILTER EXPANSION THRESHOLD IN DB
struct  func  expdB ;
float  expthreshamp, expamp   ; 



// FILTER TRANSPOSE IN SEMITONES
struct  func  ftrans ; 

// FILTER  SHIFTER
struct  func  fshift ; 

//  FILTER RELEASE
struct  func  frelease ; 

//  FILTER ATTACK
struct  func  fattack ; 

//  FILTER WARP SHAPE
struct  func  warpshape ; 

//  FILTER SMOOTHING
struct  func  octaves ; 

//  FILTER DEVIATION BASE
struct  func  fdevbase ;
//  FILTER DEVIATION PEAK
struct  func  fdevpeak ;
//  FILTER DEVIATION SHIFT BASE 
struct  func  fshiftbase ;
//  FILTER DEVIATION SHIFT PEAK
struct  func  fshiftpeak ;
//  FILTER DEVIATION WARP SHAPE
struct  func  freqwarpshape ;
//  FILTER DEVIATION MASTER CONTROL
struct  func  fdevcontrol ;


#include "underflow.h"


//*****************INITIALIZE
// COMB FREQUENCY SHIFT ADDER
harmadd.L = 1. ; harmadd.n = 1. ; harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// PITCH MULTIPLIER
ptrans.L = 1. ; ptrans.n = 1. ; ptrans.A[ 0 ] = 0. ; 

//  SOURCE DECIBELS
sourcedB.L = 1. ; sourcedB.n = 1. ; sourcedB.A[ 0 ] = -96. ; 

//  RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 

//  ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 


// FILTER
filter.L = 1. ; filter.n = 0. ; filter.A[ 0 ] = 0. ; 

// *****
//  FILTER  RATE
filtrate.L = 1. ; filtrate.n = 1. ; filtrate.A[ 0 ] = 1. ; 

// FILTER TIME ORIGIN
filttorigin.L = 1. ; filttorigin.n = 1. ; filttorigin.A[ 0 ] = 0. ; 

// FILTER TIME WINDOW LOWER BOUNDARY
filtwinlow.L = 1. ; filtwinlow.n = 1. ; filtwinlow.A[ 0 ] = 0. ; 

// FILTER TIME WINDOW UPPER BOUNDARY
filtwinhi.L = 1. ; filtwinhi.n = 1. ; filtwinhi.A[ 0 ] = -1. ; 

// *****
// FILTER TRANSPOSE MULTIPLIER
ftrans.L = 1. ; ftrans.n = 1. ; ftrans.A[ 0 ] = 0. ; 

// FILTER TRANSPOSE SHIFTER
fshift.L = 1. ; fshift.n = 1. ; fshift.A[ 0 ] = 0. ; 

//  FILTER RELEASE
frelease.L = 1. ; frelease.n = 1. ; frelease.A[ 0 ] = 0. ; 

//  FILTER ATTACK
fattack.L = 1. ; fattack.n = 1. ; fattack.A[ 0 ] = 0. ; 

//  FILTER WARP SHAPE
warpshape.L = 1. ; warpshape.n = 1. ; warpshape.A[ 0 ] = 0. ; 

//  FILTER SMOOTHING
octaves.L = 1. ; octaves.n = 1. ; octaves.A[ 0 ] = 0. ; 

//  FILTER DEVIATION BASE
fdevbase.L = 1. ; fdevbase.n = 1. ; fdevbase.A[ 0 ] = 0. ; 

//  FILTER DEVIATION PEAK
fdevpeak.L = 1. ; fdevpeak.n = 1. ; fdevpeak.A[ 0 ] = 0. ; 

//  FILTER DEVIATION SHIFT BASE 
fshiftbase.L = 1. ; fshiftbase.n = 1. ; fshiftbase.A[ 0 ] = 0. ; 

//  FILTER DEVIATION SHIFT PEAK
fshiftpeak.L = 1. ; fshiftpeak.n = 1. ; fshiftpeak.A[ 0 ] = 0. ; 

//  FILTER DEVIATION WARP SHAPE
freqwarpshape.L = 1. ; freqwarpshape.n = 1. ; freqwarpshape.A[ 0 ] = 0. ; 

//  FILTER DEVIATION MASTER CONTROL
fdevcontrol.L = 1. ; fdevcontrol.n = 1. ; fdevcontrol.A[ 0 ] = 0. ; 


//  FILTER COMPRESSION THRESHOLD
filtcompthresh.L = 1. ; filtcompthresh.n = 1. ; filtcompthresh.A[ 0 ] = 0. ; 

//  FILTER DECIBELS OF COMPRESSION 
filtcompdecibels.L = 1. ; filtcompdecibels.n = 1. ; filtcompdecibels.A[ 0 ] = 0. ; 

//  FILTER EXPANSION THRESHOLD IN DB
expthreshdB.L = 1. ; expthreshdB.n = 1. ; expthreshdB.A[ 0 ] = -200. ; 

//  FILTER EXPANSION THRESHOLD IN DB
expdB.L = 1. ; expdB.n = 1. ; expdB.A[ 0 ] = 0. ; 


if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, 
    "R|N|M|P|D|B|t|I|C|F|f|T|l|h|j|J|k|n|O|p|d|o|r|i|_|=|b|f|e|q|L|K|Z|Q|g|G|z|Y|V|u|S|H|E|c|m|X|W|c|d|s|a|A|h",
     0  )) != 0 ) {
	switch(ch) {
	    case 'N':   N = atoi(arg_option);
			break;
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;

	    case 'B':   pitchflag = atoi(arg_option) ;
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

	    case 'K':   achannelout = atoi(arg_option) ;
			break;

	    case 'H':   dBlow = atof(arg_option) ;
			break;
	    case 'X':   dBhi = atof(arg_option) ;
			break;
	    case 'm':   freqlow = atof(arg_option) ;
			break;
	    case 'R':   freqhi = atof(arg_option) ;
			break;

           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;

	    case 'd':   autostop = atoi(arg_option) ;
			break;



            case 'p':	quiet = atoi(arg_option) ; break;
            case 'i':	ampstatinc = atof(arg_option) ; break;

	    case 'P':   strcpy(tempstring, arg_option);
			ptrans.fp = crackstring( tempstring, &ptrans ); 
			break;
	    case 'a':   strcpy(tempstring, arg_option);
			harmadd.fp = crackstring( tempstring, 
			    &harmadd );
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;

	    case 'F':   strcpy(tempstring, arg_option);
			filter.fp = crackstring( tempstring, 
			    &filter );
			break;
 
            case 'q':	bandrejecton = atoi(arg_option) ; break;


	    case 'f':   strcpy(tempstring, arg_option);
			octaves.fp = crackstring( tempstring, 
			    &octaves );
			break;

// *****
	    case 'u':	imode = atoi(arg_option);
			break;
	    case 'Q':   strcpy(tempstring, arg_option);
			filttorigin.fp = crackstring( tempstring, 
			    &filttorigin );
			break;
	    case 'Y':   strcpy(tempstring, arg_option);
			filtrate.fp = crackstring( tempstring, 
			    &filtrate );
			break;

	    case 'g':   strcpy(tempstring, arg_option);
			filtwinlow.fp = crackstring( tempstring, 
			    &filtwinlow );
			break;
	    case 'G':   strcpy(tempstring, arg_option);
			filtwinhi.fp = crackstring( tempstring, 
			    &filtwinhi );
			break;

	    case 'E':   strcpy(tempstring, arg_option);
			filtcompthresh.fp = crackstring( tempstring, 
			    &filtcompthresh );
			break;
	    case 'c':   strcpy(tempstring, arg_option);
			filtcompdecibels.fp = crackstring( tempstring, 
			    &filtcompdecibels );
			break;


	    case 'o':   strcpy(tempstring, arg_option);
			expthreshdB.fp = crackstring( tempstring, 
			    &expthreshdB );
			break;
	    case 'r':   strcpy(tempstring, arg_option);
			expdB.fp = crackstring( tempstring, 
			    &expdB );
			break;


// *****

	    case 'T':   strcpy(tempstring, arg_option);
			ftrans.fp = crackstring( tempstring, 
			    &ftrans );
			break;
	    case 'V':   strcpy(tempstring, arg_option);
			fshift.fp = crackstring( tempstring, 
			    &fshift );
			break;
	    case 'Z':   strcpy(tempstring, arg_option);
			frelease.fp = crackstring( tempstring, 
			    &frelease );
			break;
	    case 'z':   strcpy(tempstring, arg_option);
			fattack.fp = crackstring( tempstring, 
			    &fattack );
			break;

   //***********


	    case 'h':   strcpy(tempstring, arg_option);
			fdevbase.fp = crackstring( tempstring, 
			    &fdevbase );
			break;
	    case 'j':   strcpy(tempstring, arg_option);
			fdevpeak.fp = crackstring( tempstring, 
			    &fdevpeak );
			break;

	    case 'J':   strcpy(tempstring, arg_option);
			fshiftbase.fp = crackstring( tempstring, 
			    &fshiftbase );
			break;
	    case 'k':   strcpy(tempstring, arg_option);
			fshiftpeak.fp = crackstring( tempstring, 
			    &fshiftpeak );
			break;

	    case 'n':   strcpy(tempstring, arg_option);
			freqwarpshape.fp = crackstring( tempstring, 
			    &freqwarpshape );
			break;

	    case 'O':   strcpy(tempstring, arg_option);
			fdevcontrol.fp = crackstring( tempstring, 
			    &fdevcontrol );
			break;

     //***********



	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;
	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;

	    case 'S':   strcpy(tempstring, arg_option);
			sourcedB.fp = crackstring( tempstring, 
			    &sourcedB );
			break;


	    case 'W':   strcpy(tempstring, arg_option);
			warpshape.fp = crackstring( tempstring, 
			    &warpshape );
			break;

	    case 't':   threshfacdB = atof(arg_option);
			break;
	    case 's':   sflag = 1;
			break;
	} 
    }

prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "TVFILTDEVIATOR", 69 ) ; 
prline( 69,  "-" ) ; 

    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
 




// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 
    

// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 

    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
//*********************************
    IR = (float) I / (float) R ; 
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    fundamental = (float) R / (float) N ; 
    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	

    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 


// SET UP FLAG FOR OSCIL BANK OR OVERLAP/ADD
    if( (ptrans.n  != 1.) || (harmadd.n  != 1.) || 
	    (ptrans.A[0] != 0.) || (harmadd.A[0] != 0.)  ) {
	// OSC BANK
	P = 1. ; obank = 1 ;  
    }else{
	// OVERLAPP-ADD
	P = 0. ; obank = 0 ;  
    }
    
    // READ IN FFT HEADER VALUES
    readffthead(  &analysis_N,  &analysis_D,  &analysis_R,  &analysis_chan, &window_type,  normamp, &filter ) ; 

    for( i = 0; i < analysis_chan; i++){
	prf( normamp[i], "normamp" ) ; 
    }


    analysis_N2 = analysis_N>>1 ; 

// ************ TEST SIZE TO SEE IF DATA FILE IS POSSIBLY WRONG
    temp = ( ((filter.n  - (float) FFT_HEADER_SIZE ) / (float) (analysis_N + 2) ) != 0 ) ; 
    temp2 = temp - (float) ( (int) temp ) ; 
    if( (analysis_N <= 0) || (analysis_D <= 0) || (analysis_R <= 0) || 
	    (analysis_chan <= 0) || ( temp2 != 0. ) ){
	prt( "YOUR SOUND B ANALYSIS FILE HAS QUESTIONABLE DATA. BYE." ) ; 
	    pri( analysis_N,  "INPUT ANALYSIS: FFT SIZE" ) ; 
	    pri( analysis_R,  "INPUT ANALYSIS: SAMPLE RATE" ) ; 
	    pri( analysis_D,  "INPUT ANALYSIS: DECIMATION" ) ; 
	    pri( analysis_chan,  "INPUT ANALYSIS: NUMBER OF CHANNELS" ) ; 
	    pri( filter.n,  "INPUT ANALYSIS: FILE SIZE" ) ; 
	exit(0) ; 
    }

 		
// PRINT VALUES
prf( dur, "DURATION" ) ; 
pri( N,  "FFT SIZE" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
pri( R,  "SAMPLE RATE" ) ; 
pri( D,  "DECIMATION" ) ; 
pri( I,  "INTERPOLATION" ) ; 

prp( &dBgain,  "MASTER GAIN (dB)"  ) ; 
prp( &ptrans,  "PITCH TRANSPOSITION (semitones)"  ) ; 
prp( &harmadd,  "FREQUENCY SHIFT (Hz)"  ) ; 
prp( &attack,  " ENVELOPE ATTACK TIME (seconds)"  ) ; 
prp( &release,  " ENVELOPE RELEASE TIME (seconds)"  ) ; 
prp( &sourcedB,  "SOURCE SIGNAL FLOOR (dB)"  ) ; 


prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (dB)" ) ; 


//pr( &?,  "~"  ) ; 

    fprintf( stderr,  "\n\n" ) ; 
    // *******

//*******
// FIND DURATION OF INPUT FILE
    


    niframes = (((filter.n - (float) FFT_HEADER_SIZE ) / (float) (analysis_N + 2))) / analysis_chan ; 
    analysis_dur = (float) (niframes) / ((float) analysis_R / (float) analysis_D ) ; 
    iframes_per_sec = (float) analysis_R /  (float) analysis_D ; 
    pri( niframes,  "NUMBER OF FRAMES IN ANALYSIS" ) ; 

// FILTER WINDOW BOUNDARIES
    if( filtwinhi.A[ 0 ] < 0.) filtwinhi.A[ 0 ] = analysis_dur ;

    temp2 = (float) R  / (float) I  ; 
fprintf( stderr,"\n******** TVFILTER  OUTPUT *******************" ) ; 
fprintf( stderr,"\nOUTPUT DURATION: %f seconds",  dur ) ; 
fprintf( stderr,"\nOUTPUT: %d frames/sec ", (int) temp2 ) ; 
fprintf( stderr,"\nOUTPUT: %d total frames", (int) (temp2 * dur) ) ;


fprintf( stderr,"\n********** FILTER FILE ********************" ) ; 
prf( analysis_dur,	  "INPUT ANALYSIS: DURATION" ) ; 
pri( analysis_N,  "INPUT ANALYSIS: FFT SIZE" ) ; 
pri( analysis_R,  "INPUT ANALYSIS: SAMPLE RATE" ) ; 
pri( analysis_D,  "INPUT ANALYSIS: DECIMATION" ) ; 
pri( analysis_chan,  "INPUT ANALYSIS: NUMBER OF CHANNELS" ) ;
// ***** VERIFY ANALYSIS CHANNEL
    if( achannelout == 0 ){
	// ANALYSIS USES CHANNEL FOR CHANNEL
	if( analysis_chan < ichan) {
		// NOT ENOUGH ANALYSIS CHANNELS
		prbanner( "WARNING",  69 ) ; 
		prt( " =======> THERE ARE NOT ENOUGH  ANALYSIS CHANNELS TO MATCH INPUT SOUNDFILE <=====" ) ;
		    pri( analysis_chan,  "INPUT ANALYSIS: NUMBER OF CHANNELS" ) ; 
		    pri( ichan,  "INPUT SOUND FILE: NUMBER OF CHANNELS" ) ; 
		prt( " ANALYSIS CHANNEL WILL BE SET TO 1 AND APPLIED TO ALL INPUT CHANNELS.\n" ) ;
		prline( 69,  "-" ) ;
		achannelout = 1 ;
	}else{
		prt( "\n.....ANALYSIS AND INPUT SOUND FILE CHANNELS WILL BE PAIRED BY NUMBER.\n" ) ; 
	}  
    }else{
	// PARTICULAR ANALYSIS CHANNEL SELECTED
	if( (achannelout - 1) >= analysis_chan ){
	    // NOT AN ANALYSIS CHANNEL -- RESET TO 1 AND ANNOUNCE
	    prline( 1,  "*" ) ;
	    pri( achannelout,  "\nSELECTED ANALYSIS CHANNEL" ) ;
	    prt( "DOES NOT EXIST. WILL RESET INPUT ANALYSIS CHANNEL = 1" ) ;
	    prline( 1,  "*" ) ;
	    achannelout = 1 ;  
	}else{
	    // GOOD CHANNEL
	    prt( "\nTHE SELECTED INPUT ANALYSIS CHANNEL WILL BE APPLIED TO ALL CHANNELS." ) ; 
	    pri( achannelout,  "SELECTED INPUT ANALYSIS CHANNEL" ) ; 
	    prline( 1,  "*" ) ;
	}
    }


pri( imode,  "INPUT ANALYSIS: DATA MODE" ) ; 
prp( &filtrate,  "FILTER RATE MULTIPLIER"  ) ; 
prp( &filttorigin,  "FILTER TIME POINT-ORIGIN"  ) ; 
prp( &filtwinlow,  "FILTER TIME WINDOW LOWER BOUNDARY"  ) ; 
prp( &filtwinhi,  "FILTER TIME WINDOW UPPER BOUNDARY"  ) ; 

if( bandrejecton ){
    prt( "FILTER TYPE: ............REJECT RESPONSE" ) ;
}else{
    prt( "FILTER TYPE: ............PASS RESPONSE" ) ;
}
prp( &ftrans,  "FILTER TRANSPOSITION (semitones)"  ) ; 
prp( &fshift,  "FILTER FREQUENCY SHIFT (Hz)"  ) ; 
prp( &fattack,  "FILTER ENVELOPE ATTACK TIME (seconds)"  ) ; 
prp( &frelease,  "FILTER ENVELOPE RELEASE TIME (seconds)"  ) ; 
prp( &filtcompthresh,  "FILTER COMPRESSION THRESHOLD (dB)"  ) ; 
prp( &filtcompdecibels,  "FILTER DEGREE OF COMPRESSION (dB)"  ) ; 
//prp( &expthreshdB,  "FILTER EXPANSION THRESHOLD (dB)" ) :  
//prp( &expdB,  "FILTER DEGREE OF EXPANSION (dB)"  ) ; 


prline( 1,  "*" ) ; 


prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prf( freqlow, "LOW SHELF FREQUENCY" ) ; 
prf( dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prf( freqhi, "HIGH SHELF FREQUENCY" ) ; 
prf( dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
prt( "*...........................................*" ) ;  
prline( 1,  "*" ) ; 
prp( &warpshape, "INPUT SPECTRUM WARPSHAPE INDEX" ) ; 
prline( 1,  "*" ) ; 
prp( &octaves, "RESPONSE SMOOTHING (Q) FACTOR IN OCTAVES" ) ; 


prline( 1,  "*" ) ; 
prt( "************** FREQUENCY DEVIATION PARAMETERS ***************" ) ; 
prp( &fdevbase,  "BASE FREQUENCY DEVIATION (in semitones)"  ) ; 
prp( &fdevpeak,  "PEAK FREQUENCY DEVIATION (in semitones)"  ) ; 
prline( 1,  "*" ) ; 
prp( &fshiftbase,  "BASE FREQUENCY DEVIATION SHIFT (in Hz)"  ) ; 
prp( &fshiftpeak,  "PEAK FREQUENCY DEVIATION SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &fdevcontrol,  "MASTER FREQUENCY DEVIATION CONTROL (0-1)"  ) ; 




prp( &freqwarpshape, "INPUT SPECTRUM FREQUENCY DOMAIN WARPSHAPE INDEX" ) ; 


fprintf( stderr,"\n*******************************************\n\n" ) ; 



//***********
// SETUP FILTER CONTROL VALUES
	         // FILTER INCREMENT IN SECONDS
    filttinc =  (float) D / (float) R ; 
//***********

// MAKE THRESH AMP
    threshfac = dB_to_amp( threshfacdB ) ; 
 //*****************
// SET UP SOME FILTER FILE VALUES
    analysis_fundamental = nyquist / (float) (analysis_N/2) ; 
    // MAKE RATIO OF ANALYSIS N TO SOURCE N FOR FILTER POSITIONING
    N_ratio = (float) analysis_N / (float) N ; 
    

    
    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    fvec( previous_channel, N+2 ) ;	/* previous analysis channels */

// ALLOCATE FILTER SPACE
    fvec( F,  analysis_N+2  ) ;	/* filter array */
    fvec( Ffreq,  N+2  ) ;	/* filter array */
    fvec( previous_F, analysis_N+2 ) ;	/* previous filter channels */

    fvec( F_lower,  analysis_N+2  ) ;	/* lower filter array */
    fvec( F_higher,  analysis_N+2  ) ;	/* higher filter array */


// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 

//*********************************************
//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

    // **** SET UP ANALYSIS CHANNEL
	ainchan = (achannelout == 0) ? channow : (achannelout - 1) ; 
    // SETUP FILTER CONTROL VALUES
	filttorigin.A[ 0 ] = fval( &filttorigin, dur, 0. );
	filttnow = filttorigin.A[ 0 ] ; // ACCUMULATED FILTER TIME POINT IN SECONDS

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 
pri( (ainchan+1), "INPUT ANALYSIS (FILTER) CHANNEL" ) ; 

    
    
    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 
    autostopflag = 0 ; 

    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;

//********** MAKE SOME ANNOUNCEMENTS
//    if(dBhi != 0. )fprintf(stderr," \nUSING FILTER EQ ......" ) ;
    if( compflag == 1 )fprintf(stderr," \nUSING FILTER SPECTRUM COMPRESSION......" ) ;
    fprintf(stderr," \n") ; 
    if( bandrejecton )prt( "INVERTING RESPONSE......." ) ; 

//*************
	    // SET AT DATA BEGIN
		fseek( filter.fp,  sizeof(float) * FFT_HEADER_SIZE,  SEEK_SET ) ; 
//*************
	
 //*********************************************
// LOOP FOR FRAMES
//*********************************************

   while ( (!eof)  && (autostopflag == 0) ) {
	in += D ;
	on += I ;
	timenow( dur ) ;

    eof = shiftin( input, Nw, D ) ;
    fold( input, Wanal, Nw, buffer, N, in ) ;
    rfft( buffer, N2, FORWARD ) ;
    convert( buffer, channel, N2, D, R ) ;

	// SETUP PREVIOUS CHANNEL
    if( !frame_count )for(i = 0; i < N; i++)
	    previous_channel[ i ] = channel[ i ] ; 



//*************
// FILTER TIME ISSUES

	// LOW WINDOW TIME POINT
		filtwinlow.A[ 0 ] = fval( &filtwinlow, dur, t );
		if(filtwinlow.A[ 0 ] < 0.)filtwinlow.A[ 0 ] = 0. ; 
		if(filtwinlow.A[ 0 ] > analysis_dur)filtwinlow.A[ 0 ] = analysis_dur ;  

	// HIGH WINDOW TIME POINT
		filtwinhi.A[ 0 ] = fval( &filtwinhi, dur, t );
		if(filtwinhi.A[ 0 ] > analysis_dur)filtwinhi.A[ 0 ] = analysis_dur ; 
		if(filtwinhi.A[ 0 ] < 0.)filtwinhi.A[ 0 ] = 0. ;

	// WINDOW SIZE
		temp = filtwinhi.A[ 0 ] - filtwinlow.A[ 0 ] ;  
		if( temp == 0. ){
		    // ZERO WINDOW SIZE
		    filttnow = filtwinlow.A[ 0 ] ; 
		}else if(temp < 0.){
		    // UPPER BENEATH LOWER
		    while(filttnow >= filtwinlow.A[ 0 ]){
			filttnow += temp ;
			prf( t, "CROSSED LOWER BOUNDARY (NOW ABOVE LOWER) AT TIME" ) ;
			if( autostop != 0 ) autostopflag = 1 ;  
		    } 
		    while(filttnow < filtwinhi.A[ 0 ]){
			filttnow -= temp ; 
			prf( t, "CROSSED UPPER BOUNDARY (NOW BENEATH LOWER) AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    }
		}else{
		    // REGULAR
		    while(filttnow >= filtwinhi.A[ 0 ]){
			filttnow -= temp ; 
			prf( t, "CROSSED UPPER BOUNDARY AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    }
		    while(filttnow < filtwinlow.A[ 0 ]){
			filttnow += temp ;
			prf( t, "CROSSED LOWER BOUNDARY AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    } 
		    
		}

//*************



//******************************************************************************
// MAKE THE FILTER FRAME
//******************************************************


		filtf = iframes_per_sec * filttnow ; // VIRTUAL FRAME 
		filtflow = (int) filtf ; // LOWER FRAME
		filtfhigh = filtflow + 1 ; // HIGHER FRAME
		filtfprop =  filtf - (float) filtflow ; // PROPORTIONAL POSITION BETWEEN FRAMES

// READ IN THE LOWER AND HIGHER FRAMES
	    
    if((t == 0.) || (filtflowold != filtflow)){
	// POSITION TO LOWER FRAME
		k = ((FFT_HEADER_SIZE + 
		    ((ainchan + (analysis_chan * filtflow) ) 
			    * (analysis_N + 2) ) ) * sizeof(float)) ; 
		fseek( filter.fp,  k,  SEEK_SET ) ; 
	// READ IN LOWER FRAME		
		fread( F_lower, sizeof(float), analysis_N+2, filter.fp ) ;
    
	// POSITION TO HIGHER FRAME
		k = ((FFT_HEADER_SIZE + 
		    ((ainchan + (analysis_chan * filtfhigh) ) 
			    * (analysis_N + 2) ) ) * sizeof(float)) ; 
		fseek( filter.fp,  k,  SEEK_SET ) ; 
	// READ IN HIGHER FRAME		
		fread( F_higher, sizeof(float) , analysis_N+2, filter.fp ) ;
    }

// MAKE INTERPOLATED FRAME
	for( i = 1; i < analysis_N; i +=2){
	    F[i - 1] = F_lower[i - 1] + (filtfprop * (F_higher[i - 1] - F_lower[i - 1])) ; 
	}
	
// SAVE OLD FRAME NUMBERS
		filtflowold = filtflow ; 
// INCREMENT FILTER TIME POINT
    // BRANCH FOR EXPLICIT OR RATE MODE
	if( imode == 0 ){
	    // EXPLCIT MODE
	// FIND THE TIME POINT ORIGIN
		filttorigin.A[ 0 ] = fval( &filttorigin, dur, t );
		filttnow = filttorigin.A[ 0 ] ; 
	} else{
	    // RATE MODE
   // FIRST GET THE FRAME RATE MULTIPLIER
		filtrate.A[ 0 ] = fval( &filtrate, dur, t );
		filttnow += (filttinc * filtrate.A[ 0 ]) ;
	}

		
//******************************************************





//*************NORMALIZE THE INPUT SPECTRUM
    normalize(  F,  analysis_N,   normamp[ainchan]  ) ;

//******************************************************
//**************COMPRESS THE INPUT SPECTRUM

// MAKE COMPRESSION STUFF

    filtcompthresh.A[ 0 ] =  fval( &filtcompthresh, dur, t );
    filtcompdecibels.A[ 0 ] =  fval( &filtcompdecibels, dur, t );
//    expthreshdB.A[ 0 ] =  fval( &expthreshdB, dur, t );
//    expdB.A[ 0 ] =  fval( &expdB, dur, t );


    if( filtcompthresh.A[ 0 ] > 0.){
	fprintf(stderr," \n\n***** COMPRESSION THRESHOLD MUST BE < 0dB. BYE.\n\n" ) ;
	exit( 0 ) ; 
    }
    if( filtcompdecibels.A[ 0 ] > 0.){
	fprintf(stderr," \n\n***** COMPRESSION DECIBELS MUST BE < 0dB. BYE.\n\n" ) ;
	exit( 0 ) ; 
    }

    filtcompthreshamp = pow( (double) 10.0, (double) (filtcompthresh.A[ 0 ]/20.) );
    filtcompamp =  pow( (double) 10.0, (double) (filtcompdecibels.A[ 0 ]/20.) );
//    compamp = dB_to_amp( compdB ) ; 
//    expamp = 1. / dB_to_amp( expdB ) ; 

    filtcompnormamp = 
	1. / (filtcompthreshamp + (filtcompamp * (1. - filtcompthreshamp))) ; 

    if( (filtcompthreshamp < 1.0) && (filtcompamp < 1.0) ){
	compflag = 1;
    }


/*

    if( compthreshamp <= expthreshamp ){
	fprintf( stderr, "\n\nCOMPRESSION THRESHOLD IS BELOW EXPANSION THRESHOLD!\n\nCOMPANSION SKIPPED!\n\n" ) ;
    }else{
	if( (compamp < 1.) || (expamp > 1. ) ){
	    if( (compamp <= 1.) && (expamp >= 1.) ){
		prt( "...............USING COMPRESSION" ) ; 
		 compand( F, analysis_N, filtcompthreshamp, filtcompamp, expthreshamp, expamp  ) ;
	    }else{
		prf( compdB.A[ 0 ],  "COMPRESSION DECIBELS" ) ; 
		prf( expdB.A[ 0 ],  "EXPANSION DECIBELS" ) ; 
		prt( "ILLEGAL COMPRESSION/EXPANSION VALUES" ) ;
		prt( "...................NO COMPRESSION" ) ; 
	    }
	}else{
	    prt( "...................NO COMPRESSION" ) ; 
	}  
    }

*/


//******************************************************



   if( compflag == 1 )
	compress( F,  analysis_N,  filtcompthreshamp, filtcompamp,  filtcompnormamp ) ; 

//*************** IF BAND REJECT, THEN INVERT THE RESPONSE
    if( bandrejecton )invertresponse( F,  analysis_N, (bandrejecton - 1) ) ; 

//*************WARP THE INPUT SPECTRUM
	warpshape.A[ 0 ] = fval( &warpshape, dur, t );
    spectmagwarp( F,  analysis_N, warpshape.A[ 0 ], 0 ) ;

//*************EQUALIZE THE INPUT SPECTRUM
    eq( F,  analysis_N,  dBlow,  dBhi, freqlow,  freqhi,  fundamental, 1,  0, 0 ) ; 

     //*********** SMOOTH THE SPECTRUM
	octaves.A[ 0 ] = fval( &octaves, dur, t );
    smoothspec( F, analysis_N2, octaves.A[ 0 ], R ) ; 


//***********SMOOTH THE CHANGES ON THE FILTER

		//RELEASE
    frelease.A[ 0 ] = fval( &frelease, dur, t );
    smooth_setup( frelease.A[ 0 ], &freleasec, &minusfreleasec, IR ) ; 

		// ATTACK
    fattack.A[ 0 ] = fval( &fattack, dur, t );
    smooth_setup( fattack.A[ 0 ], &fattackc, &minusfattackc, IR ) ; 


		// SMOOTH THE CHANGES TO THE FILTER
    smooth( F, previous_F, analysis_N, fattackc, minusfattackc, freleasec, minusfreleasec ) ; 

//*** END FILTER SMOOTH ************************************* 

// COMPRESSION => REJECTION => FILTER WARPING => EQ => OCTAVE Q SMOOTH =>
//   =>  ATTACK/RELEASE => (OUTPUT FOR FILTERING) => 
// => FREQ DEVIATION WARPING => OUTPUT FOR FREQ DEVIATION

// ********** COPY F INTO Ffreq
    for(i = 0; i < (N+2); i++)Ffreq[i] = F[i] ; 

//*************FREQ WARP
	freqwarpshape.A[ 0 ] = fval( &freqwarpshape, dur, t );
    spectmagwarp( Ffreq,  N, freqwarpshape.A[ 0 ], 1 ) ;


//*************************
// GET THE VALUES
//*************************


//  SHIFT, GAIN, AND TRANSPOSITION

		harmadd.A[ 0 ] =  fval( &harmadd, dur, t );
		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp( dBgain.A[ 0 ] ) ; 
		ptrans.A[ 0 ] = fval( &ptrans, dur, t );
		pm = semitones_to_mult( ptrans.A[ 0 ] ) ; 


		ftrans.A[ 0 ] = fval( &ftrans, dur, t );
		    fm = semitones_to_mult( ftrans.A[ 0 ] ) ; 
		fs = fshift.A[ 0 ] = fval( &fshift, dur, t );
		    // IF FREQ SHIFT FOR SOURCE ONLY, SUBTRACT FROM FILTER CHANGE
		    if( !pitchflag ) fs = fs - harmadd.A[ 0 ] ; 
		sourcedB.A[ 0 ] = fval( &sourcedB, dur, t );
		    sourceamp = dB_to_amp( sourcedB.A[ 0 ] ) ; 
		    filtamp = 1. - sourceamp ;  


		    // IF PITCH TRANSPOSITION FOR SOURCE ONLY, DIVIDE OUT OF FILTER CHANGE
		    if( !pitchflag ) fm = fm / pm ; 


		//RELEASE
		release.A[ 0 ] = fval( &release, dur, t );
		smooth_setup( release.A[ 0 ], &releasec, &minusreleasec, IR ) ; 

		// ATTACK
		attack.A[ 0 ] = fval( &attack, dur, t );
		smooth_setup( attack.A[ 0 ], &attackc, &minusattackc, IR ) ; 



    //****** FREQ DEV ******

		// **** FREQ DEVIATION: SETUP 
		fdevbase.A[ 0 ] = fval( &fdevbase, dur, t );
		  fdbm = semitones_to_mult( fdevbase.A[ 0 ]  ) ; 
		fdevpeak.A[ 0 ] = fval( &fdevpeak, dur, t );
		  fdpm = semitones_to_mult( fdevpeak.A[ 0 ] ) ; 
		fdmdiff = fdpm - fdbm ; 		    


		// **** FREQ DEVIATION: SETUP 
		fshiftbase.A[ 0 ] = fval( &fshiftbase, dur, t );
		fshiftpeak.A[ 0 ] = fval( &fshiftpeak, dur, t );
		fsdiff = fshiftpeak.A[ 0 ] - fshiftbase.A[ 0 ] ; 		    


		fdevcontrol.A[ 0 ] = fval( &fdevcontrol, dur, t );
		fdevminus = 1. - fdevcontrol.A[ 0 ] ; 


//*************************


//*****************
// MODIFICATIONS LOOP
//*****************


//********************* FILTER

		 for( i = 1,  j = 0; i < N; i+= 2,  j++ ){

		    // APPLY FILTER TRANSPOSE
		    // SHIFT
		    temp = (float) j ;  // THE 0-(N/2) BIN WE ARE ON (TO BE FILTERED)
		    temp = temp * N_ratio ; // SHIFT BY RATIO OF ANALYSIS N TO SOURCE N
		    temp = temp - ( fs / analysis_fundamental ) ; // SHIFT THE BIN
		    // TRANSPOSE
		    temp =  (temp / fm )  ; // TRANSPOSE THE BIN
		    i2p = temp - (float)((int) temp ) ; // FRACTIONAL BIN VALUE
		    i1p = 1. - i2p ;			// 1. - FRACTIONAL BIN VALUE
		    i1 = 2 * (int) temp ;		// THE LOWER BIN AMP INDEX
		    i2 = i1 + 2 ;			// THE UPPER BIN AMP INDEX

		    if( i1 < 0 ){			
			//UNDER THE ARRAY
    			temp = F[ 0 ]  ; 
    			temp2 = Ffreq[ 0 ]  ; 

		    }else if( i2 > (analysis_N - 2)  ){ 
			//OVER THE ARRAY
    			temp = F[ analysis_N - 2 ]  ; 
    			temp2 = Ffreq[ analysis_N - 2 ]  ; 

		    }else{
			// IN ARRAY
			temp = ( F[ i1 ] * i1p ) + (F[ i2 ] * i2p ) ;
			temp2 = ( Ffreq[ i1 ] * i1p ) + (Ffreq[ i2 ] * i2p ) ;  

		    }
		    
		    // CHANGE AMP
		    channel[i - 1] *=  ((filtamp * temp) + sourceamp );  


	    // MAKE NEW DEVIATED FREQUENCY FOR THIS BIN
		  // MAKE NEW DEVIATED FREQUENCY
		    
		    channel[i] = 
			((fdevminus) + (fdevcontrol.A[ 0 ] * (fdbm + (temp2 * fdmdiff)))  )
			    * 
			(channel[i] + 
			    (fdevcontrol.A[ 0 ] * (fshiftbase.A[ 0 ] + (temp2 * fsdiff)))
			 ) ; 




		//****** END FILTER

		}

    // SMOOTH THE CHANGES TO THE SPECTRUM
    smooth( channel, previous_channel, N, attackc, minusattackc, releasec, minusreleasec ) ; 



		 for( i = 1, j = 0; i < N; i+= 2, j++ ){

// SHIFT BY -a AND TRANSPOSE BY -P

		    temp = pm * (channel[i] + harmadd.A[ 0 ]) ;
		    
		// ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
		    if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
		    else channel[i] = temp ; 



		    channel[i - 1] = channel[i - 1] * gain ;  

		}
		

        synt = getthresh( channel, N, threshfac );


// ** OSCIL BANK OR OVERLAP/ADD OUT
	if ( obank ) {
	    noscbank(channel, N2, R, Nw, I, P, output);
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;
	} else {
	    unconvert( channel, buffer, N2, I, R ) ;

	    rfft( buffer, N2, INVERSE ) ;
	    overlapadd( buffer, N, Wsyn, output, Nw, on ) ;
	     shiftout( output, Nw, I, on, 0 ) ;
	
	}

	frame_count++ ; 

    // FRAMES LOOP END

    }
    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  


    fprintf(stderr,"\nTVFILTDEVIATOR : RESYNTHESIS COMPLETED\n");

  
 
 
    if( harmadd.n != 1. ) fclose(harmadd.fp ) ;
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;
    if( ptrans.n != 1. ) fclose(ptrans.fp ) ;

   if( sourcedB.n != 1. ) fclose(sourcedB.fp ) ;
   if( release.n != 1. ) fclose(release.fp ) ;
   if( attack.n != 1. ) fclose(attack.fp ) ;
   if( frelease.n != 1. ) fclose(frelease.fp ) ;
   if( fattack.n != 1. ) fclose(fattack.fp ) ;
   if( filter.n != 1. ) fclose(filter.fp ) ;
   if( ftrans.n != 1. ) fclose(ftrans.fp ) ;
   if( fshift.n != 1. ) fclose(fshift.fp ) ;

   if( fdevbase.n != 1. ) fclose(fdevbase.fp ) ;
   if( fdevpeak.n != 1. ) fclose(fdevpeak.fp ) ;
   if( fdevpeak.n != 1. ) fclose(fdevpeak.fp ) ;
   if( fshiftbase.n != 1. ) fclose(fshiftbase.fp ) ;
   if( fshiftpeak.n != 1. ) fclose(fshiftpeak.fp ) ;
   if( freqwarpshape.n != 1. ) fclose(freqwarpshape.fp ) ;
   if( fdevcontrol.n != 1. ) fclose(fdevcontrol.fp ) ;

    if( filtrate.n != 1. ) fclose(filtrate.fp ) ;
     if( filttorigin.n != 1. ) fclose(filttorigin.fp ) ;
     if( filtwinlow.n != 1. ) fclose(filtwinlow.fp ) ;
     if( filtwinhi.n != 1. ) fclose(filtwinhi.fp ) ;
     if( warpshape.n != 1. ) fclose(warpshape.fp ) ;
     if( octaves.n != 1. ) fclose(octaves.fp ) ;
     if( filtcompthresh.n != 1. ) fclose(filtcompthresh.fp ) ;
     if( filtcompdecibels.n != 1. ) fclose(filtcompdecibels.fp ) ;
    if( expthreshdB.n != 1. ) fclose(expthreshdB.fp ) ;
     if( expdB.n != 1. ) fclose(expdB.fp ) ;


    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"tvfiltdeviator:  time-varying  cross-synthetic, phase vocoder filter\n"
	"	    with response-correlated frequency deviation\n"
	"tvfiltdeviator   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	    (values in brackets denote defaults)\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	D:	analysis frames per second [200]\n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"

	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (0. = end of file) [0.] \n"
	"	C:	resynthesis channel (1 -> ?) (0 = all) [0] \n"

	"	P:	pitch transposition in semitones (func) [0]\n"
	"	B:	TRANSPOSITION/SHIFT application FLAG [0]\n"
	"		 Apply -P and -a to:\n"
	"		  source only -- prefliter (0),\n"  
	"		  or to  source and filter -- postfilter (1)\n"  

	"	a:	frequency shift factor (bin frequency adder, before -P )(func)[0.] \n"
	"	A:	gain in decibels (func) [0.] \n"

	"	F:	FILTER time_varying, frequency response file analysis \n"

	"	K:	FILTER analysis channel (1 -> ?) (0 = all) [0] \n"

	"	q:	FILTER: filtering method: \n"
	"		 0 = pass, 1 = invert response against 0 dB peak\n"
	"		    2 = invert response against peak amp in frame [0] \n"

	"	u:	FILTER data access mode [1]\n"
	"		   (0 = explicit time: Use -Q)\n"
	"		   (1 = rate mode: Use -Q as begin point, -Y as rate control) \n"
	"	Q:	FILTER time point (func) [0.] \n"
	"	g:	FILTER time window: lower boundary (func) [0.] \n"
	"	G:	FILTER time window: upper boundary (func) [end of file] \n"
	"		    (upper boundary < 0. defaults to end of file\n)"
	"	Y:	FILTER rate multiplier (func) [1.]\n"
	"		    (1. = rate of original, 2. = twice as fast, etc.)\n"
	"		    (negative = reverse,  0 = stationary) \n"
	"	d:	DATA auto stop: 0 = off,  1 = on [0]\n"
	"		    (When on,  auto stop will terminate synthesis\n"
	"		      when a time boundary is crossed.)\n"

	"	    FILTER COMPRESSION:\n"
	"	E:	FILTER-spectrum compression threshold (in decibels) [0] \n"
	"	c:	FILTER-spectrum decibels of compression [0] \n"

	"	T:	FILTER frequency response transposition in semitones (func) [0]\n"
	"	V:	FILTER  response shifter (func) [0.] \n"
	"	Z:      FILTER envelope envelope release time   (func) [0.]\n"
	"	z:      FILTER envelope envelope attack time   (func) [0.]\n"

	"	S:	FILTER source decibels (reduces filtered signal in proportion)(func) [-96] \n"
	"	W:	FILTER warp index for reshaping filter frequency response (func) [0.] \n"
	"		    values > 0 expand the dynamic range, \n"
	"		    values < 0 compress the dynamic range \n"

	"	l:      envelope attack time  (func) [0.]\n"
	"	L:      envelope release time   (func) [0.]\n"

	"	f:	FILTER FREQUENCY RESPONSE: smoothing bandwidth (in octaves) [0]\n"
	"		    (The value for each peak is  replaced with the average\n"
	"		     value within the band. The bandwidth has \"octaves\" width, \n"
	"		       positioned with the peak as the center frequency.\n"
	"			 ; 0 = no averaging)\n"

	"	PROCESSING SEQUENCE:\n"
	"	     COMPRESSION/EXPANSION => REJECTION => FILTER WARPING => EQ => \n"
	"	     OCTAVE Q SMOOTH =>  ATTACK/RELEASE => (OUTPUT FOR FILTERING) =>\n" 
	"	       FREQ DEVIATION WARPING => (OUTPUT FOR FREQ DEVIATION)\n"




	"	h:      FREQUENCY DEVIATION: base deviation in semitones (func) [0.]\n"
	"	j:      FREQUENCY DEVIATION: peak deviation in semitones (func) [0.]\n"
	"	J:      FREQUENCY DEVIATION: base frequency shift (func) [0.]\n"
	"	k:      FREQUENCY DEVIATION: peak frequency shift (func) [0.]\n"
	"	n:	FREQUENCY RESPONSE WARP:  index for reshaping frequency response [0.] \n"
	"		    in frequency processing (frequency deviation domain)\n"
	"		    values > 0 close down response, < 0 open it up\n"
	"	O:	FREQUENCY DEVIATION: master deviation control (0 (off) - 1) (func) [1.] \n"





	"	     FILTER FREQUENCY RESPONSE -- SHELF EQ: (pre-processing)\n"
	"	H:	FILTER SHELF EQ: Low shelf gain in dB [0.] \n"
	"	X:	FILTER SHELF EQ: High shelf gain in dB [0.] \n"
	"	m:	FILTER SHELF EQ: Low shelf frequency in Hz [200.] \n"
	"	R:	FILTER SHELF EQ: High shelf frequency in Hz [2000.] \n"

	"	t:	oscillator resynthesis threshold [.001]\n"
	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 
	"	_:	 OUTPUT FORMAT: 0 = taken from input file\n"
	"		    1 = 16-bit integer, 2 = 32-bit floats [0]\n" 

	"	=:	 PEAK RESCALE LEVEL (float output only) 0 to -96 dB \n"
	"		    set to 1 to rescale to level of input file [ 1 ]\n" 

	);
    exit(woof);
}


int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

