#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k,  i1,  i2;
float i1p,  i2p ; 
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int analysis_N,  analysis_D, analysis_R, analysis_chan,  niframes ;  
float analysis_dur,  iframes_per_sec ; 
int   eof = 0, obank = 0,  sflag = 0,  channelout=0,  achannelout=0 ;
 float P = 1.0;
  FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel,  *F_lower,  *F_higher,   *channel_freqdev,  *previous_ranampv ; 
float threshfac = .001,  threshfacdB=-60 ;
float	pm, fm, fs,  gain=1.;
double ar_dB ; 
float  temp,  temp2,  temp3 ;  
float getthresh();
float normamp[4],  normamppk ;
float diff ; 
float   IR,  dur=0.;
float fundamental ;
float filtframenow=0. ; 
float analysis_fundamental ;  
float prebalancesum,  postbalancesum, balancelimitdB=0,  balancelimitamp=0  ; 
int ainchan ; 

// SHELF EQ
//float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 

int autostop=0,  autostopflag=0 ; 

float releasec,  minusreleasec,  attackc,  minusattackc ; 
float  fsmoothc,  minusfsmoothc ; 
float  tsmoothc,  minustsmoothc ; 
float  ranampsmoothc,  minusranampsmoothc ; 


//** FILTER VARIABLES
float filttnow=0., oldfilttnow=0.,   filttinc,  filtf, filtfprop  ; 
int filtflow,  filtflowold=0,  filtfhigh,  imode=1. ; 
float dwin ; 

char tempstring[ 128 ] ; 

// FREQUENCY SHIFT ADDER
struct  func  harmadd ; 

// GAIN
struct  func  dBgain ; 

// PITCH MULTIPLIER
struct  func  ptrans ; 

//  BIN AMP SOURCE dB
struct  func  sourcedB ; 

//  ATTACK
struct  func  attack ; 

//  RELEASE
struct  func  release ; 

//  FREQUENCY CHANGE RESPONSE TIME
struct  func  fsmooth ; 

// DATA
struct  func  filter ; 

// ****
//  DATA  RATE
struct  func  filtrate ; 

// DATA TIME POINT ORIGIN
struct  func  filttorigin ; 

// DATA TIME WINDOW LOWER BOUNDARY
struct  func  filtwinlow ; 

// DATA TIME WINDOW UPPER BOUNDARY
struct  func  filtwinhi ; 


// DATA TIME POINT DITHER WINDOW
struct  func  ditherwin ; 

//  TIME POINT CHANGE RESPONSE TIME
struct  func  tsmooth ; 



// SPECTRUM WARPSHAPE INDEX
struct  func  warpshape ; 




// RAMDOM AMP VARIATION DB FLOOR
struct  func  randomdBfloor ; 

// RAMDOM AMP VARIATION RESPONSE TIME
struct  func  randomdBresponse ; 


//  FILTER COMPRESSION THRESHOLD
float  filtcompthresh=0,   filtcompthreshamp; 
int compflag=0 ; 

//  FILTER DECIBELS OF COMPRESSION 
float  filtcompdecibels=0,  filtcompamp,  filtcompnormamp ; 
// ****

//SHELF EQ
struct  func  dBlow;
struct  func  dBhi;
struct  func  freqlow;
struct  func  freqhi ;




#include "underflow.h"




//*****************INITIALIZE
// COMB FREQUENCY SHIFT ADDER
harmadd.L = 1. ; harmadd.n = 1. ; harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// PITCH MULTIPLIER
ptrans.L = 1. ; ptrans.n = 1. ; ptrans.A[ 0 ] = 0. ; 

//  SOURCE DECIBELS
sourcedB.L = 1. ; sourcedB.n = 1. ; sourcedB.A[ 0 ] = -96. ; 

//  ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 

//  RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 

//  FREQUENCY CHANGE RESPONSE TIME
fsmooth.L = 1. ; fsmooth.n = 1. ; fsmooth.A[ 0 ] = 0. ; 

// FILTER
filter.L = 1. ; filter.n = 0. ; filter.A[ 0 ] = 0. ; 

// *****
//  FILTER  RATE
filtrate.L = 1. ; filtrate.n = 1. ; filtrate.A[ 0 ] = 1. ; 

// FILTER TIME ORIGIN
filttorigin.L = 1. ; filttorigin.n = 1. ; filttorigin.A[ 0 ] = 0. ; 

// FILTER TIME WINDOW LOWER BOUNDARY
filtwinlow.L = 1. ; filtwinlow.n = 1. ; filtwinlow.A[ 0 ] = 0. ; 

// FILTER TIME WINDOW UPPER BOUNDARY
filtwinhi.L = 1. ; filtwinhi.n = 1. ; filtwinhi.A[ 0 ] = -1. ; 


// DATA TIME POINT DITHER WINDOW
ditherwin.L = 1. ; ditherwin.n = 1. ; ditherwin.A[ 0 ] = 0. ; 

//  TIME POINT CHANGE RESPONSE TIME
tsmooth.L = 1. ; tsmooth.n = 1. ; tsmooth.A[ 0 ] = 0. ; 

// SPECTRUM WARPSHAPE INDEX
warpshape.L = 1. ; warpshape.n = 1. ; warpshape.A[ 0 ] = 0. ; 

// RAMDOM AMP VARIATION DB FLOOR
randomdBfloor.L = 1. ; randomdBfloor.n = 1. ; randomdBfloor.A[ 0 ] = 0. ; 

// RAMDOM AMP VARIATION RESPONSE TIME
randomdBresponse.L = 1. ; randomdBresponse.n = 1. ; randomdBresponse.A[ 0 ] = 0. ; 


// SHELF EQ
dBlow.L = 1. ; dBlow.n = 1. ; dBlow.A[ 0 ] = 0. ; 
dBhi.L = 1. ; dBhi.n = 1. ; dBhi.A[ 0 ] = 0. ; 
freqlow.L = 1. ; freqlow.n = 1. ; freqlow.A[ 0 ] = 200. ; 
freqhi.L = 1. ; freqhi.n = 1. ; freqhi.A[ 0 ] = 2000. ; 



if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, 
    "R|N|M|P|D|B|b|e|t|I|C|F|f|T|l|J|p|w|_|=|i|b|e|q|L|K|Z|S|Q|g|G|z|Y|V|u|S|H|E|c|m|X|W|c|d|s|a|A|h",
     0  )) != 0 ) {
	switch(ch) {
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'w':   window_type = atoi(arg_option) ;
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;

	    case 'd':   dur = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;


           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;




	    case 'H':   strcpy(tempstring, arg_option);
			dBlow.fp = crackstring( tempstring, &dBlow );
			break;
	    case 'X':   strcpy(tempstring, arg_option);
			dBhi.fp = crackstring( tempstring, &dBhi );
			break;
	    case 'm':   strcpy(tempstring, arg_option);
			freqlow.fp = crackstring( tempstring, &freqlow );
			break;
	    case 'R':   strcpy(tempstring, arg_option);
			freqhi.fp = crackstring( tempstring, &freqhi );
			break;




            case 'p':	quiet = atoi(arg_option) ; break;
            case 'i':	ampstatinc = atof(arg_option) ; break;

	    case 'P':   strcpy(tempstring, arg_option);
			ptrans.fp = crackstring( tempstring, &ptrans ); 
			break;
	    case 'a':   strcpy(tempstring, arg_option);
			harmadd.fp = crackstring( tempstring, 
			    &harmadd );
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;

	    case 'F':   strcpy(tempstring, arg_option);
			filter.fp = crackstring_bin_only( tempstring, 
			    &filter );
			break;
 

// *****
	    case 'u':	imode = atoi(arg_option);
			break;
	    case 'Q':   strcpy(tempstring, arg_option);
			filttorigin.fp = crackstring( tempstring, 
			    &filttorigin );
			break;
	    case 'Y':   strcpy(tempstring, arg_option);
			filtrate.fp = crackstring( tempstring, 
			    &filtrate );
			break;

	    case 'g':   strcpy(tempstring, arg_option);
			filtwinlow.fp = crackstring( tempstring, 
			    &filtwinlow );
			break;
	    case 'G':   strcpy(tempstring, arg_option);
			filtwinhi.fp = crackstring( tempstring, 
			    &filtwinhi );
			break;
	    case 'T':   strcpy(tempstring, arg_option);
			ditherwin.fp = crackstring( tempstring, 
			    &ditherwin );
			break;
	    case 'K':   strcpy(tempstring, arg_option);
			tsmooth.fp = crackstring( tempstring, 
			    &tsmooth );
			break;


	    case 'S':   autostop = atoi(arg_option) ;
			break;


	    case 'E':   filtcompthresh = atof(arg_option) ;
			break;
	    case 'c':   filtcompdecibels = atof(arg_option) ;
			break;

// *****


	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;
	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;

	    case 'f':   strcpy(tempstring, arg_option);
			fsmooth.fp = crackstring( tempstring, 
			    &fsmooth );
			break;

	    case 'W':   strcpy(tempstring, arg_option);
			warpshape.fp = crackstring( tempstring, 
			    &warpshape );
			break;


	    case 'b':   strcpy(tempstring, arg_option);
			randomdBfloor.fp = crackstring( tempstring, 
			    &randomdBfloor );
			break;

	    case 'e':   strcpy(tempstring, arg_option);
			randomdBresponse.fp = crackstring( tempstring, 
			    &randomdBresponse );
			break;

	    case 't':   threshfacdB = atof(arg_option);
			break;
	    case 'h':   usage(1); 
	} 
    }

prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "TIME WARP RESYNTHESIS", 69 ) ; 
prline( 69,  "-" ) ; 

    // READ IN FFT HEADER VALUES
    readffthead(  &analysis_N,  &analysis_D,  &analysis_R,  &analysis_chan, &k,  normamp, &filter ) ; 

    // MAKE THE MASTER PEAK AMP
    normamppk = 0 ; 
    for(k = 0; k < analysis_chan; k++) 
	if( normamp[k] > normamppk) normamppk  = normamp[k]; 
		
    //COPY PEAKAMPS INTO INPUT FILE PEAKAMPS
     for(k = 0; k < analysis_chan; k++)
	ipeakamp[ k ] = normamp[k] ; 
 
    //NO AUDIO INPUT FILE: SET OUTPUTFORMAT TO SHORTS
    // IF SET TO AUTOMATIC
    if( outputformat == 0 )outputformat = 1 ;  
 


// ************ TEST SIZE TO SEE IF DATA FILE IS POSSIBLY WRONG
    temp = ( ((filter.n  - (float) FFT_HEADER_SIZE) / (float) (analysis_N + 2) ) != 0 ) ; 
    temp2 = temp - (float) ( (int) temp ) ; 
    if( (analysis_N <= 0) || (analysis_D <= 0) || (analysis_R <= 0) || 
	    (analysis_chan <= 0) || ( temp2 != 0. ) ){
	prt( "YOUR SOUND B ANALYSIS FILE HAS QUESTIONABLE DATA. BYE." ) ; 
	    pri( analysis_N,  "INPUT ANALYSIS: FFT SIZE" ) ; 
	    pri( analysis_R,  "INPUT ANALYSIS: SAMPLE RATE" ) ; 
	    pri( analysis_D,  "INPUT ANALYSIS: DECIMATION" ) ; 
	    pri( analysis_chan,  "INPUT ANALYSIS: NUMBER OF CHANNELS" ) ; 
	    pri( filter.n,  "INPUT ANALYSIS: FILE SIZE" ) ; 
	exit(0) ; 
    }

//*******
// FIND DURATION OF INPUT FILE

    niframes = (((filter.n - (float) FFT_HEADER_SIZE) / (float) (analysis_N + 2))) / analysis_chan ; 
    analysis_dur = (float) (niframes) / ((float) analysis_R / (float) analysis_D ) ; 
    iframes_per_sec = (float) analysis_R /  (float) analysis_D ; 
    pri( niframes,  "NUMBER OF FRAMES IN ANALYSIS" ) ; 

//*******

    N = analysis_N; isr = R = analysis_R; D = analysis_D ; ichan = analysis_chan ; 
    idur = analysis_dur ; isr = R ; 

    if(channelout == 0){
	channelflag = 0 ; 
    } else{
	channelflag = 1 ; 
    }
 
// DURATION
prf( dur, "OUTPUT DURATION" ) ; 
    outdur = dur ; 
    if( outdur <= 0. ){
	// BOGUS DURATION
	prt( "\n\n=============> BOGUS INPUT DURATION <=================\n\n................BYE." ) ; 
	prf( outdur,  "DURATION" ) ; exit(0) ; 
	 
    }

// SET UP OUTPUT FILE ACCORDING TO ANALYSIS RATE AND
    outfile_setup(argc, argv) ; 


// **** SET UPS *****
      if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    I = D = (int) ((float) R / frames_per_sec) ; 


//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
//*********************************
    IR = (float) I / (float) R ; 
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    fundamental = (float) R / (float) N ; 
    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	

// SET UP FLAG FOR OSCIL BANK OR OVERLAP/ADD
    if( (ptrans.n  != 1.) || (harmadd.n  != 1.) || 
	    (ptrans.A[0] != 0.) || (harmadd.A[0] != 0.)  ) {
	// OSC BANK
	P = 1. ; obank = 1 ;  
    }else{
	// OVERLAPP-ADD
	P = 0. ; obank = 0 ;  
    }
    



 		
// PRINT VALUES
prf( dur, "DURATION" ) ; 
pri( N,  "FFT SIZE" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
pri( R,  "SAMPLE RATE" ) ; 
pri( D,  "DECIMATION" ) ; 
pri( I,  "INTERPOLATION" ) ; 

prp( &dBgain,  "MASTER GAIN (dB)"  ) ; 
prp( &ptrans,  "PITCH TRANSPOSITION (semitones)"  ) ; 
prp( &harmadd,  "FREQUENCY SHIFT (Hz)"  ) ; 
prp( &attack,  " ENVELOPE ATTACK TIME (seconds)"  ) ; 
prp( &release,  " ENVELOPE RELEASE TIME (seconds)"  ) ; 
prp( &fsmooth,  " FREQUENCY CHANGE RESPONSE TIME (seconds)"  ) ; 


prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (dB)" ) ; 


//pr( &?,  "~"  ) ; 

    fprintf( stderr,  "\n\n" ) ; 
    // *******

// FILTER WINDOW BOUNDARIES
    if( filtwinhi.A[ 0 ] < 0.) filtwinhi.A[ 0 ] = analysis_dur ;

    temp2 = (float) R  / (float) I  ; 
fprintf( stderr,"\n******** TWARP  OUTPUT *******************" ) ; 
fprintf( stderr,"\nOUTPUT DURATION: %f seconds",  dur ) ; 
fprintf( stderr,"\nOUTPUT: %d frames/sec ", (int) temp2 ) ; 
fprintf( stderr,"\nOUTPUT: %d total frames", (int) (temp2 * dur) ) ;


fprintf( stderr,"\n********** FILTER FILE ********************" ) ; 
prf( analysis_dur,	  "INPUT ANALYSIS: DURATION" ) ; 
pri( analysis_N,  "INPUT ANALYSIS: FFT SIZE" ) ; 
pri( analysis_R,  "INPUT ANALYSIS: SAMPLE RATE" ) ; 
pri( analysis_D,  "INPUT ANALYSIS: DECIMATION" ) ; 
pri( analysis_chan,  "INPUT ANALYSIS: NUMBER OF CHANNELS" ) ;
// ***** VERIFY ANALYSIS CHANNEL
    if( channelout == 0 ){
	prt( "RESYNTHESIZING ALL CHANNELS" );
    } else{
	if( (channelout - 1) >= analysis_chan ){
	    // BAD CHANNEL
	    pri(  channelout, "\nCHANNEL" );
	    prt( " IS NOT AN ALLOWED CHANNEL. WILL CHANGE TO 1.\n" ) ; 
	}
	pri( channelout, "RESYNTHESIZING  CHANNEL" );
	
    }

pri( imode,  "INPUT ANALYSIS: DATA MODE" ) ; 
prp( &filtrate,  "FILTER RATE MULTIPLIER"  ) ; 
prp( &filttorigin,  "FILTER TIME POINT-ORIGIN"  ) ; 
prp( &filtwinlow,  "FILTER TIME WINDOW LOWER BOUNDARY"  ) ; 
prp( &filtwinhi,  "FILTER TIME WINDOW UPPER BOUNDARY"  ) ; 

prf( filtcompthresh,  "FILTER COMPRESSION THRESHOLD (dB)"  ) ; 
prf( filtcompdecibels,  "FILTER DEGREE OF COMPRESSION (dB)"  ) ; 
prline( 1,  "*" ) ; 
prp( &ditherwin,  "DITHER WINDOW (SECONDS)"  ) ; 
prp( &tsmooth,  "TIME POINT CHANGE RESPONSE TIME (SECONDS)"  ) ; 


prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prp( &freqlow, "LOW SHELF FREQUENCY" ) ; 
prp( &dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prp( &freqhi, "HIGH SHELF FREQUENCY" ) ; 
prp( &dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
prt( "*...........................................*" ) ;  
prline( 1,  "*" ) ; 
prp( &warpshape, "INPUT SPECTRUM WARPSHAPE INDEX" ) ; 
prline( 1,  "*" ) ; 

prp( &randomdBfloor, "RANDOM AMPLITUDE VARIATION  FLOOR (dB) " ) ; 
prp( &randomdBresponse, "RANDOM AMPLITUDE VARIATION  RESPONSE TIME " ) ; 



fprintf( stderr,"\n*******************************************\n\n" ) ; 



//***********
// SETUP FILTER CONTROL VALUES
	         // FILTER INCREMENT IN SECONDS
    filttinc =  (float) D / (float) R ; 
//***********

// MAKE THRESH AMP
    threshfac = pow( (double) 10.0, (double) (threshfacdB / 20.) );	

 //*****************
// SET UP SOME FILTER FILE VALUES
    analysis_fundamental = nyquist / (float) (analysis_N/2) ; 
    
//*****************

// MAKE COMPRESSION STUFF
    if( filtcompthresh > 0.){
	fprintf(stderr," \n\n***** COMPRESSION THRESHOLD MUST BE < 0dB. BYE.\n\n" ) ;
	exit( 0 ) ; 
    }
#define JGG
#ifdef JGG
    if( filtcompdecibels > 0.){
#else
    if( filtcompamp > 0.){
#endif
	fprintf(stderr," \n\n***** COMPRESSION DECIBELS MUST BE < 0dB. BYE.\n\n" ) ;
	exit( 0 ) ; 
    }
	//filtcompthreshamp = pow( (double) 10.0, (double) (filtcompthresh/20.) );
    filtcompthreshamp = dB_to_amp( filtcompthresh ) ; 
	//filtcompamp =  pow( (double) 10.0, (double) (filtcompdecibels/20.) );
    filtcompamp = dB_to_amp( filtcompdecibels ) ; 
    filtcompnormamp = 
	1. / (filtcompthreshamp + (filtcompamp * (1. - filtcompthreshamp))) ; 

    if((filtcompthreshamp < 1.0) && (filtcompamp < 1.0) ){
	compflag = 1;
    }
//*****************

    
    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    fvec( previous_channel, N+2 ) ;	/* previous analysis channels */

    fvec( F_lower,  analysis_N+2  ) ;	/* lower filter array */
    fvec( F_higher,  analysis_N+2  ) ;	/* higher filter array */

    fvec( channel_freqdev,  N + 2 ) ;	// channel SORT ARRAY ACCUMULATOR

    fvec( previous_ranampv, N+2 ) ;	/* channels old random amp value (0-1) */



//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(channow = 0; channow < ochan; channow++ ){

    // **** SET UP ANALYSIS CHANNEL
	ainchan = (achannelout == 0) ? channow : (achannelout - 1) ; 
    // SETUP FILTER CONTROL VALUES
	filttorigin.A[ 0 ] = fval( &filttorigin, dur, 0. );
	filttnow = filttorigin.A[ 0 ] ; // ACCUMULATED FILTER TIME POINT IN SECONDS
	oldfilttnow = filttnow ; //INITIALIZE OLD FILTER TIME POINT IN SECONDS

prline( 69,   "=" ) ; 
pri( (ainchan+1), "INPUT ANALYSIS CHANNEL" ) ; 

    
    
    //*****   REINITS
    frame_count = 0 ;    eof = 0 ;  t = 0 ; samps = 0 ; 
    autostopflag = 0 ; 

//**** SEED RANDOM
    srandom(1);


//***** ZERO OLD RAN AMP VALUES
    for( i = 0; i < N; i++ ) previous_ranampv[i] = 0. ; 



    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;

//********** MAKE SOME ANNOUNCEMENTS
//    if(dBhi != 0. )fprintf(stderr," \nUSING FILTER EQ ......" ) ;
    if( compflag == 1 )fprintf(stderr," \nUSING FILTER SPECTRUM COMPRESSION......" ) ;
    fprintf(stderr," \n") ; 

	
 //*********************************************
// LOOP FOR FRAMES
//*********************************************

   while ( (t < dur) && (autostopflag == 0) ) {
	in += D ;
	on += I ;
	timenow( dur ) ;



//*************
// FILTER TIME ISSUES




	// LOW WINDOW TIME POINT
		filtwinlow.A[ 0 ] = fval( &filtwinlow, dur, t );
		if(filtwinlow.A[ 0 ] < 0.)filtwinlow.A[ 0 ] = 0. ; 
		if(filtwinlow.A[ 0 ] > analysis_dur)filtwinlow.A[ 0 ] = analysis_dur ;  

	// HIGH WINDOW TIME POINT
		filtwinhi.A[ 0 ] = fval( &filtwinhi, dur, t );
		if(filtwinhi.A[ 0 ] > analysis_dur)filtwinhi.A[ 0 ] = analysis_dur ; 
		if(filtwinhi.A[ 0 ] < 0.)filtwinhi.A[ 0 ] = 0. ;

	// WINDOW SIZE
		temp = filtwinhi.A[ 0 ] - filtwinlow.A[ 0 ] ;  
		if( temp == 0. ){
		    // ZERO WINDOW SIZE
		    filttnow = filtwinlow.A[ 0 ] ; 
		}else if(temp < 0.){
		    // UPPER BENEATH LOWER
		    while(filttnow >= filtwinlow.A[ 0 ]){
			filttnow += temp ;
			prf( t, "CROSSED LOWER BOUNDARY (NOW ABOVE LOWER) AT TIME" ) ;
			if( autostop != 0 ) autostopflag = 1 ;  
		    } 
		    while(filttnow < filtwinhi.A[ 0 ]){
			filttnow -= temp ; 
			prf( t, "CROSSED UPPER BOUNDARY (NOW BENEATH LOWER) AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    }
		}else{
		    // REGULAR
		    while(filttnow >= filtwinhi.A[ 0 ]){
			filttnow -= temp ; 
			prf( t, "CROSSED UPPER BOUNDARY AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    }
		    while(filttnow < filtwinlow.A[ 0 ]){
			filttnow += temp ;
			prf( t, "CROSSED LOWER BOUNDARY AT TIME" ) ; 
			if( autostop != 0 ) autostopflag = 1 ;  
		    } 
		    
		}

//*************

// filttnow IS NOW INSIDE THE WINDOW


//******************************************************************************
// MAKE THE FILTER FRAME
//******************************************************




		filtf = iframes_per_sec * filttnow ; // VIRTUAL FRAME 
		filtflow = (int) filtf ; // LOWER FRAME
		filtfhigh = filtflow + 1 ; // HIGHER FRAME
		filtfprop =  filtf - (float) filtflow ; // PROPORTIONAL POSITION BETWEEN FRAMES

// READ IN THE LOWER AND HIGHER FRAMES
	    
    if((t == 0.) || (filtflowold != filtflow)){
	// POSITION TO LOWER FRAME
		k = ((FFT_HEADER_SIZE + 
		    ((ainchan + (analysis_chan * filtflow) ) 
			    * (analysis_N + 2) ) ) * sizeof(float)) ; 
		fseek( filter.fp,  k,  SEEK_SET ) ; 
	// READ IN LOWER FRAME		
		fread( F_lower, sizeof(float), analysis_N+2, filter.fp ) ;
    
	// POSITION TO HIGHER FRAME
		k = ((FFT_HEADER_SIZE + 
		    ((ainchan + (analysis_chan * filtfhigh) ) 
			    * (analysis_N + 2) ) ) * sizeof(float)) ; 
		fseek( filter.fp,  k,  SEEK_SET ) ; 
	// READ IN HIGHER FRAME		
		fread( F_higher, sizeof(float) , analysis_N+2, filter.fp ) ;
    }

// MAKE INTERPOLATED FRAME
	for( i = 1; i < analysis_N; i +=2){
	    channel[i - 1] = F_lower[i - 1] + (filtfprop * (F_higher[i - 1] - F_lower[i - 1])) ; 
	    channel[i] = F_lower[i] + (filtfprop * (F_higher[i] - F_lower[i])) ; 

	}
	// SETUP PREVIOUS CHANNEL
	    if( !frame_count )for(i = 0; i < analysis_N; i++)
		    previous_channel[ i ] = channel[ i ] ; 
	// SETUP FREQDEV HISTORY ARRAY
	    	for( i = 1; i < N; i+= 2 ) {
			channel_freqdev[ i - 1 ] = 0. ; 
			channel_freqdev[ i ] = 1. ; 
		}
	
// SAVE OLD FRAME NUMBERS
		filtflowold = filtflow ; 
// SAVE THE OLD TIME POINT
		oldfilttnow = filttnow ; 



// INCREMENT FILTER TIME POINT
    // BRANCH FOR EXPLICIT OR RATE MODE
	if( imode == 0 ){
	    // EXPLCIT MODE
	// FIND THE TIME POINT ORIGIN
		filttorigin.A[ 0 ] = fval( &filttorigin, dur, t );
		filttnow = filttorigin.A[ 0 ] ; 
	} else{
	    // RATE MODE
   // FIRST GET THE FRAME RATE MULTIPLIER
		filtrate.A[ 0 ] = fval( &filtrate, dur, t );
		filttnow += (filttinc * filtrate.A[ 0 ]) ;
	}

//  TIME POINT DITHER WINDOW
	 ditherwin.A[ 0 ] = fval( &ditherwin, dur, t );
	if( ditherwin.A[ 0 ] > 0.){
		    dwin = ditherwin.A[ 0 ] / 2. ; 
	    filttnow += randf( (-dwin),  dwin ) ; 
        }

	// GET TIME POINT CHANGE SMOOTH VALUES
	tsmooth.A[ 0 ] = fval( &tsmooth, dur, t );
	    smooth_setup( tsmooth.A[ 0 ], &tsmoothc, &minustsmoothc, IR ) ; 



	// SMOOTH THE TIME POINT
	filttnow = (tsmoothc * oldfilttnow ) + ( minustsmoothc * filttnow ); 




// WE HAVE THE NEXT NONWINDOWED filttnow. 

		
//******************************************************
//*************NORMALIZE THE INPUT SPECTRUM
    normalize(  channel,  analysis_N,   normamppk  ) ;

//**************COMPRESS THE INPUT SPECTRUM
   if( compflag == 1 )
	compress( channel,  analysis_N,  filtcompthreshamp, filtcompamp,  filtcompnormamp ) ; 

//*************WARP THE INPUT SPECTRUM
	warpshape.A[ 0 ] =  fval( &warpshape, dur, t );
    spectmagwarp( channel,  analysis_N, warpshape.A[ 0 ], 0 ) ;

//*************EQUALIZE THE INPUT SPECTRUM
   // eq( channel,  analysis_N,  dBlow,  dBhi, freqlow,  freqhi,  analysis_fundamental, 1,  0, 0 ) ; 

//************* GAIN SCALE BACK
    gainscale(  channel,  analysis_N,   normamppk  ) ;

//*************************
// GET THE VALUES
//*************************


//  SHIFT, GAIN, AND TRANSPOSITION

		harmadd.A[ 0 ] =  fval( &harmadd, dur, t );
		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp( dBgain.A[ 0 ] ) ; 
		ptrans.A[ 0 ] = fval( &ptrans, dur, t );
		    pm = semitones_to_mult( ptrans.A[ 0 ] ) ;

		//RELEASE
		release.A[ 0 ] = fval( &release, dur, t );
		    smooth_setup( release.A[ 0 ], &releasec, &minusreleasec, IR ) ; 
		attack.A[ 0 ] = fval( &attack, dur, t );
		    smooth_setup( attack.A[ 0 ], &attackc, &minusattackc, IR ) ; 

		// FRQ SMOOTH
		fsmooth.A[ 0 ] = fval( &fsmooth, dur, t );
		    smooth_setup( fsmooth.A[ 0 ], &fsmoothc, &minusfsmoothc, IR ) ; 


		// EQ VALUES
		dBlow.A[ 0 ] =  fval( &dBlow, dur, t );
		dBhi.A[ 0 ] =  fval( &dBhi, dur, t );
		freqlow.A[ 0 ] =  fval( &freqlow, dur, t );
		freqhi.A[ 0 ] =  fval( &freqhi, dur, t );


		// RANDOM AMP VARIATION
		randomdBfloor.A[ 0 ] = fval( &randomdBfloor, dur, t );
		randomdBresponse.A[ 0 ] = fval( &randomdBresponse, dur, t );
		    smooth_setup( randomdBresponse.A[ 0 ], 
			    &ranampsmoothc, &minusranampsmoothc, IR ) ; 



//*************************


//*****************
// MODIFICATIONS LOOP
//*****************

    // SMOOTH THE CHANGES TO THE SPECTRUM
    smooth( channel, previous_channel, N, attackc, minusattackc, releasec, minusreleasec ) ; 

    for( i = 1, j = 0; i < N; i+= 2, j++ ){


		// FREQ SMOOTH
			channel[i] =  (fsmoothc * previous_channel[i] )
				+ ( minusfsmoothc * channel[i] ); 
		    previous_channel[i] = channel[i] ; 

//******* 

// SHIFT BY -a AND TRANSPOSE BY -P

		    temp = pm * (channel[i] + harmadd.A[ 0 ]) ;
		    
		// ADD THIS MULTIPLIER TO THE STORE MULTIPLIERS
		    channel_freqdev[ i ] *= pm ; 
		// ADD THIS ADDER TO THE STORE ADDERS
		    channel_freqdev[ i - 1 ] *= harmadd.A[ 0 ]  ; 
		    
		// ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
		    if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
		    else channel[i] = temp ; 


		// RANDOM AMPLITUDE VARIATION

		temp = (ranampsmoothc * previous_ranampv[i - 1] )
				+ ( minusranampsmoothc * randf( randomdBfloor.A[ 0 ],  0. ) ); 
		channel[i - 1] *= dB_to_amp( temp ) ; 

		previous_ranampv[i - 1] = temp ; 


		    channel[i - 1] = channel[i - 1] * gain ;  

    }
		
//*************EQUALIZE THE OUTPUT SPECTRUM
//    eq2( channel,  N,  dBlow,  dBhi, freqlow,  freqhi,  analysis_fundamental, channel_freqdev, 0 ) ; 
    eq2( channel,  N,  dBlow.A[0],  dBhi.A[0], freqlow.A[0],  freqhi.A[0],  analysis_fundamental, channel_freqdev, 0 ) ; 
		

        synt = getthresh( channel, N, threshfac );


// ** OSCIL BANK OR OVERLAP/ADD OUT
	if ( obank ) {
	    noscbank(channel, N2, R, Nw, I, P, output);
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;
	} else {
	    unconvert( channel, buffer, N2, I, R ) ;

	    rfft( buffer, N2, INVERSE ) ;
	    overlapadd( buffer, N, Wsyn, output, Nw, on ) ;
	     shiftout( output, Nw, I, on, 0 ) ;
	
	}

	frame_count++ ; 

    // FRAMES LOOP END

    }
    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    fprintf(stderr,"\nTIMEWARP : RESYNTHESIS COMPLETED\n");

    if( harmadd.n != 1. ) fclose(harmadd.fp ) ;
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;
    if( ptrans.n != 1. ) fclose(ptrans.fp ) ;
    if( sourcedB.n != 1. ) fclose(sourcedB.fp ) ;
    if( attack.n != 1. ) fclose(attack.fp ) ;
    if( release.n != 1. ) fclose(release.fp ) ;
    if( fsmooth.n != 1. ) fclose(fsmooth.fp ) ;
    if( filter.n != 1. ) fclose(filter.fp ) ;
    if( filtrate.n != 1. ) fclose(filtrate.fp ) ;
    if( filttorigin.n != 1. ) fclose(filttorigin.fp ) ;
    if( filtwinlow.n != 1. ) fclose(filtwinlow.fp ) ;
    if( filtwinhi.n != 1. ) fclose(filtwinhi.fp ) ;
    if( ditherwin.n != 1. ) fclose(ditherwin.fp ) ;
    if( tsmooth.n != 1. ) fclose(tsmooth.fp ) ;
    if( warpshape.n != 1. ) fclose(warpshape.fp ) ;
    if( randomdBfloor.n != 1. ) fclose(randomdBfloor.fp ) ;
    if( randomdBresponse.n != 1. ) fclose(randomdBresponse.fp ) ;
    if( dBlow.n != 1. ) fclose(dBlow.fp ) ;
    if( dBhi.n != 1. ) fclose(dBhi.fp ) ;
    if( freqlow.n != 1. ) fclose(freqlow.fp ) ;
    if( freqhi.n != 1. ) fclose(freqhi.fp ) ;



    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"twarp:  time-varying  phase vocoder resynthesis\n"
	"twarp   [flags]  [output file ]\n"
	"	    (values in brackets denote defaults)\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  \n"
	"		    2 = Blackman,  3 = Bartlett triangular [0.]\n"
	"	D:	analysis frames per second [200]\n"

	"	d:	output duration in seconds \n"
	"	C:	resynthesis channel (1 -> ?) (0 = all) [0] \n"

	"	P:	pitch transposition in semitones (func) [0]\n"
	"	a:	frequency shift factor (bin frequency adder, before -P )(func)[0.] \n"
	"	A:	gain in decibels (func) [0.] \n"

	"	F:	phase vocoder analysis file \n"

	"	u:	DATA access mode [1]\n"
	"		   (0 = explicit time: Use -Q)\n"
	"		   (1 = rate mode: Use -Q as begin point, -Y as rate control) \n"
	"	Q:	DATA time point (func) [0.] \n"
	"	g:	DATA time window: lower boundary (func) [0.] \n"
	"	G:	DATA time window: upper boundary (if < 0,  then EOF) (func) [end of file] \n"
	"	Y:	DATA rate multiplier (func) [1.]\n"
	"		    (1. = rate of original, 2. = twice as fast, etc.)\n"
	"		    (negative = reverse,  0 = stationary) \n"
	"	S:	DATA auto stop: 0 = off,  1 = on [0]\n"
	"		    (When on,  auto stop will terminate synthesis\n"
	"		      when a time boundary is crossed.)\n"
	"	T:	DATA time point dither window size in seconds (0 (off) -> ? ) (func) [0.] \n"
	"		 (This  value defines a window of randomization \n"
	"		    positioned around the time point, in which the\n"
	"		     time point is selected.)\n"
	"	K:	timepoint change response time in seconds (func) [0.] \n"
	"		    (Use for smoothing dithered or angular time functions)\n"

	"	E:	spectrum compression threshold (in decibels) [0] \n"
	"	c:	spectrum decibels of compression [0] \n"

	"	W:	warp index for reshaping magnitude response (func) [0.] \n"
	"		    values > 0 expand the dynamic range, \n"
	"		    values < 0 compress the dynamic range \n"

	"	b:	random amplitude variation floor in dB 0 to -96 (func) [0.] \n"
	"	e:	random amplitude variation response time in seconds (func) [0.] \n"

	"	l:      envelope attack time  (func) [0.]\n"
	"	L:      envelope release time   (func) [0.]\n"
	"	f:      frequency change response time   (func) [0.]\n"
	
	"	     FILTER FREQUENCY RESPONSE -- SHELF EQ: (post transpostion/shift)\n"
	"	H:	FILTER SHELF EQ: Low shelf gain in dB (func) [0.] \n"
	"	X:	FILTER SHELF EQ: High shelf gain in dB (func) [0.] \n"
	"	m:	FILTER SHELF EQ: Low shelf frequency in Hz (func) [200.] \n"
	"	R:	FILTER SHELF EQ: High shelf frequency in Hz (func) [2000.] \n"

	"	t:	oscillator resynthesis threshold in dB [-96]\n"
	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 

	"	_:	 OUTPUT FORMAT: 0 = taken from input file\n"
	"		    1 = 16-bit integer, 2 = 32-bit floats [0]\n" 

	"	=:	 PEAK RESCALE LEVEL (float output only) 0 to -96 dB \n"
	"		    set to 1 to rescale to level of input file [ 1 ]\n" 

	);
    exit(woof);
}


int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

