#include "globals.h"
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>


/* CRACK STUFF */
int arg_index = 0;
char *arg_option;
char *pvcon = NULL;
char *index();



/************************************************************/

int main(argc,argv)
   int argc;
   char *argv[]; 
   {
   


    char	*filename, 
		ch, 
		crack()
    ;

    float norm=1.,  amplitude,  dB ; 
    
 
/*GIVE USAGE AND EXIT IF NO ARGUMENTS */
   if(argc == 1) {
	fprintf( stderr,"%s",
	"USAGE:\n\n   amptodB [ flags ] amplitude(s)\n" 
	"\tflags:\n"
	"	(values in brackets denote defaults)\n"
	"   :n	    normalization amplitude [1.]\n\n"
	"   This routine prints out the amplitude value(s) in decibels.\n"
	"   Specification of the -n flag (i.e. -n32000. ) causes the amplitude to first \n"
	"   be normalized to the -n range ( i.e. amplitude / 3200. ). \n"
	 );
	exit(0);
    }

    while((ch = crack(argc,argv,"n|",0)) != 0)
{
        switch(ch) {
            case 'n': norm = atof(arg_option) ;
			fprintf( stderr, "\nNORMALIZATION AMPLITUDE = %f",  norm ) ;                 
		 break;	
        }
    }

   if(arg_index >= argc) {
       // ABORT
       fprintf( stderr, "\n\nWHERE IS THE AMPLITUDE VALUE??\n\n" ) ;
       exit( 0 ) ; 
   }
    fprintf( stdout, "\n\n" ) ; 
    
    while(arg_index < argc){ 
  
      /* GET AMPLITUDE VALUE */
       amplitude = atof(argv[arg_index]) ;
       amplitude = amplitude / norm ; 
       dB = 20. * log10( (double) amplitude ) ; 

	if( norm != 1. )
	    fprintf( stdout, "\nNORMALIZED AMPLITUDE:\t%-f\tDECIBELS:\t%-6.2f dB",  amplitude,  dB ) ; 
	else
	    fprintf( stdout, "\nAMPLITUDE:\t%-f\tDECIBELS:\t%-6.2f dB",  amplitude,  dB ) ; 
	
	// GO TO NEXT
	arg_index++ ; 

    }
    fprintf( stdout, "\n\n" ) ; 

    exit( 1 ) ; 
}


char crack(argc, argv, flags, ign)
    int argc; char **argv; char *flags; int ign;
{
    char *pv, *flgp, *index();
    while ((arg_index) < argc)
	{
	if (pvcon != NULL)
	    pv = pvcon;
	else
	    {
	    if (++arg_index >= argc) return(0); 
	    pv = argv[arg_index];
	    if (*pv != '-') 
		return(0);
	    }
	pv++;		/* skip '-' or prev. flag */
	if (*pv != 0) 
	    {
	    if ((flgp=index(flags, *pv)) != NULL)
		{
		pvcon = pv;
		if (*(flgp+1) == '|') { arg_option = pv+1; pvcon = NULL; }
		return(*pv);
		}
	    else
		if (!ign)
		    {
		    fprintf(stderr, "\n\n%s: no such flag: %s\n", argv[0], pv);
		    return(EOF);
		    }
		else
		    pvcon = NULL;
	    }
	pvcon = NULL;
	}
    return(0);
    }

int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }
