#include "globals.h"
#define NUM_PARAMETERS 6

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k, l,  i1,  i2, ipartial,   n, exflag, 
     NC, NC2,   np,  nf=2,  first=1  ;
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag = 0,  channelout=0 ;
float P = 1.0;
FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel,  *F,  *FT,  *SUM,  *harmony ; 
 float threshfac = .001;
float	gain=1. ;
float  temp,  temp2,  temp3,  temp4,  temp5,  temp6 ;  
float getthresh();
float peakbinamp = 0.,  avgbinamp=0.,  averagedB,  peakamp=0,  peakfreq, 
    dBedge=-96,  dbdown1,  dbdown2,  percentofbins, dBrolloff ;
float fundamental ; 
int   invert_flag=0,  nbins=0,  spectmethod=0 ;
float   IR,  dur=0.;

// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 
int eqnormbypassflag=0 ; 

float partfreq,  fundfreq,  octroll,  partdB ; 

FILE *data ; 
char datafile[ 128 ] = "EMPTY\0" ; 
char datafile2[ 128 ] = "EMPTY\0" ; 
char new_datafile[ 128 ] = "EMPTY\0" ; 
float *PP, *domainamp, *partialamp,    fund=100.,  freqdiff,  target_gain,  SOURCE_gain,  midC,  part ; 
int method=1,  nd=0,  vb=0 ; 
float bw1,  bw2,  bw ; 
char tempstring[ 128 ] ; 

int window_t=0 ; 

if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|Z|F|D|s|v|i|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':	N = atoi(arg_option);
			break;

	    case 'R':	R = atoi(arg_option);
			break;

	    case 'Z':   method = atoi(arg_option) ;
			break;
	    case 'D':   window_t = atoi(arg_option) ;
			break;
	    case 's':   spectmethod = atoi(arg_option) ;
			break;
	    case 'i':   invert_flag = atoi(arg_option) ;
			break;

	    case 'F':   strcpy(datafile, arg_option);
			break;

	    case 'v':	vb = atoi(arg_option) ;
			break;

	    case 'h':	usage(1);
	}
    }

//*****************
prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "CHORDRESPONSEMAKER", 69 ) ; 
prline( 69,  "-" ) ; 


    midC = (220.*pow(2., (3./12.))) ; 
    freqdiff = (float) R / (float) N ; 
    nyquist = R/2.0;
    fundamental =  ((float) R / (float) N) ; 


if( window_t == 0 )dBedge = -96. ; 
else if( window_t == 1 ) dBedge = 0. ; 
else {
    prt( "ILLEGAL WINDOW TYPE" ) ; 
    exit( 0 ) ; 
}


//fprintf( stderr,  "\nN: %d, R: %d,    BASEFREQ: %f",N, R,    freqdiff ) ; 

// GET NAME OF OUTPUT FILE

/* GET OUTPUT FILE NAME */
   ofile = argv[arg_index] ; 

    /* OPEN FOR BUSINESS */

    
    ofd = open(ofile,O_RDWR,(0644));
    if(ofd < 0) {
	fprintf( stderr,  "\n\n%s DOES NOT YET EXIST. I'LL MAKE IT.\n", ofile );
	exflag = open(ofile, O_CREAT,(0644)); 
	if( exflag == -1 ){
	    bannero() ;
	    fprintf( stderr,  "\n\n I COULD NOT MAKE THE FILE:\n\n-----> %s <-------\n\n",  ofile ) ; 
	    fprintf( stderr,  "\n\n CHECK THE PATH OF YOUR FILE. ....BYE.\n\n" ) ; 
		exit( 0 ) ; 
	}
	ofd = open(ofile, O_RDWR,(0644));
    }else{
	open(ofile, O_TRUNC, (0644));
    }

//*********************************
prs( ofile, "FREQUENCY RESPONSE FUNCTION OUTPUT FILE" ) ; 
prline( 1,  "*" ) ; 
prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

if( window_t == 0 )prt( "USING TRIANGULAR WINDOW" ) ; 
else prt( "USING RECTANGULAR WINDOW" ) ; 

prline( 1,  "*" ) ; 
    if( spectmethod == 0 )prt( "SPECTRUM ACCUMULATION METHOD: PEAK" );
    else prt( "SPECTRUM ACCUMULATION METHOD: SUM" ) ;
prline( 1,  "*" ) ; 
    if( invert_flag )prt( "BAND REJECT " );
    else prt( "BAND PASS" ) ;
prline( 1,  "*" ) ; 
//*********************************




//fprintf( stderr,  "\n datafile = %s, datafile2 = %s  ",  datafile,  datafile2 )  ; 
if( (strcasecmp( datafile, datafile2 ) == 0)){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A DATA FILE. BYE.\n\n" ) ;
    usage(1);
}




// MAKE NEW DATA FILE WITH COMMENTED LINES REMOVED

    cut_data_lines( datafile,  new_datafile,  NUM_PARAMETERS ) ; 


//**************************GET DATA	
// READ IN CHORD TONES, SHIFTPOINT, NUMBER_OF_PARTIALS, BW, AND DB
// OPEN FILE
	if( (data = fopen( new_datafile, "r")) == NULL ){
	    fprintf( stderr, "\n%s <-- NO SUCH FILE. BYE.\n",  datafile ) ; 
	    exit(0); 
	}
// COUNT VALUES IN FILE
	k = 0 ; 
	while( fscanf( data,  " %f ",  &temp ) != EOF ) k++ ; 			
	rewind( data ) ;    
// ALLOCATE SPACE FOR CHORD TONES
    fvec( PP, k ) ;	/* PARTIALS */
// COMPUTE NUMBER OF TONES
    np = k / NUM_PARAMETERS ;

fprintf( stderr,  "\nCHORDRESPONSEMAKER:  \n- datafile values - " ) ;
if(method == 1){
    fprintf( stderr,  "\n******************************************************************************" ) ; 
    fprintf( stderr,  "\nOctave.Pitch|Number of   |BW          |Decibels    |Partials    |dB Rolloff  |" ) ; 
    fprintf( stderr,  "\nClass       |Partials    |Proportion  |            |Spacing Prop|per Octave  |" ) ; 

}else{
    fprintf( stderr,  "\n******************************************************************************" ) ; 
    fprintf( stderr,  "\nFrequency   |Number of   |BW          |Decibels    |Partials    |dB Rolloff  |" ) ; 
    fprintf( stderr,  "\n            |Partials    |Proportion  |            |Spacing Prop|per Octave  |" ) ;

}
    fprintf( stderr,  "\n.............................................................................|" ) ; 

// READ IN VALUES
k = 0 ; 
for( i = 0; i < np ; i++ ){
    fprintf( stderr,  "\n" ) ;
    for( j = 0; j < NUM_PARAMETERS ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	    fprintf( stderr,  "%-12.3f|", PP[ k ]  ) ;
	     k++ ; 			
    }
} 
    fprintf( stderr,  "\n******************************************************************************" ) ; 

// ALLOCATE FILTER SPACE
fvec( F,  N+2  ) ;	/* filter array */

// INITIALIZE ARRAY
    for(i = 1,  j = 0;  i < N; i += 2,  j++){
	 F[i - 1] = 0. ;  // SET AMP TO ZERO
	 F[i] = (float) (j)  * freqdiff  ; // SET FREQ
    }

    
    // FOR EACH TONE, REDUCE THE AMP BY ITS SPECIFIED AMOUNT

    // LOOP FOR  TONES

    for( j = 0; j < (np*NUM_PARAMETERS) ; j += NUM_PARAMETERS ){

	// FIND THE TONES FREQUENCY AND MAKE THE BW MULTIPLIER
	if( method == 1 ){
 
	// TRANSLATE OCTAVE.PT.PITCHCLASS INTO FREQUENCY AND REPLACE IN ARRAY
	    temp = (float) ((int) PP[j] ) ; // INTEGER PART
	    temp =  (( 12. * (temp - 8.)) + 
		    (100. * (PP[j] - temp)) ) / 12. ;

	    fundfreq = temp = midC * pow( 2., (double) temp ) ; 
		    // FREQUENCY METHOD
	} else if(method == 0) {
 
	    // MOVE FREQUENCY INTO TEMP
	    fundfreq = temp = PP[j] ;
	}
	    // MAKE BW ADDER
	    bw = temp * PP[j + 2] * .5 ;

	    // IF NUMBER OF PARTIALS IS 0, COMPUTE NUMBER UP TO NYQUIST
	    if( (int) PP[j + 1] <= 0 ){
		PP[j + 1] = (float) ((int)((nyquist - temp) / (temp * PP[j + 4]))) ; 
	    }

	    // CREATE PARTIAL DB ROLLOFF INCREMENT

		dBrolloff = PP[j + 5] ; 






	// LOOP FOR PARTIALS
	for( k = 1; k <= (int) PP[j + 1]; k++ ){

	// MAKE PARTIAL FREQUENCY
	    partfreq = temp3 = temp + (temp * PP[j + 4] * (float) (k - 1)) ; 
	// INDEX OF THE FREQ BIN BELOW THE PARTIAL
	i1 = 1 + (2 * ( rint((double)(temp3 - bw) / freqdiff)) ) ; 
	// INDEX OF THE FREQ BIN ABOVE THE PARTIAL
	i2 = 1 + (2 * ( rint((double)(temp3 + bw) / freqdiff)) )  ;  
	// INDEX OF THE FREQ BIN AT THE PARTIAL
	ipartial = 1 + (2 * ( rint((double)(temp3) / freqdiff)) )  ;  


	// PROPORTION OF PARTIAL TO FUNDAMENTAL IN OCTAVES
	octroll = log10( (double) ( partfreq / fundfreq ) ) / log10( 2. )  ; 


	// FIND THE DB LEVEL OF THE PARTIAL
	partdB = (PP[j + 3] + (octroll * dBrolloff)) ; 
	partdB = ( partdB < -96 ) ? -96 : partdB ; 

	// FIND DECIBEL DOWN INCREMENT ABOVE AND BELOW
	    // BELOW
	temp6 = (float) (ipartial - i1) / 2 ;  
	if((temp6 == 0.) || (window_t == 1) ) dbdown1 = 0. ; 
	else dbdown1 = (dBedge - partdB) / temp6 ; 
	    // ABOVE
	temp6 = (float) (i2 - ipartial) / 2 ;  
	if((temp6 == 0.)  || (window_t == 1)  ) dbdown2 = 0. ; 
	else dbdown2 =  (dBedge - partdB) / temp6  ; 

//fprintf( stderr,  "\npartdB: %f,  dBedge: %f,  dbdown1: %f,  dbdown2: %f",
//	    partdB,  dBedge,  dbdown1,  dbdown2 ) ;  


	// SETUP PARTIAL
	    // IF IN RANGE.....
	    if((ipartial > 0) && (ipartial < N) ){

		// AMP
		if(F[ ipartial - 1] == 0.) nbins++ ; 

		    // MAKE FINAL AMP
		    temp5 = pow( (double) 10.0, (double) partdB / 20. ) ;



		// PEAK OR SUM RESPONSE
		if(spectmethod == 0){
		    // PEAK
		    if(temp5 > F[ ipartial - 1] )  F[ ipartial - 1] = temp5 ; 
		}else{
		    // SUM
		    F[ ipartial - 1] = F[ ipartial - 1] + temp5 ; 
		}

	    }


	// LOOP FOR THE ipartial-i1 BINS
	for(i = i1; i < ipartial; i += 2){
	    // IN THE NEXT (ipartial-i1)*2 SPACES IN THE FILTER ARRAY 
	    // PLACE THE APPROPRIATE AMP VALUE FOR THIS TONE
	    
	    // IF IN RANGE.....
	    if((i > 0) && (i < N) ){
		// AMP
		if(F[ i - 1] == 0.) nbins++ ; 
		temp6 = (float) ((ipartial - i) / 2) * dbdown1 ; 
		temp5 =  (PP[j + 3] + (octroll * dBrolloff) + temp6) ;
		temp5 = (temp5 < -96.) ? -96 : temp5 ;  
		temp5 = pow( (double) 10.0, (double) temp5 / 20. ) ;


		// PEAK OR SUM RESPONSE
		if(spectmethod == 0){
		    if(temp5 > F[ i - 1] )  F[ i - 1] = temp5 ; 
		}else{
		    F[ i - 1] = F[ i - 1] + temp5 ; 
		}


	    }
	}


	// LOOP FOR THE ipartial-i2 BINS
	for(i = i2; i > ipartial; i -= 2){
	    // IN THE NEXT (ipartial-i2)*2 SPACES IN THE FILTER ARRAY 
	    // PLACE THE APPROPRIATE AMP VALUE FOR THIS TONE
	    
	    // IF IN RANGE.....
	    if((i > 0) && (i < N) ){
		// AMP
		if(F[ i - 1] == 0.) nbins++ ; 
		temp6 = (float) ((i - ipartial) / 2) * dbdown2 ; 
		temp5 =  (PP[j + 3] + (octroll * dBrolloff) + temp6) ;
		temp5 = (temp5 < -96.) ? -96 : temp5 ;  
		temp5 = pow( (double) 10.0, (double) temp5 / 20. ) ;


		// PEAK OR SUM RESPONSE
		if(spectmethod == 0){
		    if(temp5 > F[ i - 1] ) F[ i - 1] = temp5 ; 
		}else{
		    F[ i - 1] = F[ i - 1] + temp5 ; 
		}

	    }
	}

      }

    }

// NORMALIZE
//*************NORMALIZE THE SYNTHESIZED SPECTRUM
    normalize(  F,  N,   1.  ) ;


// FIND THE PEAK AND AVERAGE
    peakamp = 0 ; peakfreq = 0 ; avgbinamp = 0 ; 
    for( i = 1; i < N; i += 2 ){
	avgbinamp += F[ i - 1] ; 
	if( F[ i - 1] > peakamp ) {
	    peakamp = F[ i - 1] ;
	    peakfreq = F[ i ] ;  
	}
    }

    avgbinamp = avgbinamp / (float) (nbins) ; 
    averagedB = (float) (20. * log10( (double) avgbinamp )) ; 
    percentofbins = (float) nbins / (float) (N / 2) ; 



// PRINT STATS
    fprintf( stderr,  "\n\nAVERAGE BIN AMP: %f dB", averagedB ) ;  
    fprintf( stderr,  "\n\nNUMBER OF NON-ZERO BINS: %d", nbins ) ;  
    fprintf( stderr,  "\n\nPROPORTION OF NON-ZERO BINS: %f \%", percentofbins ) ;  

// INVERT FILTER IF BAND REJECT
    if( invert_flag != 0 ){
	for(i = 1; i < N; i += 2){
	    F[i - 1] = 1. - F[i - 1] ; 
	}
    }

prf( fundamental,  "FUNDAMENTAL" ) ; 

// LET'S SEE THE FILTER
    if( vb )tprintspec( F, N, fundamental,  vb ) ;

 
// WRITE RESPONSE TO stdout
    for( i = 0; i < N; i++ )write(ofd,  &F[ i ], sizeof(float) ) ;

    close(ofd) ; 

fprintf( stderr,  "\n\nNUMBER OF SYNTHESIS OUTPUT AMP/FREQ PAIRS:    %d\n",  i/2 ) ; 
    
    
    fprintf(stderr,"\nCHORDRESPONSEMAKER : SYNTHESIS OF RESPONSE COMPLETED\n");
  
    fclose( data ) ; 
 
    exit( 0 ) ;
}
usage(int woof)
{
    fprintf(stderr, "%s",
	"chordresponsemaker:  chordal frequency response synthesizer\n"
	"			(multiple harmonic tone format)  \n"
	"			(values in brackets represent defaults)\n"
	"chordresponsemaker   [flags]  [output freqresponse file]\n"
	"	N:	fft length [1024]\n"
	"	R:	sampling rate [44100]\n"
	"	F:	(ascii) DATA FILE of unordered sextuples:\n"
	"		     Each consisting of: \n"
	"		     (1) pitch or frequency (see data pitch format below)\n"
	"		     (2) number of partials (0 = all partials below Nyquist)\n"
	"		     (3) bandwidth as proportion of fundamental frequency\n"
	"		     (4) decibels\n"
	"		     (5) partial spacing as proportion of fundamental frequency\n"
	"		     (6) decibel rolloff (+ or -) per octave of partials \n"
	"	Z:	DATA PITCH FORMAT: [1]\n"
	"		     0 = frequency\n"
	"		     1 = octave.pitch_class\n"
	"	s:	Frequency Response Accumulation Method: [0]\n"
	"		    (treatment of overlapping bin values)\n"
	"		    0 = peak response (uses highest of all)\n"
	"		    1 = sum response (uses sum of all)\n"
	"	D:	Band Window Type: 0 = triangle,  1 = rectangle [0]\n"
	"		    (As reflected in decibels)\n"
	"	i:	filter type: bandpass (0),  band reject (1) [0]\n"
	"	v:	frequency response stderr printout: high cutoff frequency in Hz [0]\n"
	"		    (0 = off)\n"
	);

    exit(woof);

}

int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

