 #include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k, jj,   i1,  i2 ;
float i1p,  i2p,  pm,  fm,  fs,  fdbm, fdpm, fdmdiff,  fd,  fsdiff,  fdevminus ; 
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag = 0,  channelout=0 ;
float P = 1.0;

float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel,  *F,  *Ffreq ; 
float threshfac = .001,  threshfacdB=-96 ;
float releasec,  minusreleasec,  attackc,  minusattackc ; 
double ar_dB ; 
float	gain=1. ;
int bandrejecton=0 ; 
FILE *fopen();
FILE *fp;

float peakampnow,  baseampnow,  peakdBnow,  basedBnow,  ampdiffnow,  dBdiffnow,  fdevdiff ; 

int print_flag=0 ; 
int pitchflag=0; 
char ch;
// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 

float  temp,  temp2,  temp3 ;  
float getthresh();
float   IR,  dur=0.;
int beginchan,  endchan ; 

float ampwarpshape,  freqwarpshape ; 

float fundamental, factor,   sourceamp,  filtamp ;  

char tempstring[ 128 ] ; 

// COMB FREQUENCY SHIFT ADDER
struct  func  harmadd ; 

// GAIN
struct  func  dBgain ; 

// PITCH SEMITONE TRANSPOSE
struct  func  ptrans ; 

// FILTER
struct  func  filter ; 

// FILTER SEMITONE TRANSPOSE
struct  func  ftrans ; 

// FILTER TRANSPOSE SHIFTER
struct  func  fshift ; 

//  SOURCE DECIBELS
struct  func  sourcedB ; 

//  RELEASE
struct  func  release ; 

//  ATTACK
struct  func  attack ; 

// **** FREQ DEVIATION: BASE
struct  func  fdevbase ; 

// **** FREQ DEVIATION: PEAK
struct  func  fdevpeak ; 

// **** FREQ DEVIATION SHIFT: BASE
struct  func  fshiftbase ; 

// **** FREQ DEVIATION SHIFT: PEAK
struct  func  fshiftpeak ; 

// **** FREQ DEVIATION: MASTER DEVIATION CONTROL
struct  func  fdevcontrol ; 

#include "underflow.h"


//*****************INITIALIZE
// COMB FREQUENCY SHIFT ADDER
harmadd.L = 1. ; harmadd.n = 1. ; harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// PITCH SEMITONE TRANSPOSE
ptrans.L = 1. ; ptrans.n = 1. ; ptrans.A[ 0 ] = 0. ; 

// FILTER
filter.L = 1. ; filter.n = 0. ; filter.A[ 0 ] = 0. ; 

// FILTER SEMITONE TRANSPOSE
ftrans.L = 1. ; ftrans.n = 1. ; ftrans.A[ 0 ] = 0. ; 

// FILTER TRANSPOSE SHIFTER
fshift.L = 1. ; fshift.n = 1. ; fshift.A[ 0 ] = 0. ; 

//  SOURCE DECIBELS
sourcedB.L = 1. ; sourcedB.n = 1. ; sourcedB.A[ 0 ] = -96. ; 

//  RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 

//  ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 

// **** FREQ DEVIATION: BASE
fdevbase.L = 1. ; fdevbase.n = 1. ; fdevbase.A[ 0 ] = 0. ; 

// **** FREQ DEVIATION: PEAK
fdevpeak.L = 1. ; fdevpeak.n = 1. ; fdevpeak.A[ 0 ] = 0. ; 


// **** FREQ DEVIATION SHIFT: BASE
fshiftbase.L = 1. ; fshiftbase.n = 1. ; fshiftbase.A[ 0 ] = 0. ; 

// **** FREQ DEVIATION SHIFT: PEAK
fshiftpeak.L = 1. ; fshiftpeak.n = 1. ; fshiftpeak.A[ 0 ] = 0. ; 


// **** FREQ DEVIATION: MASTER DEVIATION CONTROL
fdevcontrol.L = 1. ; fdevcontrol.n = 1. ; fdevcontrol.A[ 0 ] = 1. ; 




if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|w|M|P|D|t|n|G|I|p|i|B|u|U|F|b|O|E|k|v|K|e|C|i|T|Z|l|L|V|S|H|m|X|W|c|d|s|a|A|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':   N = atoi(arg_option);
			break;
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'w':   window_type = atoi(arg_option) ;
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;

	    case 'P':   strcpy(tempstring, arg_option);
			ptrans.fp = crackstring( tempstring, &ptrans ); 
			break;
	    case 'a':   strcpy(tempstring, arg_option);
			harmadd.fp = crackstring( tempstring, 
			    &harmadd );
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;
	    case 'B':   pitchflag = atoi(arg_option) ;
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

	    case 'H':   dBlow = atof(arg_option) ;
			break;
	    case 'X':   dBhi = atof(arg_option) ;
			break;
	    case 'm':   freqlow = atof(arg_option) ;
			break;
	    case 'R':   freqhi = atof(arg_option) ;
			break;

	    case 'k':   strcpy(tempstring, arg_option);
			fdevbase.fp = crackstring( tempstring, 
			    &fdevbase );
			break;
	    case 'K':   strcpy(tempstring, arg_option);
			fdevpeak.fp = crackstring( tempstring, 
			    &fdevpeak );
			break;

	    case 'u':   strcpy(tempstring, arg_option);
			fshiftbase.fp = crackstring( tempstring, 
			    &fshiftbase );
			break;
	    case 'U':   strcpy(tempstring, arg_option);
			fshiftpeak.fp = crackstring( tempstring, 
			    &fshiftpeak );
			break;

	    case 'O':   strcpy(tempstring, arg_option);
			fdevcontrol.fp = crackstring( tempstring, 
			    &fdevcontrol );
			break;

            case 'p':	quiet = atoi(arg_option)      ; break;
            case 'i':	ampstatinc = atof(arg_option) ; break;
            case 'Z':	print_flag = atoi(arg_option) ; break;



	    case 'F':   strcpy(tempstring, arg_option);
			filter.fp = crackstring( tempstring, 
			    &filter );
			break;

            case 'G':	bandrejecton = atoi(arg_option) ; break;


	    case 'T':   strcpy(tempstring, arg_option);
			ftrans.fp = crackstring( tempstring, 
			    &ftrans );
			break;
	    case 'V':   strcpy(tempstring, arg_option);
			fshift.fp = crackstring( tempstring, 
			    &fshift );
			break;
	    case 'S':   strcpy(tempstring, arg_option);
			sourcedB.fp = crackstring( tempstring, 
			    &sourcedB );
			break;

	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;
	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;


	    case 'W':   ampwarpshape = atof(arg_option) ;
			break;
	    case 'v':   freqwarpshape = atof(arg_option) ;
			break;




	    case 't':   threshfacdB = atof(arg_option);
			break;
	    case 's':	sflag = 1;
			break;
	    case 'h':	usage(1);
	}
    }

prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "FILDEVIATOR", 69 ) ; 
prline( 69,  "-" ) ; 

    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
 
// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 
    

// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 

    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
//*********************************
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    IR = (float) I / (float) R ; 
    fundamental = (float) R / (float) N ; 
    factor = (float) R / ((float) D * TWOPI) ; 

    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	
    
    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 


if( filter.n < 1. ){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A FILTER FUNCTION. BYE.\n" ) ;
    exit(0);
}


// SET UP FLAG FOR OSCIL BANK OR OVERLAP/ADD
    if( 
	(ptrans.n  != 1.) || (ptrans.A[0] != 0.) || 
	(harmadd.n  != 1.) || (harmadd.A[0] != 0.) ||
	(fdevbase.n  != 1.) || (fdevbase.A[0] != 0.) || 
	(fdevpeak.n  != 1.) || (fdevpeak.A[0] != 0.) || 
	(fshiftbase.n  != 1.) || (fshiftbase.A[0] != 0.) || 
	(fshiftpeak.n  != 1.) || (fshiftpeak.A[0] != 0.) 

    ){
	// OSC BANK
	P = 1. ; obank = 1 ;  
    }else{
	// OVERLAPP-ADD
	P = 0. ; obank = 0 ;  
    }



    
//***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 

prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
pri( tfactor,  "TIME EXPANSION/CONTRACTION FACTOR" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( I,  "      INTERPOLATION SAMPLES (samples between resynthesis frames)" ) ; 
prline( 1,  "*" ) ; 
prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (in dB)" ) ; 
prline( 1,  "*" ) ; 

prp( &dBgain,  "GAIN (in dB)"  ) ; 
prp( &ptrans,  "PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &harmadd,  "FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
if( bandrejecton ){
    prt( "FILTER TYPE: ............REJECT RESPONSE" ) ;
}else{
    prt( "FILTER TYPE: ............PASS RESPONSE" ) ;
}
prp( &ftrans,  "FILTER: PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &fshift,  "FILTER: FREQUENCY SHIFT (in Hz)"  ) ; 
prp( &sourcedB,  "FILTER: SOURCE SIGNAL FLOOR (in dB)"  ) ; 
prline( 1,  "*" ) ; 
prp( &attack,  "ENVELOPE ATTACK TIME (in seconds)"  ) ; 
prp( &release,  "ENVELOPE RELEASE TIME (in seconds)"  ) ; 
prline( 1,  "*" ) ; 
prf( ampwarpshape, "INPUT SPECTRUM AMPLITUDE DOMAIN WARPSHAPE INDEX" ) ; 
prline( 1,  "*" ) ; 


prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prf( freqlow, "LOW SHELF FREQUENCY" ) ; 
prf( dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prf( freqhi, "HIGH SHELF FREQUENCY" ) ; 
prf( dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
prt( "*...........................................*" ) ;  
prline( 1,  "*" ) ; 
// *******
prp( &fdevbase,  "BASE FREQUENCY DEVIATION (in semitones)"  ) ; 
prp( &fdevpeak,  "PEAK FREQUENCY DEVIATION (in semitones)"  ) ; 
prline( 1,  "*" ) ; 
prp( &fshiftbase,  "BASE FREQUENCY DEVIATION SHIFT (in Hz)"  ) ; 
prp( &fshiftpeak,  "PEAK FREQUENCY DEVIATION SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &fdevcontrol,  "MASTER FREQUENCY DEVIATION CONTROL (0-1)"  ) ; 




prf( freqwarpshape, "INPUT SPECTRUM FREQUENCY DOMAIN WARPSHAPE INDEX" ) ; 


//***************** SET UP ARRAYS


    
    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    fvec( previous_channel, N+2 ) ;	/* previous analysis channels */

// MAKE THRESH AMP
    threshfac = pow( (double) 10.0, (double) (threshfacdB / 20.) );	

// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 

// ALLOCATE FILTER SPACE FOR BOTH AMP AND FREQ FORMS OF RESPONSE
fvec( F,  N+2  ) ;	/* filter array */
fvec( Ffreq,  N+2  ) ;	/* filter array */

//************FIRST TIME: FILL ARRAY FROM FILE
    fillfunc( &filter, F, N  ) ;     

// ********** COPY F INTO Ffreq
    for(i = 0; i < (N+2); i++)Ffreq[i] = F[i] ; 
    
//*************EQ AND NORMALIZE
    if(dBlow !=  dBhi)prt("...............EQUALIZING AND NORMALIZING INPUT FREQUENCY RESPONSE....." ) ; 
    else prt("...............NORMALIZING INPUT FREQUENCY RESPONSE....." ) ;
    eq( F,  N,  dBlow,  dBhi, freqlow,  freqhi,  fundamental, 1,  0, 1 ) ; 

//*************** IF BAND REJECT, THEN INVERT THE RESPONSE
   if( bandrejecton ){
	prt( "INVERTING RESPONSE......." ) ;
	invertresponse( F,  N,  0  ) ; 
    }

//*************WARP: AMPLITUDE
    if(ampwarpshape != 0) prt("..............WARPING  RESPONSE AMPLITUDE DOMAIN....." ) ; 
    spectmagwarp( F,  N, ampwarpshape, 1 ) ;

//*************WARP
    if(freqwarpshape != 0) prt("..............WARPING  RESPONSE FREQUENCY DOMAIN....." ) ; 
    spectmagwarp( Ffreq,  N, freqwarpshape, 1 ) ;

//*********** PRINT TO TERMINAL IF DESIRED ******
    if(print_flag){
	prbanner( "FILTER RESPONSE",  69 ) ; 
	tprintspec( F, N, fundamental,  print_flag) ;
 	if(freqwarpshape != 0) {
	    prbanner( "FREQUENCY DEVIATION RESPONSE",  69 ) ; 
	    tprintspec( Ffreq, N, fundamental,  print_flag) ;
	}
   }
//************ CONVERT FREQUENCIES TO PHASE DIFFERENCES
    for(i = 1,  j = 0; i < N; i += 2,  j++) 
	F[ i ] = (F[ i ] - ((float) j * fundamental)) / factor ; 


//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 



    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
	
//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
	in += D ;
	on += I ;
	timenow( dur ) ;

	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
		  convert( buffer, channel, N2, D, R ) ;	 

	// SETUP PREVIOUS CHANNEL
	    if( !frame_count )for(i = 0; i < N; i++)
		    previous_channel[ i ] = channel[ i ] ; 







//*************************
// GET THE VALUES
//*************************


//  SHIFT, GAIN, AND TRANSPOSITION

		harmadd.A[ 0 ] =  fval( &harmadd, dur, t );
		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp(dBgain.A[ 0 ] );	
		ptrans.A[ 0 ] = fval( &ptrans, dur, t );
		    pm = semitones_to_mult( ptrans.A[ 0 ] ) ;


		fs = fshift.A[ 0 ] = fval( &fshift, dur, t );
		    // IF FREQ SHIFT FOR SOURCE ONLY, SUBTRACT FROM FILTER CHANGE
		    if( !pitchflag ) fs = fs - harmadd.A[ 0 ] ; 
		ftrans.A[ 0 ] = fval( &ftrans, dur, t );
		    fm = semitones_to_mult( ftrans.A[ 0 ]  ) ;
		    // IF PITCH TRANSPOSITION FOR SOURCE ONLY, DIVIDE OUT OF FILTER CHANGE
		    if( !pitchflag ) fm = fm / pm ; 

		sourcedB.A[ 0 ] = fval( &sourcedB, dur, t );
		    sourceamp = dB_to_amp(sourcedB.A[ 0 ] );
		    filtamp = 1. - sourceamp ;  


		attack.A[ 0 ] = fval( &attack, dur, t );
		    smooth_setup( attack.A[ 0 ], &attackc, &minusattackc, IR ) ; 
		release.A[ 0 ] = fval( &release, dur, t );
		    smooth_setup( release.A[ 0 ], &releasec, &minusreleasec, IR ) ; 


		// **** FREQ DEVIATION: SETUP 
		fdevbase.A[ 0 ] = fval( &fdevbase, dur, t );
		  fdbm = semitones_to_mult( fdevbase.A[ 0 ]  ) ; 
		fdevpeak.A[ 0 ] = fval( &fdevpeak, dur, t );
		  fdpm = semitones_to_mult( fdevpeak.A[ 0 ] ) ; 
		fdmdiff = fdpm - fdbm ; 		    


		// **** FREQ DEVIATION: SETUP 
		fshiftbase.A[ 0 ] = fval( &fshiftbase, dur, t );
		fshiftpeak.A[ 0 ] = fval( &fshiftpeak, dur, t );
		fsdiff = fshiftpeak.A[ 0 ] - fshiftbase.A[ 0 ] ; 		    


		fdevcontrol.A[ 0 ] = fval( &fdevcontrol, dur, t );
		fdevminus = 1. - fdevcontrol.A[ 0 ] ; 


	    // ***** SIGNAL BALANCE
	    // FIND SUM OF ALL MAGNITUDES, baseampnow, and peakampnow
	    
		baseampnow = 99999999.; peakampnow = -1. * baseampnow ; 
		
	    // *****		

//*****************
// MODIFICATIONS LOOP
//*****************
		for( i = 1, j = 0; i < N; i+= 2, j++ ){


	    // FIND THE INDECES WHICH RESULT AFTER SHIFT AND TRANSPOSE OF 
	    // THE FILTER
		    // APPLY FILTER TRANSPOSE
		    // SHIFT
		    temp = (i - 1) / 2 ; 
		    temp = temp -  ( fs / fundamental ) ; 
		    // TRANSPOSE
		    temp =  temp / fm   ; 
		    i2p = temp - (float)((int) temp ) ; 
		    i1p = 1. - i2p ; 
		    i1 = 2 * (int) temp ; 
		    i2 = i1 + 2 ; 
		    
		    if( i1 < 0 ){ //UNDER THE ARRAY
			i1 = 0; i2 = i1 + 2 ; i1p = 1. ; i2p = 0. ; 
		    }
		    if( i2 > N ){ //OVER THE ARRAY
			i2 = N - 2 ; i1 = i2 - 2 ; i2p = 1. ; i1p = 0. ; 
		    }

	    // MAKE NEW AMPLITUDE FOR THIS BIN
		// FIRST MAKE INTERPOLATED FILTER AMP
		    temp = ( F[ i1 ] * i1p ) + (F[ i2 ] * i2p ) ; 

		  // MAKE NEW AMP
		    channel[i - 1] = channel[i - 1] * 
			((filtamp * temp) + sourceamp );  



	    // MAKE NEW DEVIATED FREQUENCY FOR THIS BIN
		// FIRST MAKE INTERPOLATED FILTER AMP
		    temp2 = ( Ffreq[ i1 ] * i1p ) + (Ffreq[ i2 ] * i2p ) ; 

		  // MAKE NEW DEVIATED FREQUENCY
		    
		    channel[i] = 
			((fdevminus) + (fdevcontrol.A[ 0 ] * (fdbm + (temp2 * fdmdiff)))  )
			    * 
			(channel[i] + 
			    (fdevcontrol.A[ 0 ] * (fshiftbase.A[ 0 ] + (temp2 * fsdiff)))
			 ) ; 



	}

	//****
	
    // SMOOTH THE CHANGES TO THE SPECTRUM
    smooth( channel, previous_channel, N, attackc, minusattackc, releasec, minusreleasec ) ; 
	 
	for( i = 1; i < N; i+= 2 ){

	    // SHIFT BY -a AND TRANSPOSE BY -P

	    temp = pm * (channel[i] + harmadd.A[ 0 ]) ;
		    
	    // ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
	    if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
	    else channel[i] = temp ; 
	    
	    channel[i - 1] = channel[i - 1] * gain ;  

	}
		

        synt = getthresh( channel, N, threshfac );

// ** OSCIL BANK OR OVERLAP/ADD OUT
	if ( obank ) {
	    noscbank(channel, N2, R, Nw, I, P, output);
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;
	} else {
	    unconvert( channel, buffer, N2, I, R ) ;

	    rfft( buffer, N2, INVERSE ) ;
	    overlapadd( buffer, N, Wsyn, output, Nw, on ) ;
	     shiftout( output, Nw, I, on, 0 ) ;
	
	}

	frame_count++ ; 

    // FRAMES LOOP END

    }
    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  



    fprintf(stderr,"\n\nFILDEVIATOR : RESYNTHESIS COMPLETED\n");

    if( harmadd.n != 1. ) fclose(harmadd.fp ) ;
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;
    if( ptrans.n != 1. ) fclose(ptrans.fp ) ;
    if( filter.n != 1. ) fclose(filter.fp ) ;
    if( ftrans.n != 1. ) fclose(ftrans.fp ) ;
    if( fshift.n != 1. ) fclose(fshift.fp ) ;
    if( sourcedB.n != 1. ) fclose(sourcedB.fp ) ;
    if( release.n != 1. ) fclose(release.fp ) ;
    if( attack.n != 1. ) fclose(attack.fp ) ;
    if( fdevbase.n != 1. ) fclose(fdevbase.fp ) ;
    if( fdevpeak.n != 1. ) fclose(fdevpeak.fp ) ;
    if( fshiftbase.n != 1. ) fclose(fshiftbase.fp ) ;
    if( fshiftpeak.n != 1. ) fclose(fshiftpeak.fp ) ;
    if( fdevcontrol.n != 1. ) fclose(fdevcontrol.fp ) ;


    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"filtdeviator:  fixed-spectrum, phase vocoder filter\n"
	"	    with response-correlated frequency deviation\n"
	"filtdeviator   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	    (values in brackets denote defaults)\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  \n"
	"		    2 = Blackman,  3 = Bartlett triangular [0.]\n"
	"	D:	analysis frames per second [200]\n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"

	"	P:	pitch transposition in semitones (func) [0]\n"
	"	a:	frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func) [0.] \n"
	"	B:	TRANSPOSITION/SHIFT application FLAG [0]\n"
	"		 Apply -P and -a to:\n"
	"		  source only -- prefilter (0),\n"  
	"		  or to  source and filter -- postfilter (1)\n"  
	"	A:	gain in decibels (func)[0.] \n"

	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (0. = end of file) [0.] \n"
	"	C:	resynthesis channel (1 -> ?) (0 = all) [0] \n"

	"	F:	FILTER: frequency response file \n"
	"	G:	FILTER: filtering method: \n"
	"		 0 = pass, 1 = reject (inverted response) [0] \n"

	"	Z:	FILTER: print input frequency response file\n"
	"		    analysis average to standard error (1 = yes, 0 = no) [0]\n"
	"	T:	FILTER: frequency response transposition in semitones (func) [0]\n"
	"	V:	FILTER: frequency response shifter (func) [0.] \n"
	"	S:	FILTER: source decibels floor \n"
	"		    (reduces filtered signal in proportion)(func) [0.] \n"
	"	W:	AMPLITUDE RESPONSE WARP:  index for reshaping frequency response [0.] \n"
	"		    values > 0 expand the dynamic range, \n"
	"		    values < 0 compress the dynamic range \n"



	"	     FILTER FREQUENCY RESPONSE -- SHELF EQ: (pre-processing)\n"
	"	H:	FILTER SHELF EQ: Low shelf gain in dB [0.] \n"
	"	X:	FILTER SHELF EQ: High shelf gain in dB [0.] \n"
	"	m:	FILTER SHELF EQ: Low shelf frequency in Hz [200.] \n"
	"	R:	FILTER SHELF EQ: High shelf frequency in Hz [2000.] \n"

	"	l:      envelope attack time  (func) [0.]\n"
	"	L:      envelope release time   (func) [0.]\n"

	"	k:      FREQUENCY DEVIATION: base deviation in semitones (func) [0.]\n"
	"	K:      FREQUENCY DEVIATION: peak deviation in semitones (func) [0.]\n"
	"	u:      FREQUENCY DEVIATION: base frequency shift (func) [0.]\n"
	"	U:      FREQUENCY DEVIATION: peak frequency shift (func) [0.]\n"
	"	v:	FREQUENCY RESPONSE WARP:  index for reshaping frequency response [0.] \n"
	"		    in frequency processing (frequency deviation domain)\n"
	"		    values > 0 close down response, < 0 open it up\n"
	"	O:	FREQUENCY DEVIATION: master deviation control (0 (off) - 1) (func) [1.] \n"



	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 

	"	t:	oscillator resynthesis threshold in decibels [ -96 ]\n"
	);
    exit(woof);
}



int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

