#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{


int i,j,k, jj,   i1,  i2 ;
float i1p,  i2p,  pm,  fm,  fs ; 
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag = 0,  channelout=0 ;
float P = 1.0;

float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel,  *F, *OF,   *FF ; 
int warpflag=0 ; 
float threshfac = .001,  threshfacdB=-96 ;
float releasec,  minusreleasec,  attackc,  minusattackc ; 
double ar_dB ; 
float	gain=1. ;
int limitcount=0,  bandrejecton=0 ; 
FILE *fopen();
FILE *fp;
float N_ratio,  analysis_fundamental ; 
int analysis_N,  analysis_N2 ; 

float sumofamps,  normgain ; 

int print_flag=0 ; 
int pitchflag=0; 
char ch;
// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 

float  temp,  temp2,  temp3 ;  
float getthresh();
float   IR,  dur=0.;
int beginchan,  endchan ; 

float dBnumerator ; 
float fundamental, factor,   sourceamp,  filtamp ;  


float  compthreshamp,  compthreshdB,  compamp,  compdB ; 
float  expthreshamp,  expthreshdB, expamp,  expdB ; 


float fcentroid,  scentroid,  old_scentroid,  sm ; 




char tempstring[ 128 ] ; 

// COMB FREQUENCY SHIFT ADDER
struct  func  harmadd ; 

// GAIN
struct  func  dBgain ; 

// PITCH SEMITONE TRANSPOSE
struct  func  ptrans ; 

// FILTER
struct  func  filter ; 

// FILTER SEMITONE TRANSPOSE
struct  func  ftrans ; 

// FILTER TRANSPOSE SHIFTER
struct  func  fshift ; 

//  SOURCE DECIBELS
struct  func  sourcedB ; 

//  FILTER WARPSHAPE
struct  func  warpshape ; 

//  RELEASE
struct  func  release ; 

//  ATTACK
struct  func  attack ; 

//  FILTER SMOOTHING
struct  func  octaves ; 

//  NORMALIZATION dB
struct  func  normdB ; 


//  CENTROID SHIFT CONROL
//struct  func  centroidshift ; 

#include "underflow.h"



//*****************INITIALIZE
// COMB FREQUENCY SHIFT ADDER
harmadd.L = 1. ; harmadd.n = 1. ; harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// PITCH SEMITONE TRANSPOSE
ptrans.L = 1. ; ptrans.n = 1. ; ptrans.A[ 0 ] = 0. ; 

// FILTER
filter.L = 1. ; filter.n = 0. ; filter.A[ 0 ] = 0. ; 

// FILTER SEMITONE TRANSPOSE
ftrans.L = 1. ; ftrans.n = 1. ; ftrans.A[ 0 ] = 0. ; 

// FILTER TRANSPOSE SHIFTER
fshift.L = 1. ; fshift.n = 1. ; fshift.A[ 0 ] = 0. ; 

//  SOURCE DECIBELS
sourcedB.L = 1. ; sourcedB.n = 1. ; sourcedB.A[ 0 ] = -96. ; 

//  FILTER WARPSHAPE
warpshape.L = 1. ; warpshape.n = 1. ; warpshape.A[ 0 ] = 0. ; 

//  RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 

//  ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 

//  FILTER SMOOTHING
octaves.L = 1. ; octaves.n = 1. ; octaves.A[ 0 ] = 0. ; 

//  NORMALIZATION dB
normdB.L = 1. ; normdB.n = 1. ; normdB.A[ 0 ] = -96. ; 

//  CENTROID SHIFT CONROL
//centroidshift.L = 1. ; centroidshift.n = 1. ; centroidshift.A[ 0 ] = 0. ; 


if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|w|n|M|o|P|D|t|_|=|n|I|p|i|B|g|F|b|Q|G|E|e|C|i|T|Z|l|L|V|S|H|m|X|W|c|d|s|a|A|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':   N = atoi(arg_option);
			break;
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;

	    case 'w':   window_type = atoi(arg_option) ;
			break;
	    case 'P':   strcpy(tempstring, arg_option);
			ptrans.fp = crackstring( tempstring, &ptrans ); 
			break;
	    case 'a':   strcpy(tempstring, arg_option);
			harmadd.fp = crackstring( tempstring, 
			    &harmadd );
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;

           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;



	    case 'B':   pitchflag = atoi(arg_option) ;
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

	    case 'H':   dBlow = atof(arg_option) ;
			break;
	    case 'X':   dBhi = atof(arg_option) ;
			break;
	    case 'm':   freqlow = atof(arg_option) ;
			break;
	    case 'R':   freqhi = atof(arg_option) ;
			break;

            case 'p':	quiet = atoi(arg_option) ; break;
            case 'i':	ampstatinc = atof(arg_option) ; break;
            case 'Z':	print_flag = atoi(arg_option) ; break;



	    case 'F':   strcpy(tempstring, arg_option);
			filter.fp = crackstring( tempstring, 
			    &filter );
			break;

            case 'G':	bandrejecton = atoi(arg_option) ; break;


	    case 'T':   strcpy(tempstring, arg_option);
			ftrans.fp = crackstring( tempstring, 
			    &ftrans );
			break;
	    case 'V':   strcpy(tempstring, arg_option);
			fshift.fp = crackstring( tempstring, 
			    &fshift );
			break;
	    case 'S':   strcpy(tempstring, arg_option);
			sourcedB.fp = crackstring( tempstring, 
			    &sourcedB );
			break;

	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;
	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;

	    case 'W':   strcpy(tempstring, arg_option);
			warpshape.fp = crackstring( tempstring, 
			    &warpshape );
			break;


/*
	    case 'n':   strcpy(tempstring, arg_option);
			normdB.fp = crackstring( tempstring, 
			    &normdB );
			break;
*/

/*
	    case 'o':   strcpy(tempstring, arg_option);
			centroidshift.fp = crackstring( tempstring, 
			    &centroidshift );
			break;
*/

	    case 'Q':   strcpy(tempstring, arg_option);
			octaves.fp = crackstring( tempstring, 
			    &octaves );
			break;


	    case 'c':   compthreshdB = atof(arg_option) ;
			break;
	    case 'd':   compdB = atof(arg_option) ;
			break;
	    case 'E':   expthreshdB = atof(arg_option) ;
			break;
	    case 'g':   expdB = atof(arg_option) ;
			break;




	    case 't':   threshfacdB = atof(arg_option);
			break;
	    case 's':	sflag = 1;
			break;
	    case 'h':	usage(1);
	}
    }

prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "FILTER", 69 ) ; 
prline( 69,  "-" ) ; 




    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
 
// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 
    
// ******** FILTER FILE SETUPS
if( filter.n < 1. ){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A FILTER FUNCTION. BYE.\n" ) ;
    exit(0);
}

    analysis_N = filter.n ;
    analysis_N2 = analysis_N>>1 ; 

// ******** SET N TO ANALYSIS N IF 0
    if( N <= 0 ) N = analysis_N ; 


// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 

    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
//*********************************
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    IR = (float) I / (float) R ; 
    fundamental = (float) R / (float) N ; 
    factor = (float) R / ((float) D * TWOPI) ; 
    dBnumerator = (float) pow( (double) 10.0, (double) -3.9 ) ; 
    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	
    
    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 


 //*****************
// SET UP SOME FILTER FILE VALUES
    analysis_fundamental = nyquist / (float) (analysis_N/2) ; 
    // MAKE RATIO OF ANALYSIS N TO SOURCE N FOR FILTER POSITIONING
    N_ratio = (float) analysis_N / (float) N ; 
    
//*****************
// SET UP FLAG FOR OSCIL BANK OR OVERLAP/ADD
    if( 
	(ptrans.n  != 1.) || (harmadd.n  != 1.) || 
	    (ptrans.A[0] != 0.) || (harmadd.A[0] != 0.)  ) {
	// OSC BANK
	P = 1. ; obank = 1 ;  
    }else{
	// OVERLAPP-ADD
	P = 0. ; obank = 0 ;  
    }
    
//***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 
//*****************
prbanner( "FREQUENCY RESPONSE",  69 ) ; 
pri( analysis_N,  "FREQRESPONSE: FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( analysis_fundamental, "FREQRESPONSE:     FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
//*****************

prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
pri( tfactor,  "TIME EXPANSION/CONTRACTION FACTOR" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( I,  "      INTERPOLATION SAMPLES (samples between resynthesis frames)" ) ; 
prline( 1,  "*" ) ; 
prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (in dB)" ) ; 
prline( 1,  "*" ) ; 

prp( &dBgain,  "GAIN (in dB)"  ) ; 
prp( &ptrans,  "PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &harmadd,  "FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
if( bandrejecton ){
    prt( "FILTER TYPE: ............REJECT RESPONSE" ) ;
}else{
    prt( "FILTER TYPE: ............PASS RESPONSE" ) ;
}
prp( &ftrans,  "FILTER: PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &fshift,  "FILTER: FREQUENCY SHIFT (in Hz)"  ) ; 
prp( &sourcedB,  "FILTER: SOURCE SIGNAL FLOOR (in dB)"  ) ; 
prline( 1,  "*" ) ; 
prp( &attack,  "ENVELOPE ATTACK TIME (in seconds)"  ) ; 
prp( &release,  "ENVELOPE RELEASE TIME (in seconds)"  ) ; 
prline( 1,  "*" ) ; 
prp( &warpshape, "INPUT SPECTRUM WARPSHAPE INDEX" ) ; 
prline( 1,  "*" ) ; 


prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prf( freqlow, "LOW SHELF FREQUENCY" ) ; 
prf( dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prf( freqhi, "HIGH SHELF FREQUENCY" ) ; 
prf( dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
prt( "*...........................................*" ) ;  
prline( 1,  "*" ) ; 
// *******
prf( compthreshdB,  "COMPRESSION THRESHOLD DECIBELS" ) ; 
prf( compdB,  "COMPRESSION DECIBELS" ) ; 
prf( expthreshdB,  "EXPANSION THRESHOLD DECIBELS" ) ; 
prf( expdB,  "EXPANSION DECIBELS" ) ; 
prline( 1,  "*" ) ; 
prp( &octaves, "RESPONSE SMOOTHING (Q) FACTOR IN OCTAVES" ) ; 


//***************** SET UP ARRAYS


    
    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    fvec( previous_channel, N+2 ) ;	/* previous analysis channels */

// MAKE THRESH AMP
    //threshfac = pow( (double) 10.0, (double) (threshfacdB / 20.) );	
    threshfac = dB_to_amp( threshfacdB ) ; 
    
// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 

// ALLOCATE FILTER SPACE
fvec( F,  analysis_N+2  ) ;	/* filter array */
fvec( FF,  analysis_N+2  ) ;	/* filter array */
    if( warpshape.n > 1 ) warpflag = 1 ; 

//************FIRST TIME: FILL ARRAY FROM FILE
    fillfunc( &filter, F, analysis_N  ) ;     



//*************EQ AND NORMALIZE
    if(dBlow !=  dBhi)prt("...............EQUALIZING AND NORMALIZING INPUT FREQUENCY RESPONSE....." ) ; 
    else prt("...............NORMALIZING INPUT FREQUENCY RESPONSE....." ) ;
    eq( F,  analysis_N,  dBlow,  dBhi, freqlow,  freqhi,  analysis_fundamental, 1,  0, 1 ) ; 

//************ COMPANSION
    // FIND COMPRESSION AND EXPANSION THRESHOLDS AND AMPS
    compthreshamp = dB_to_amp( compthreshdB ) ; 
    compamp = dB_to_amp( compdB ) ; 
    expthreshamp = dB_to_amp( expthreshdB ) ; 
    expamp = 1. / dB_to_amp( expdB ) ; 

    if( compthreshamp <= expthreshamp ){
	fprintf( stderr, "\n\nCOMPRESSION THRESHOLD IS BELOW EXPANSION THRESHOLD!\n\nCOMPANSION SKIPPED!\n\n" ) ;
    }else{
	if( (compamp < 1.) || (expamp > 1. ) ){
	    if( (compamp <= 1.) && (expamp >= 1.) ){
		prt( "...............USING COMPRESSION" ) ; 
 
		 compand( F, analysis_N, compthreshamp, compamp, expthreshamp, expamp  ) ;
 
	    }else{
		prf( compdB,  "COMPRESSION DECIBELS" ) ; 
		prf( expdB,  "EXPANSION DECIBELS" ) ; 
		prt( "ILLEGAL COMPRESSION/EXPANSION VALUES" ) ;
		prt( "...................NO COMPRESSION" ) ; 
	    }
	}else{
	    prt( "...................NO COMPRESSION" ) ; 
	}  
    }
    
//*********** PRINT TO TERMINAL IF DESIRED ******
    if(print_flag)tprintspec( F, analysis_N, analysis_fundamental,  print_flag) ;



    //************* MAKE THE FILTER CENTROID
//  fcentroid = find_centroid( F, analysis_N, 20., 22050., analysis_fundamental, &temp ) ;  





//************ CONVERT FREQUENCIES TO PHASE DIFFERENCES
    for(i = 1,  j = 0; i < analysis_N; i += 2,  j++) 
	F[ i ] = (F[ i ] - ((float) j * analysis_fundamental)) / factor ; 


//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 



    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
	
//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
	in += D ;
	on += I ;
	timenow( dur ) ;
	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
		  convert( buffer, channel, N2, D, R ) ;	 

	// SETUP PREVIOUS CHANNEL
	    if( !frame_count )for(i = 0; i < N; i++)
		    previous_channel[ i ] = channel[ i ] ; 







//*************************
// GET THE VALUES
//*************************


//  SHIFT, GAIN, AND TRANSPOSITION

		harmadd.A[ 0 ] =  fval( &harmadd, dur, t );
		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp( dBgain.A[ 0 ]  ) ; 	
		ptrans.A[ 0 ] = fval( &ptrans, dur, t );
		    pm = semitones_to_mult( ptrans.A[ 0 ] ) ; 


		fs = fshift.A[ 0 ] = fval( &fshift, dur, t );
		    // IF FREQ SHIFT FOR SOURCE ONLY, SUBTRACT FROM FILTER CHANGE
		    if( !pitchflag ) fs = fs - harmadd.A[ 0 ] ; 
		ftrans.A[ 0 ] = fval( &ftrans, dur, t );
		    fm = semitones_to_mult( ftrans.A[ 0 ] ) ;
		    // IF PITCH TRANSPOSITION FOR SOURCE ONLY, DIVIDE OUT OF FILTER CHANGE
		    if( !pitchflag ) fm = fm / pm ; 

		sourcedB.A[ 0 ] = fval( &sourcedB, dur, t );
		    sourceamp = dB_to_amp( sourcedB.A[ 0 ]  ) ; 	
		    filtamp = 1. - sourceamp ;  



		// FILTER WARP
		warpshape.A[ 0 ] = fval( &warpshape, dur, t );

		// ATTACK
		attack.A[ 0 ] = fval( &attack, dur, t );
		smooth_setup( attack.A[ 0 ], &attackc, &minusattackc, IR ) ;


		//RELEASE
		release.A[ 0 ] = fval( &release, dur, t );
		smooth_setup( release.A[ 0 ], &releasec, &minusreleasec, IR ) ;



		// NORMALIZATION/BALANCE GAIN DB
//		normdB.A[ 0 ] =  fval( &normdB, dur, t );

		// FILTER CENTROID SHIFT CONTROL
//		centroidshift.A[ 0 ] =  fval( &centroidshift, dur, t );


//*** MODIFICATIONS
 
 


 
 
    
    //*************WARP AND BAND REJECT
    spectmagwarp2( F, FF,   analysis_N, warpshape.A[ 0 ], 1 ) ;

    //*************** IF BAND REJECT, THEN INVERT THE RESPONSE
    if( bandrejecton ) invertresponse( FF,  analysis_N,  0  ) ; 

     //*********** SMOOTH THE SPECTRUM
	octaves.A[ 0 ] = fval( &octaves, dur, t );
    smoothspec( FF, analysis_N2, octaves.A[ 0 ], R ) ; 

 
    //********** FIND THE SUM OF THE AMPS FOR NOMALIZATION
    sumofamps = 0 ; 
    for( i = 1; i < N; i+= 2 ){
	sumofamps += channel[i - 1] ; 
    }
 
 

//*****************
// MODIFICATIONS LOOP
//*****************

    //************* MAKE THE SOURCE CENTROID
//    scentroid = find_centroid( channel, N, 20., 22050., fundamental, &old_scentroid ) ;  

    //****** MAKE THE CENTROID TRANSPOSE
//    sm = 1. + (centroidshift.A[ 0 ]  * ((scentroid / fcentroid) - 1. ) ) ; 


		for( i = 1, j = 0; i < N; i+= 2, j++ ){


//***************************************************
	    // FIND THE INDECES WHICH RESULT AFTER SHIFT AND TRANSPOSE OF 
	    // THE FILTER
		    // APPLY FILTER TRANSPOSE
		    // SHIFT
		    temp = (float) j ; // THE 0-(N/2) BIN WE ARE ON (TO BE FILTERED)
		    temp = temp * N_ratio ; // SHIFT BY RATIO OF ANALYSIS N TO SOURCE N
		    temp = temp -  ( fs / analysis_fundamental ) ; // SHIFT BY RATIO OF ANALYSIS N TO SOURCE N
		    // TRANSPOSE
		    temp =  temp / (fm)  ; // TRANSPOSE THE BIN
		    i2p = temp - (float)((int) temp ) ; // FRACTIONAL BIN VALUE
		    i1p = 1. - i2p ; // 1. - FRACTIONAL BIN VALUE
		    i1 = 2 * (int) temp ; // THE LOWER BIN AMP INDEX
		    i2 = i1 + 2 ; // THE UPPER BIN AMP INDEX
		    
		  if( i1 < 0 ){			
			//UNDER THE ARRAY
    			temp = FF[ 0 ]  ; 

		    }else if( i2 > (analysis_N - 2)  ){ 
			//OVER THE ARRAY
    			temp = FF[ analysis_N - 2 ]  ; 

		    }else{
			// IN ARRAY
			temp = ( FF[ i1 ] * i1p ) + (FF[ i2 ] * i2p ) ; 

		    }
//***************************************************
		    
		   // CHANGE AMP
			channel[i - 1] *=  ((filtamp * temp) + sourceamp );  

	}


    // FIND THE NEW SUM OF THE AMPS
    temp = 0 ; 
    for( i = 1; i < N; i+= 2 ){
	temp += channel[i - 1] ; 
    }
    
/*
    // NORMALIZE THE AMPS
    if( temp > 0. ){

	temp2 = 20. * (float) log10( (double) (sumofamps / temp) ) ;
	normgain = dB_to_amp( temp2 + normdB.A[ 0 ] ) ;  
	for( i = 1; i < N; i+= 2 ) channel[i - 1] *= normgain ; 
    }

*/	
    // SMOOTH THE CHANGES TO THE SPECTRUM
    smooth( channel, previous_channel, N, attackc, minusattackc, releasec, minusreleasec ) ; 

	for( i = 1; i < N; i+= 2 ){

	    // SHIFT BY -a AND TRANSPOSE BY -P

	    temp = pm * (channel[i] + harmadd.A[ 0 ]) ;
		    
	    // ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
	    if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
	    else channel[i] = temp ; 
	    
	    channel[i - 1] = channel[i - 1] * gain ;  

	}
		

        synt = getthresh( channel, N, threshfac );

// ** OSCIL BANK OR OVERLAP/ADD OUT
	if ( obank ) {
	    noscbank(channel, N2, R, Nw, I, P, output);
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;
	} else {
	    unconvert( channel, buffer, N2, I, R ) ;

	    rfft( buffer, N2, INVERSE ) ;
	    overlapadd( buffer, N, Wsyn, output, Nw, on ) ;
	     shiftout( output, Nw, I, on, 0 ) ;
	
	}

	frame_count++ ; 

    // FRAMES LOOP END

    }
    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  


    fprintf(stderr,"\n\nFILTER : RESYNTHESIS COMPLETED\n");


    if( harmadd.n != 1. ) fclose(harmadd.fp ) ;
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;
    if( ptrans.n != 1. ) fclose(ptrans.fp ) ;
    if( filter.n != 1. ) fclose(filter.fp ) ;
    if( ftrans.n != 1. ) fclose(ftrans.fp ) ;
    if( fshift.n != 1. ) fclose(fshift.fp ) ;
    if( sourcedB.n != 1. ) fclose(sourcedB.fp ) ;
    if( warpshape.n != 1. ) fclose(warpshape.fp ) ;
    if( release.n != 1. ) fclose(release.fp ) ;
    if( attack.n != 1. ) fclose(attack.fp ) ;
    if( octaves.n != 1. ) fclose(octaves.fp ) ;
    if( normdB.n != 1. ) fclose(normdB.fp ) ;



    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"filter:  fixed-spectrum,  phase vocoder filter\n"
	"filter   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	    (values in brackets denote defaults)\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"		    -N0 causes FFT length to be taken from response file\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  \n"
	"		    2 = Blackman,  3 = Bartlett triangular [0.]\n"
	"	D:	analysis frames per second [200]\n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"

	"	P:	pitch transposition in semitones (func) [0]\n"
	"	a:	frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func) [0.] \n"
	"	B:	TRANSPOSITION/SHIFT application FLAG [0]\n"
	"		 Apply -P and -a to:\n"
	"		  source only -- prefilter (0),\n"  
	"		  or to  source and filter -- postfilter (1)\n"  

	"	A:	gain in decibels (func)[0.] \n"

	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (0. = end of file) [0.] \n"
	"	C:	resynthesis channel (1 -> ?) (0 = all) [0] \n"

	"	F:	FILTER: frequency response file \n"
	"	G:	FILTER: filtering method: (POST everything)\n"
	"		 0 = pass, 1 = reject (inverted response) [0] \n"

	"	Z:	FREQUENCY RESPONSE PRINTOUT: high cutoff frequency in Hz [0]\n"
	"		    (0 = off)\n"


	"	T:	FILTER: frequency response transposition in semitones (func) [0]\n"
	"	V:	FILTER: frequency response shifter (func) [0.] \n"
	"	S:	FILTER: source decibels floor \n"
	"		    (reduces filtered signal in proportion)(func) [0.] \n"


	"	     FILTER FREQUENCY RESPONSE -- SHELF EQ: \n"
	"		(PRE-compression/expansion and transposition/shift)\n"
	"	H:	FILTER SHELF EQ: Low shelf gain in dB [0.] \n"
	"	X:	FILTER SHELF EQ: High shelf gain in dB [0.] \n"
	"	m:	FILTER SHELF EQ: Low shelf frequency in Hz [200.] \n"
	"	R:	FILTER SHELF EQ: High shelf frequency in Hz [2000.] \n"

	"	Z:	FILTER FREQUENCY RESPONSE: COMPRESSION/EXPANSION:\n"
	"		(POST-EQ and PRE-warp)\n"
	"	c:	compression threshold in decibels (0 to -96) [0]\n"
	"	d:	decibels of compression (0 to -96) [0]\n"
	"	E:	expansion threshold in decibels (0 to -96) [-96]\n"
	"	g:	decibels of expansion (0 to -96) [0]\n"

	"	W:	FILTER FREQUENCY RESPONSE: \n"
	"		warp index for reshaping magnitude response (func) [0.]\n"
	"		(POST-compression/expansion and transposition/shift)\n"
	"		    values > 0 expand the response's dynamic range, \n"
	"		    values < 0 compress the the response's dynamic range \n"

	"		FILTER FREQUENCY RESPONSE PROCESSING CHAIN:\n"
	"		    EQ -> COMPANDING -> WARP -> INVERSION -> SMOOTHING -> NORMALIZATION\n"

	"	Q:	FILTER FREQUENCY RESPONSE: smoothing bandwidth (in octaves) (func) [0]\n"
	"		    (The value for each peak is  replaced with the average\n"
	"		     value within the band. The bandwidth has \"octaves\" width, \n"
	"		       positioned with the peak as the center frequency.\n"
	"			 ; 0 = no averaging)\n"

	"	l:      envelope attack time  (func) [0.]\n"
	"	L:      envelope release time   (func) [0.]\n"

	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 

	"	t:	oscillator resynthesis threshold in decibels [ -96 ]\n"
	);

/*
 * 	"	o:	FILTER: CENTROID shift control (0-1) [0.] \n"
	"		    This controls the degree to which the filter centroid is\n"
	"		    shifted to align with the centroid of the source signal.\n"
	"		    1 = full shift,  0 = no shift\n" 


	"	n:	NORMALIZATION (balance)  GAIN in decibels (0 to -96) (func) [-96]\n"
	"		    0 = returns  the  signal  at every frame to its original energy \n"
	"			    level redistributed by the filter response\n"
	"		    -96 = normalization off\n"



 */




    exit(woof);





}



int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

