#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k, l,  i1,  i2, ipartial,   n, exflag, 
     NC, NC2,   np,  nf=2,  first=1  ;
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag = 0,  channelout=0 ;
float P = 1.0;
FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel,  *F,  *FT,  *SUM,  *harmony ; 
 float threshfac = .001;
float	gain=1. ;
float  temp,  temp2,  temp3,  temp4,  temp5,  temp6 ;  
float getthresh();
float peakbinamp = 0.,  avgbinamp=0.,  averagedB,  peakamp=0,  peakfreq, 
    dBedge=0,  dbdown1,  dbdown2,  percentofbins, dBrolloff ;
float fundamental ; 
int   invert_flag=0,  nbins=0,  spectmethod=0 ;
float   IR,  dur=0.;
int flag ; 
int N_limit=0 ; 
// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 
int eqnormbypassflag=0 ; 

FILE *data ; 
char datafile[ 128 ] = "EMPTY\0" ; 
char datafile2[ 128 ] = "EMPTY\0" ; 
float *PP, *domainamp, *partialamp,    fund=100.,  freqdiff,  target_gain,  SOURCE_gain,  midC,  part ; 
int method=1,  nd=0,  vb=0 ; 
float bw1,  bw2,  bw ; 
char tempstring[ 128 ] ; 

#include "underflow.h"


if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|Z|F|A|D|s|v|i|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'A':	N_limit = atoi(arg_option);
			break;

	    case 'R':	R = atoi(arg_option);
			break;


	    case 'Z':   method = atoi(arg_option) ;
			break;
	    case 'i':   invert_flag = atoi(arg_option) ;
			break;

	    case 'F':   strcpy(datafile, arg_option);
			break;

	    case 'v':	vb = atoi(arg_option) ;
			break;

	    case 'h':	usage(1);
	}
    }

//*****************
prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "FILTRESPONSEMAKER", 69 ) ; 
prline( 69,  "-" ) ; 


    midC = (220.*pow(2., (3./12.))) ; 
    freqdiff = (float) R / (float) N ; 
    nyquist = R/2.0;
    fundamental =  ((float) R / (float) N) ; 

//fprintf( stderr,  "\nN: %d, R: %d,    BASEFREQ: %f",N, R,    freqdiff ) ; 

// GET NAME OF OUTPUT FILE

/* GET OUTPUT FILE NAME */
   ofile = argv[arg_index] ; 

    /* OPEN FOR BUSINESS */

    
    ofd = open(ofile,O_RDWR,(0644));
    if(ofd < 0) {
	fprintf( stderr,  "\n\n%s DOES NOT YET EXIST. I'LL MAKE IT.\n", ofile );
	exflag = open(ofile, O_CREAT,(0644)); 
	if( exflag == -1 ){
	    bannero() ;
	    fprintf( stderr,  "\n\n I COULD NOT MAKE THE FILE:\n\n-----> %s <-------\n\n",  ofile ) ; 
	    fprintf( stderr,  "\n\n CHECK THE PATH OF YOUR FILE. ....BYE.\n\n" ) ; 
		exit( 0 ) ; 
	}
	ofd = open(ofile, O_RDWR,(0644));
    }else{
	open(ofile, O_TRUNC, (0644));
    }

//*********************************
prs( ofile, "FREQUENCY RESPONSE FUNCTION OUTPUT FILE" ) ; 
prline( 1,  "*" ) ; 
prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 
prline( 1,  "*" ) ; 
    if( invert_flag )prt( "RESPONSE MODE: REJECTION " );
    else prt( "RESPONSE MODE: PASS" ) ;
prline( 1,  "*" ) ; 
//*********************************



//fprintf( stderr,  "\n datafile = %s, datafile2 = %s  ",  datafile,  datafile2 )  ; 
if( (strcasecmp( datafile, datafile2 ) == 0)){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A DATA FILE. BYE.\n\n" ) ;
    usage(1);
}


//**************************GET DATA	
// READ IN FILTER BREAKPOINT DUPLES
// OPEN FILE
	if( (data = fopen( datafile, "r")) == NULL ){
	    fprintf( stderr, "\n%s <-- NO SUCH FILE. BYE.\n",  datafile ) ; 
	    exit(0); 
	}
// COUNT VALUES IN FILE
	k = 0 ; 
	while( fscanf( data,  " %f ",  &temp ) != EOF ) k++ ; 			

	rewind( data ) ;    
// ALLOCATE SPACE FOR FILTER BREAKPOINTS
    fvec( PP, (k + 4) ) ;	/* PARTIALS */
// COMPUTE NUMBER OF BREAKPOINTS
    np = k / 2 ;
// ABORT IF TOO FEW
    if( np < 2 ){
	prt( "NOT ENOUGH FILTER BREAKPOINTS. BYE" ) ; 
	exit( 0 ) ; 
    }
// READ IN VALUES
k = 0 ; 
for( i = 0; i < np ; i++ ){
    fprintf( stderr,  "\n" ) ;
    for( j = 0; j < 2 ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	     k++ ; 			
    }
} 
// SORT THEM
flag = 0 ; 

while( flag == 0 ){
    flag = 1 ; 
    for( i = 1,  j = 2,  k = 0; i < np ; i++,  j += 2, k += 2  ){
	if( PP[ j ] <  PP[ k ] ){
	    // SWITCH
	    temp2 = PP[ j ] ; temp3 = PP[ j + 1 ] ; 
	    PP[ j ] = PP[ k ] ; PP[ j + 1 ] = PP[ k + 1 ] ; 
	    PP[ k ] = temp2 ; PP[ k + 1 ] = temp3 ; 
	    flag = 0 ; 
	}
    } 
}


// PRINT VALUES

fprintf( stderr,  "\nFILTRESPONSEMAKER:  \n- datafile values - " ) ;
if(method == 1){
    fprintf( stderr,  "\n**************************" ) ; 
    fprintf( stderr,  "\nOctave.Pitch|Decibels    |" ) ; 
    fprintf( stderr,  "\nClass       |            |" ) ; 

}else{
    fprintf( stderr,  "\n**************************" ) ; 
    fprintf( stderr,  "\nFrequency   |Decibels    |" ) ; 
    fprintf( stderr,  "\n            |            |" ) ; 

}
    fprintf( stderr,  "\n.........................|" ) ; 


k = 0 ; 
for( i = 0; i < np ; i++ ){
    fprintf( stderr,  "\n" ) ;
    for( j = 0; j < 2 ; j++ ){
	    fprintf( stderr,  "%-12.3f|", PP[ k ]  ) ; k++ ; 			
    }
} 


    fprintf( stderr,  "\n**************************" ) ; 

// TRANSLATE TO FREQ IF NECESSARY
    if( method == 1 ){
	for( j = 0; j < (np*2) ; j += 2 ){
	    temp = (float) ((int) PP[j] ) ; // INTEGER PART
	    temp =  (( 12. * (temp - 8.)) + 
		    (100. * (PP[j] - temp)) ) / 12. ;

	    temp = midC * pow( 2., (double) temp ) ; 
	    PP[j] = temp ; 
	}
    }



// PUT O Hz IN IF ABSENT
if( PP[ 0 ] > 0.){
    // SHIFT THEM
    for( i = ((2 * np) - 1) ; i >=  0; i-- )PP[ i + 2 ] = PP[ i ] ; 
    PP[ 0 ] = 0. ; PP[ 1 ] = PP[ 3 ] ; 
    np++ ; 
}

// PUT Nyquist Hz IN IF ABSENT
if( PP[ (np - 1) * 2 ] < nyquist){
    np++ ; 
    PP[ (np - 1) * 2 ] = nyquist ; 
    PP[ ((np - 1) * 2) + 1 ] = PP[ ((np - 2) * 2) + 1 ] ; 
}


// FIND SMALLEST BREAKPOINT FREQUENCY DIFFERENCE AND AUTO ADJUST
if( N_limit > 0 ){
    temp = 99999999.; 
    for( j = 2; j < (np*2) ; j += 2 ){
	if( (PP[ j ] - PP[ j - 2 ]) < temp ) temp = (PP[ j ] - PP[ j - 2 ]) ; 
    }
    if( (temp < freqdiff) ){
	// ADJUST
	prt( "-----> FFT IS TOO SMALL FOR BREAKPOINT FREQUENCY DIFFERENCES <-----------" );
	prt( "-----> RESETTING FFT SIZE..............................." ); 
	while( (temp < freqdiff) && ( (N * 2) < N_limit) ){
	    N *= 2 ; 
	    freqdiff = (float) R / (float) N ;
	}
	pri( N,  "------> NEW FFT SIZE" ) ; 
	fundamental = (float) (R / N) ; 
	prf( fundamental, "------> NEW FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
    
    }
}

// ALLOCATE FILTER SPACE
fvec( F,  N+2  ) ;	/* filter array */

// INITIALIZE ARRAY
    for(i = 1,  j = 0;  i < N; i += 2,  j++){
	 F[i - 1] = 0 ;  // SET AMP TO ZERO
	 F[i] = (float) (j)  * freqdiff  ; // SET FREQ
    }

    
// MAKE RESPONSE
    k = 0 ;
    for( i = 1,  j = 0; i < N; i += 2,  j++ ){

	while( PP[ k + 2 ] < F[i]   ){
	    // INCREMENT TO NEXT BREAKPOINT
	    k += 2 ; 
	}
	temp = (F[i] - PP[ k ]) / (PP[ k + 2 ] - PP[ k ]) ; 
	temp3 = curve( PP[ k + 1], PP[k + 3], temp,  0. ) ; 
	F[i - 1] = dB_to_amp( temp3 ) ; 

    }

// NORMALIZE
//*************NORMALIZE THE SYNTHESIZED SPECTRUM
    normalize(  F,  N,   1.  ) ;


// FIND THE PEAK AND AVERAGE
    peakamp = 0 ; peakfreq = 0 ; avgbinamp = 0 ; 
    for( i = 1; i < N; i += 2 ){
	avgbinamp += F[ i - 1] ; 
	if( F[ i - 1] > peakamp ) {
	    peakamp = F[ i - 1] ;
	    peakfreq = F[ i ] ;  
	}
    }

    avgbinamp = avgbinamp / (float) (nbins) ; 
    averagedB = (float) (20. * log10( (double) avgbinamp )) ; 
    percentofbins = (float) nbins / (float) (N / 2) ; 



// PRINT STATS
    fprintf( stderr,  "\n\nAVERAGE BIN AMP: %f dB", averagedB ) ;  
    fprintf( stderr,  "\n\nNUMBER OF NON-ZERO BINS: %d", nbins ) ;  
    fprintf( stderr,  "\n\nPROPORTION OF NON-ZERO BINS: %f \%", percentofbins ) ;  

// INVERT FILTER IF BAND REJECT
    if( invert_flag != 0 ){
	for(i = 1; i < N; i += 2){
	    F[i - 1] = 1. - F[i - 1] ; 
	}
    }

prf( fundamental,  "FUNDAMENTAL" ) ; 

// LET'S SEE THE FILTER
    if( vb )tprintspec( F, N, fundamental,  vb ) ;

 
// WRITE RESPONSE TO stdout
    for( i = 0; i < N; i++ )write(ofd,  &F[ i ], sizeof(float) ) ;

    close(ofd) ; 

fprintf( stderr,  "\n\nNUMBER OF SYNTHESIS OUTPUT AMP/FREQ PAIRS:    %d\n",  i/2 ) ; 
    
    
    fprintf(stderr,"\nFILTRESPONSEMAKER : SYNTHESIS OF RESPONSE COMPLETED\n");
  
    fclose( data ) ; 
 
    exit( 0 ) ;
}
usage(int woof)
{
    fprintf(stderr, "%s",
	"filtresponsemaker:  frequency response synthesizer\n"
	"			(frequency gradient format)  \n"
	"			(values in brackets represent defaults)\n"
	"filtresponsemaker   [flags]  [output freqresponse file]\n"
	"	N:	FFT length [1024]\n"
	"	A:	Auto-adjust FFT size limit (0 = auto-adjust off) [0.]\n"
	"		    (In auto-adjust mode, the smallest  difference between\n"
	"		     adjacent breakpoint frequencies is used to set the FFT size, \n"
	"		    -A sets the maximum size; 0 turns auto-adjustment off.)\n"
	"	R:	sampling rate [44100]\n"
	"	F:	(ascii) DATA FILE of unordered breakpoint duples:\n"
	"		     Each represented by: \n"
	"		     (1) pitch or frequency (see data pitch format below)\n"
	"		     (2) decibels\n"
	"	Z:	DATA PITCH FORMAT: [1]\n"
	"		     0 = frequency\n"
	"		     1 = octave.pitch_class\n"
	"	i:	filter type: bandpass (0),  band reject (1) [0]\n"
	"	v:	FREQUENCY RESPONSE PRINTOUT: high cutoff frequency in Hz [0]\n"
	"		    (0 = off)\n"
	);
	exit(woof);
}

int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

