#include "globals.h"



main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,  k  ;
  int   eof = 0, obank = 0,  sflag = 0;
 float P = 1.0;
  FILE *fopen(), *fp;
char ch;
float  temp,  temp2, average, newaverage,  temp3, temp4,    old_temp=0. ,  n=0.,  
    N,  hi,  low,  diff,  newhi,  newlow,  newdiff ;  
float peakbinamp = 0.,  avgbinamp=0.,  peakamp, peakenvamp=0., limit ;
int   frame_count=0,  flag=1,  aoutflag=0,  ainflag=0 ; 
float   IR,  dur=0.,   t=0.;
char tempstring[ 128 ] ; 
FILE *fscratch,  *data,  *scalefile ; 
char scratch[ 128 ],  scalefilename[128] = "EMPTY\0"  ; 
int itty,  invflag=0,  diffmode=0 ; 
float olddiffval ; 

int scalesize=0,  scalefileflag=0 ; 

int lowflag=0,  hiflag=0,  lastflag=0 ; 

float vcount=0.,  ninc=1. ; 
int nn= 0 ;
int nv = 0 ;  
int firstv=0,  lastv=-1,  lastvflag=0 ; 
// LOW  LIMIT
float  lowlimit ; 

float filev,  oldfilev ; 
float scalesum=0.; 

//  HIGH  LIMIT
float  hilimit ; 

int lowc=0,  hic=0 ; 
int fd ; 
float temporigin ;
//float   *scale ; 
float   scale[1000] ; 

float ampthresh ; 

float feedcu=0.,  feedcum=1.,  oldval ; 
float feedcd=0.,  feedcdm=1. ; 
int transmode=-1; 

int find_data_type( ) ; 

float pitch=-99999999.,  reffreq,  log_of_2,  midC ; 

// SHAPE INDEX
struct  func  shape ; 

// LOW  BOUND
struct  func  lowbound ; 

//  HIGH  BOUND
struct  func  hibound ; 


//  MULTIPLY
struct  func  multiply ; 

//  DIVIDE
struct  func  divide ; 

//  ADD
struct  func  adder ; 

//  INVERSE NUMERATOR
struct  func  inverse ; 

//  SCALE ORIGIN
struct  func  origin ; 

//  SCALE QUANTIZATION
struct  func  force ; 

//*****************INITIALIZE
// SHAPE INDEX
shape.L = 1. ; shape.n = 1. ; shape.A[ 0 ] = 0. ; 


// LOW  BOUND
lowbound.L = 1. ; lowbound.n = 0. ; lowbound.A[ 0 ] = 0. ; 

//  HIGH  BOUND
hibound.L = 1. ; hibound.n = 0. ; hibound.A[ 0 ] = 0. ; 

//    MULTIPLY
multiply.L = 1. ; multiply.n = 1. ; multiply.A[ 0 ] = 1. ; 

//  ADD
adder.L = 1. ; adder.n = 1. ; adder.A[ 0 ] = 0. ; 

//    DIVIDE
divide.L = 1. ; divide.n = 1. ; divide.A[ 0 ] = 1. ; 

//    INVERSE NUMERATOR
inverse.L = 1. ; inverse.n = 1. ; inverse.A[ 0 ] = 1. ; 

//    SCALE ORIGIN
origin.L = 1. ; origin.n = 1. ; origin.A[ 0 ] = 0. ; 

//    SCALE QUANTIZATION
force.L = 1. ; force.n = 1. ; force.A[ 0 ] = 1. ; 

srandom(time(0)); 

//   if (isatty(0))
//	usage(1);
    while( (ch= crack( argc, argv, "b|B|I|t|T|Q|R|A|f|d|F|O|S|x|X|y|Y|P|W|A|a|M|D|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'b':   strcpy(tempstring, arg_option);
			lowbound.fp = crackstring( tempstring, 
			    &lowbound );
			break ; 
	    case 'B':   strcpy(tempstring, arg_option);
			hibound.fp = crackstring( tempstring, 
			    &hibound );
			break ; 

	    case 'y':   strcpy(tempstring, arg_option);
			lowlimit = atof(arg_option) ; lowflag=1;
			break ; 
	    case 'Y':   strcpy(tempstring, arg_option);
			hilimit = atof(arg_option) ;  hiflag=1;
			break ; 

	    case 'x':   strcpy(tempstring, arg_option);
			firstv = atoi(arg_option) - 1 ;
			if( firstv < 0 ) firstv = 0 ; 
			break ; 
	    case 'X':   strcpy(tempstring, arg_option);
			lastv = atof(arg_option) ;
			lastvflag = 1 ; 
			break ; 

	    case 'W':   strcpy(tempstring, arg_option);
			shape.fp = crackstring( tempstring, 
			    &shape );
			break;
	    case 'M':   strcpy(tempstring, arg_option);
			multiply.fp = crackstring( tempstring, 
			    &multiply );
			break;
	    case 'D':   strcpy(tempstring, arg_option);
			divide.fp = crackstring( tempstring, 
			    &divide );
			break;
	    case 'T':   strcpy(tempstring, arg_option);
			adder.fp = crackstring( tempstring, 
			    &adder );
			break;
	    case 'I':   strcpy(tempstring, arg_option);
			inverse.fp = crackstring( tempstring, 
			    &inverse );
			invflag = 1 ; 
			break;
	    case 't':   transmode = atoi(arg_option) ;
			break;
	    case 'd':   diffmode = atoi(arg_option) ; ;
			break;
	    case 'f':   feedcu = atof(arg_option) ;
			break;

	    case 'F':   feedcd = atof(arg_option) ;
			break;

	    case 'P':   pitch = atof(arg_option) ;
			break;

	    case 'S':   strcpy(scalefilename, arg_option);
			scalefileflag = 1 ; 
			break;

	    case 'O':   strcpy(tempstring, arg_option);
			origin.fp = crackstring( tempstring, 
			    &origin );
			break;
	    
	    case 'Q':   strcpy(tempstring, arg_option);
			force.fp = crackstring( tempstring, 
			    &force );
			break;
	    
	    case 'R':   ninc = atof(arg_option) ;
			break;

	    case 'A':   aoutflag = 1 ;
			break;
	    case 'a':   ainflag = 1 ;
			break;
	    case 'h':	usage(1);
	}
    }

    itty = isatty(0);		/* 0 == stdin */


//


if( (lastvflag == 1) && (lastv <= firstv) ){
    prt( "\n\nILLEGAL VALUE RANGE. CHECK YOUR -x and -X FLAGS.\n\n" ) ; 
    exit( 0 ) ; 
}
if( (lastvflag == 1) && ((lastv - firstv) < 2) ){
    prt( "\n\nNOT ENOUGH VALUES IN YOUR X RANGE. CHECK YOUR -x and -X FLAGS.\n\n" ) ; 
    exit( 0 ) ; 
}

//fprintf( stderr, "\nOUTPUT NUMBER %d",  isatty(1) ) ; 

if( transmode > 3 ){
    prt( "\n\nILLEGAL TRANSLATION CODE.\n\n" ) ; 
    exit( 0 ) ; 
}

 log_of_2 = (float) log10( (double) 2.0 ) ; 
midC = (float) (220.* pow(2., (3./12.))) ;
feedcum = 1. - feedcu ; 
feedcdm = 1. - feedcd ; 

    ampthresh = (float) pow( 10.,  (double) (-96. / 20.) ) ;
			
    if( ninc > 0. ) ninc = 1. / ninc ; 
    else{
	prt( "\n\nILLEGAL RESAMPLE PROPORTION!\n\n" ) ; exit(0) ; 
    }
if( (lowflag == 1) && (hiflag == 1) ){
    if( lowlimit > hilimit ){
	prf( lowlimit,  "LOW LIMIT" ) ; 
	prf( hilimit,  "HIGH LIMIT" ) ; 
	prt( "YOUR HIGH LIMIT IS BELOW YOUR LOW LIMIT." ) ; 
	exit( 0 ) ; 
    }
}


if( (transmode == 2) || (transmode == 3) ){
    if( pitch == -99999999. ){ 
	prt( " YOU MUST SUPPLY A REFERENCE FREQUENCY OR PITCH WITH THIS TRANSLATION." ) ; 
	exit( 0 ) ; 
    }
    
    if( pitch <= 12.0 ){
	    // CONVERT TO FREQ
    		    temp = (float) ((int) pitch ) ; // INTEGER PART
		     temp =  (( 12. * (temp - 8.)) + (100. * (pitch - temp)) ) / 12. ;
		    reffreq = midC * pow( 2., (double) temp ) ; 
    }else{
	// IT's A FREQ
	reffreq = pitch ; 
    }
}


if(lowbound.n == 0. &&  hibound.n == 0. ) flag = 0 ; 

if( ( (lowbound.n == 0.)  &&  (hibound.n != 0.)  ) 
	|| ( (lowbound.n != 0.)  &&  (hibound.n == 0.)  ) ){
	    fprintf( stderr, "\nYOU MUST SPECIFY BOTH -b and -B. BYE.\n" ) ; 
	exit(0); 
	}
	
	
// SCALE
    
//**************************GET DATA	
// READ IN SCALE FILE
if( scalefileflag != 0 ){
    // THERE IS A SCALE

    // OPEN FILE
	if( (scalefile = fopen( scalefilename, "r")) == NULL ){
	    fprintf( stderr, "\n%s <-- NO SUCH FILE. BYE.\n",  scalefilename ) ; 
	    exit(0); 
	}
    // COUNT VALUES IN FILE
	k = 0 ; 
	while( fscanf( scalefile,  " %f ",  &temp ) != EOF ) k++ ;
	scalesize = k + 1 ;  			
//pri( k,  "k SCALE VALUES" ) ; 
	rewind( scalefile ) ;    

    // ALLOCATE SPACE FOR SCALE VALUES
//    fvec( scale, k ) ;	/* SCALE */
    // READ IN VALUES

    k = 1 ;
    scale[0] = 0. ;  
    while( fscanf( scalefile,  " %f ",  &scale[ k ] ) != EOF ){
	scale[ k ] += scale[k - 1] ; k++ ; 			
    }


    // FIND SCALE SIZE
    scalesum = scale[scalesize - 1] ; 


    

}    
 

       
//******************

	
	
// IF DATA FROM INPUT FILE, THEN OPEN
if( itty ){

//pri( arg_index,  "arg_index" ) ; 

    if( argc == arg_index ){
	fprintf( stderr,  "\nNO INPUT OR INPUT FILE.\n\n" ) ;
	usage(1);
    }
    if( (data = fopen( argv[ arg_index ], "r")) == NULL ){
	    fprintf( stderr, "\n%s <-- NO SUCH FILE. BYE.\n",  argv[ arg_index ] ) ; 
	    exit(0); 
    }
}else{

    data = stdin ; 
}



 
// MAKE /tmp ENVELOPE SCRATCH SPACE
// MAKE UNIQUE NAME
    fd = 1 ; 
    while( fd >= 0 ){
	sprintf( scratch, "/tmp/envelope.%d", (int)(random()) ) ;
	fd = open(scratch,O_RDWR,(0644));

    }
    
// OPEN IT

    fscratch = fopen( scratch, "w" ); 



// 

    average = 0 ; 
    hi = -FLT_MAX ; 
    low = FLT_MAX ; 
    nn = 0 ; 	
    while ( !eof ) {




      if( !ainflag ){


 	if( fread( &temp, sizeof(float) , 1, data ) == 0 ){
	     eof = 1 ; 

	} else {


	    if( (nn >= (int) firstv) &&
		( ( (lastvflag == 0)  ) ||
		 ( (lastvflag == 1) && (nn < (int)lastv) ) ) 
		    ){

		// LIMIT
		if( lowflag == 1 ){
		    if( temp < lowlimit ){ temp = lowlimit ; lowc++ ; }
	        }
		if( hiflag == 1 ){
		    if( temp > hilimit ) { temp = hilimit ; hic++ ; }
		}

		n += 1. ; 			    
		if( temp > hi ) hi = temp ; 
		if( temp < low ) low = temp ; 
		average += temp ; 
		fwrite( &temp, sizeof(float), 1, fscratch );
	    }
	    nn++ ; 
	}
      }else{
	if( fscanf( data, " %f" , &temp ) <= 0 ){
	     eof = 1 ; 
	} else {



	    if( (nn >= (int) firstv) &&
		( ( (lastvflag == 0)  ) ||
		 ( (lastvflag == 1) && (nn < (int)lastv) ) ) 
		    ){

		// LIMIT
		if( lowflag == 1 ){
		    if( temp < lowlimit ){
			temp = lowlimit ; lowc++ ; 
		    }
	        }
		if( hiflag == 1 ){
		    if( temp > hilimit ){
			temp = hilimit ; hic++ ; 
		    }
		}


		    //fprintf( stderr,  "\n->%f",  temp ) ;
		n += 1. ; 			    
		if( temp > hi ) hi = temp ; 
		if( temp < low ) low = temp ; 
		average += temp ; 
		fwrite( &temp, sizeof(float), 1, fscratch );
	    }
	    nn++ ; 
	}
      }
    } 


if( flag == 0 ){
   lowbound.A[ 0 ] = low ; lowbound.n = 1. ;
   hibound.A[ 0 ] = hi ; hibound.n = 1. ;
}

   diff = hi - low ; 
    N = n - 1. ;

    fclose( fscratch ) ; 
    
    if( n < 2. ){
	fprintf(stderr," \nCANNOT RESHAPE ONE INPUT VALUE. BYE.\n\n" ) ; 
	exit( 0 ); 
    }


    average = average / (float) n ; 
    prbanner( "RESHAPE", 69 ) ;    
    prline( 69, "*" ) ; 
    if( lowflag == 1 ){
	prf( lowlimit,  "LOW LIMIT" ) ; 
	prf( ((float) lowc / (float) (N + 1)),  "PROPORTION OF CLIPPED LOW LIMIT VALUES" ) ; 
	pri( lowc,  "NUMBER OF LOW CLIPPED VALUES" ) ; 
	prline( 69, "." ) ; 
    }
    if( hiflag == 1 ){
	prf( hilimit,  "HIGH LIMIT" ) ; 
	prf( ((float) hic / (float) (N + 1)),  "PROPORTION OF CLIPPED HIGH LIMIT VALUES" ) ; 
	pri( hic,  "NUMBER OF HIGH CLIPPED VALUES" ) ; 
	prline( 69, "." ) ; 
    }

 

    prbanner( "INPUT FUNCTION STATISTICS ", 69 ) ;    


   pri( (int)n,  "NUMBER OF VALUES" ) ; 
	prline( 69, "-" ) ; 
     fprintf( stderr, "\nLOW          HIGH         RANGE        AVERAGE" ) ; 
	prline( 69, "." ) ; 
    fprintf( stderr, "\n%f     %f     %f     %f",low,  hi,  diff,  average ) ; 

    if(( flag != 0 ) || (shape.A[ 0 ] != 0.) || (shape.n != 1.) || 
	  (multiply.A[ 0 ] != 1.) || (multiply.n != 1.) || 
	  (divide.A[ 0 ] != 1.) || (divide.n != 1.) || invflag || 
	  (adder.A[ 0 ] != 0.) || (adder.n != 1.) || 
	  ( scalefileflag != 0 ) || ( feedcu > 0. ) || ( feedcd > 0. ) ||
	  (ninc != 1.) )
	prbanner( "PROCESSING PARAMETERS", 69 ) ;    

    if( flag != 0 ){
	prp(&lowbound, "RANGE: NEW BASE" ) ; 
	prp(&hibound,	"RANGE: NEW PEAK" ) ; 
    }

    if( (shape.A[ 0 ] != 0.) || (shape.n != 1.) )
	prp(&shape, "WARP SHAPE INDEX" ) ; 
    if( (multiply.A[ 0 ] != 1.) || (multiply.n != 1.) )
	prp(&multiply, "MULTIPLIER" ) ; 
    if( (divide.A[ 0 ] != 1.) || (divide.n != 1.) )
	prp(&divide, "DIVISOR" ) ; 
    if( (adder.A[ 0 ] != 0.) || (adder.n != 1.) )
	prp(&adder, "ADDER" ) ; 

    if(invflag )
	prp(&inverse, "INVERSE NUMERATOR" ) ; 
    
    if(diffmode == 1 )
	prt( "USING DIFFERENCE MODE" ) ; 
    if(diffmode == 2 )
	prt( "USING DIFFERENCE MODE, ABSOLUTE VALUE" ) ; 

    if( scalefileflag != 0 ){
	// SCALE
	prp( &origin,  "SCALE ORIGIN" ) ;
	prp( &force,  "(0-1) SCALE QUANTIZATION LEVEL" ) ;  
	fprintf( stderr, "\nSCALE INTERVALS: \n" ) ; 

	k = 0 ; 
	rewind( scalefile ) ;    
	while( fscanf( scalefile,  " %f ",  &temp ) != EOF ){ 
	    fprintf( stderr, "%f ",  temp ) ; k++ ; 
	    if( k == 7 ){
		fprintf( stderr, "\n" ) ; k = 0 ; 
	    }
	}
	fprintf( stderr, "\n" ) ; 
    }


    if( feedcu > 0. )
	prf( feedcu,  "POSITIVE SLOPE FEEDBACK COEFFICIENT" ) ; 
    if( feedcd > 0. )
	prf( feedcd,  "NEGATIVE SLOPE FEEDBACK COEFFICIENT" ) ; 
    
    
//********************************* NOW OPEN,AND RESHAPE
    newaverage = 0 ; 
    newhi = -FLT_MAX ; 
    newlow = FLT_MAX ; 	
    fscratch = fopen( scratch, "r" ); 
    eof = 0 ; 
    N = n - 1. ;
    n = 0. ;  
      
    prt( "\n" ) ; 
 

    while ( !eof ){
	if( fread( &filev, sizeof(float) , 1, fscratch ) == 0 ) eof = 1; 
 
 	    // INCREMENT THE VALUE
	    if( vcount == 0. )oldfilev = filev ; 
	    if( eof == 1 ){
		// LAST: MAKE THEM EQUAL
		filev = oldfilev ; 
		lastflag = 1 ; 
	    }	
	    while( (n <  vcount) || (lastflag == 1) ){	
		
		if( lastflag == 1){
		    temp = filev ;
		    n = N ; 
//prt("LAST ONE" ) ; 
		}else{

		    // MAKE THE temp VALUE ; 
		    // FRAC PART
		    temp4 = n - (float) ((int) n ) ; 
//prf( temp4,  "temp4" ) ; 
//prf( n,  "n" ) ; 
		    temp = oldfilev + temp4 *  (filev - oldfilev) ; 
//prf( filev,  "filev" ) ; 
//prf( oldfilev,  "oldfilev" ) ; 
		}

		


		lowbound.A[ 0 ] = fval( &lowbound, N, n );
		hibound.A[ 0 ] = fval( &hibound, N, n );
		
		shape.A[ 0 ] = fval( &shape, N, n );

		multiply.A[ 0 ] = fval( &multiply, N, n );
		divide.A[ 0 ] = fval( &divide, N, n );

		adder.A[ 0 ] = fval( &adder, N, n );

		inverse.A[ 0 ] = fval( &inverse, N, n );

		origin.A[ 0 ] = fval( &origin, N, n );

		force.A[ 0 ] = fval( &force, N, n );


		if( diff == 0. ){
		    // NO RANGE
		    temp = lowbound.A[ 0 ] ; 
		}else{
		    // RANGE
		    temp = (temp - low) / diff ; 
		    temp = curve(lowbound.A[ 0 ], hibound.A[ 0 ], temp,  shape.A[ 0 ]  );
		}

		    temp = ( multiply.A[ 0 ] /  divide.A[ 0 ] ) * temp ; 

		    temp = adder.A[ 0 ] +  temp ; 

		// INVERT IF...
		if( invflag )
		    if( temp != 0. ) temp = inverse.A[ 0 ] / temp ; 
		    else prt( "CANNOT DIVIDE BY ZERO!!" ) ; 
		

		// DIFFERENCE MODE
		if( diffmode ){
		    if( n == 0 ){
			// FIRST VALUE
			olddiffval = temp ; 
			temp = 0. ; 
		    }else{ 
			// OTHERS
			temp2 = temp ; 
			temp = temp - olddiffval ; 
			if( diffmode == 2 ){
			    if( temp < 0. ) temp = temp * -1. ; 
			}
			olddiffval = temp2 ; 
		    }

		}

		if( scalefileflag != 0 ){
		    // USE SCALE

		    temporigin = origin.A[ 0 ]  ; 
		    while( temporigin > temp ) temporigin -= scalesum ;
		    while( (temp - temporigin) >= scalesum ) 
			temporigin += scalesum ; 
		    temp2 = (float) ((int) ((temp - temporigin) / scalesum)) ;
		    // PARTIAL SCALE ABOVE TONIC
		    temp3 = temp - temporigin + (scalesum * temp2) ; 
		    // STEP THROUGH SCALE AND FIND POSITION
		    k = 0 ; 


		    while( temp3 >= scale[k] )k++ ;

		    temp4 = 
			(temp3 -  scale[k - 1]) / (scale[k] - scale[k - 1]) ; 

		    if( temp4 < .5 ){
			// LOWER
			temp -= (force.A[ 0 ] * (temp3 - scale[k - 1])) ; 
		    }else{
			// UPPER
			temp += (force.A[ 0 ] * (scale[k] - temp3)) ; 
		    }		       
		}



		// LOWPASS SMOOTH
		if( n > 0 ){
		    if( temp > oldval ){
			// RISING SIGNAL
		     temp = feedcum * temp + feedcu * oldval ;
		    }else{
			// DECAYING
		     temp = feedcdm * temp + feedcd * oldval ;
		    }
		 
		} 
		oldval = temp ; 


		// TRANSLATE VALUE
		if( transmode != -1 ){
		    if( transmode == 0 ){
			// AMP TO DB
			if( temp > ampthresh )
			    temp = 20. * (float) log10( (double) temp ) ;
			else temp = -96. ;   
		    }else if( transmode == 1 ){
			// DB TO AMP
			dB_to_amp( temp ) ; 
		    }else if( (transmode == 2) || (transmode == 3) ){
			// FREQ TO SEMITONES OF DEVIATION
			temp = temp / reffreq ; 
			// CONVERT MULTIPLIER TO SEMITONES OF DEVIATION
			temp = 12. *  (float) (((float) log10( (double) temp)) / log_of_2 ) ;  
			if(transmode == 3) temp = temp * -1. ; 
		    }
		}

		// STATISTICS
		if( temp > newhi ) newhi = temp ; 
		if( temp < newlow ) newlow = temp ; 
		newaverage += temp ; 


		// OUTPUT THE VALUE AS FLOATS OR ASCII
		if( aoutflag ){
		    // ASCII
		    if( n == 0 )prt( "(OUTPUT ON)\n" ) ; 
		    fprintf( stdout,  "%f\n",  temp ) ; 
		}else if( isatty(1) != 1 ){
		    if( n == 0 )prt( "(OUTPUT ON)\n" ) ; 
		    // FLOATS TO REDIRECTED STDOUT
		    fwrite( &temp, sizeof(float), 1, stdout );
		}else{
		    if( n == 0 )prt( "(OUTPUT OFF)\n" ) ; 
		}

	    	nv++ ; 

		// INCREMENT POSITION IN VALUES
		n = n +  ninc ;

		if( lastflag == 1 ) {
		    lastflag = 0 ; 
		    vcount = N ; 
		}
	   }

	   vcount++ ; 
	   // PUT CURRENT IN OLD
	   oldfilev = filev ; 
    
    }
	    newaverage = newaverage / (float) nv ; 
	        newdiff = newhi - newlow ; 


if( (newlow != low) ||  (newhi != hi) || (newdiff != diff) || (newaverage != average)
	|| (nv != (int) (N + 1.) ) ){
	 prbanner( "OUTPUT FUNCTION STATISTICS", 69 ) ;    


    pri( (int)nv,  "NUMBER OF VALUES" ) ; 
	prline( 69, "-" ) ; 
     fprintf( stderr, "\nLOW          HIGH         RANGE        AVERAGE" ) ; 
	prline( 69, "." ) ; 
    fprintf( stderr, "\n%f     %f     %f     %f",newlow,  newhi,  newdiff,  newaverage ) ; 


    
    prline( 69, "=" ) ; 
}    
    prt( "\n" ) ; 

    if( shape.n != 1. ) fclose(shape.fp ) ;
    if( lowbound.n != 1. ) fclose(lowbound.fp ) ;
    if( hibound.n != 1. ) fclose(hibound.fp ) ;
    if( multiply.n != 1. ) fclose(multiply.fp ) ;
    if( adder.n != 1. ) fclose(adder.fp ) ;
    if( divide.n != 1. ) fclose(divide.fp ) ;
    if( inverse.n != 1. ) fclose(inverse.fp ) ;
    if( origin.n != 1. ) fclose(origin.fp ) ;
    if( force.n != 1. ) fclose(force.fp ) ;


    fclose( fscratch ) ;
    fclose( data ) ;
    sprintf( tempstring, "rm %s\0", scratch );   
    system( tempstring ) ;   	

    exit( 0 ) ; 
}



usage(woof)
{
    fprintf(stderr, "%s",
	"reshape:  function reshaper\n"
	"reshape   [flags] <input_file>  (or)\n"
	"   |  reshape [flags] \n\n"
	"   Reshape processes the stream of input values in 11 steps.\n\n"
	"   1.  Input values in range and limit if outside of the specified limits.\n"
	"   2.  Resample value stream. \n"
	"   3.  Fit the stream of values into the new range.\n"
	"   4.  Warp the values towards the upper or lower boundary of that range.\n"
	"   5.  Amplify or attenuate the magnitude by the multiplier/divisor values.\n"
	"   6.  Transpose the value by the adder values.\n"
	"   7.  Invert the values.\n"
	"   8.	Replace with difference of values.\n"
	"   9.  Quantize the values using the scale filter.\n"
	"   10.  Smooth the values with a lowpass filter.\n"
	"   11.  Translate the values according to the specified code.\n\n"
	"	    (bracketed values indicate defaults)\n"
	"	    (Parameters with (func) can be controlled with function files.)\n\n" 
	"	    (1) LIMITS\n"
	"	y:	lower limit [no limiting]\n"
	"	Y:	upper limit [no limiting]\n"
	"	x:	first numbered value (1 through total) [1]\n"
	"	X:	last numbered value [total]\n"
	"	R:  (2)	RESAMPLE proportion [1.]\n"
	"		    (Values  > 1 invoke interpolation\n"
	"		     Values  < 1 cause sampling decimation)\n"
	"	    (3) NEW RANGE\n"
	"	b:	new range BASE value (func) [old lower boundary]\n"
	"	B:	new range PEAK value (func) [old upper boundary]\n"
	"		    (You must use both -b and -B)\n"
	"	W:  (4) WARP INDEX (func) [0]\n"
	"		   value of 0: no warp\n"
	"		   values > 0 warp distribution towards lower limit (-b)\n"
	"		   values < 0 warp distribution towards upper limit (-B)\n"
	"	M:  (5) MULTIPLIER (func) [1.]\n"
	"	D:	 DIVISOR (func) [1.]\n"
	"		    (value = reshaped-value *  M / D)\n"
	"	T:  (6) ADDER (func) [0.]\n"
	"		    (value = reshaped-value + A)\n"
	"	I:  (7) INVERSE NUMERATOR  [off]\n"
	"		    (value = I / value)\n"
	"	d:  (8) DIFFERENCE   [0]\n"
	"		    (value[n] = value[n] - value[n - 1]\n"
	"		    0 = off,  1 = difference, 2 = absolute value of difference\n"
	"	    (9) SCALE:\n"
	"	S:	scale FILE: text file of scale intervals \n"
	"	O:	scale ORIGIN (func) [0.]\n"
	"	Q:	scale QUANTIZATION: 0 = no quantization by scale\n"
	"		    1 = full scale qunatization (func) [1.]\n"
	"	    (10) COEFFICIENT(S) for lowpass smoothing filter [0.]\n"
	"	f:	COEFFICIENT for positive slope signal [0.]\n"
	"	F:	COEFFICIENT for negative slope signal [0.]\n"
	"		    Where c = feedback coefficient\n"
	"		    y(n) = (1. - c) * x(n) + c * y(n - 1)\n"
	"		    If x(n) > y(n-1) then c = \"-f\",  else c = \"-F\"\n"
	"	t:  (11) TRANSLATION CODE:[no translation]\n"
	"		    0 = amplitude to dB\n"
	"		    1 = dB to amplitude\n"
	"		    2 = frequency to semitones of deviation\n"
	"			(-P reference freq/pitch required with -T2)\n"
	"		    3 = frequency to semitones of correction\n"
	"			(-P reference freq/pitch required with -T3)\n"
	"	P:	REFERENCE frequency or pitch\n"
	"		    (Values <= 12.0 will be interpreted as\n"
	"		     octave.pitchclass notation.)\n"
	"	a:	ASCII INPUT [floats]\n"
	"	A:	ASCII OUTPUT [floats]\n"
	);
    exit(woof);
}

int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

